/**
 * 
 */
package es.postigo.action;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.postigo.delegate.InventarioDelegate;
import es.postigo.delegate.ProductoDelegate;
import es.postigo.dto.Inventario;
import es.postigo.dto.Producto;
import es.postigo.dto.User;
import es.postigo.exceptions.ApplicationCoreException;
import es.postigo.exceptions.ApplicationException;
import es.postigo.struts.forms.FormularioMAP;

/**
 * @author informatica4
 *
 */
public class AltaProductoAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        
		String lStrResult = "ok";
		
		/**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
		
		FormularioMAP lObjFormulario = (FormularioMAP) form;
        
        // Extraemos los datos del formulario   
        Producto lObjProducto = new Producto(); 
        if(!"".equals((String)lObjFormulario.getValue("DESCRIPCION")) && (String)lObjFormulario.getValue("DESCRIPCION")!= null && !"".equals((String)lObjFormulario.getValue("CANTIDAD")) && (String)lObjFormulario.getValue("CANTIDAD")!= null){
	        String lStrDescripcion = (String) lObjFormulario.getValue("DESCRIPCION");
	        String lStrLote = (String) lObjFormulario.getValue("LOTE");
	        if(lObjFormulario.getValue("CANTIDAD")!= null && lObjFormulario.getValue("CANTIDAD") != ""){
	        	int lIntCantidad = Integer.valueOf((String) lObjFormulario.getValue("CANTIDAD"));
	        	lObjProducto.setCantidad(lIntCantidad); 
        	}
	        if(lObjFormulario.getValue("STOCKMIN")!= null && lObjFormulario.getValue("STOCKMIN") != ""){
	        	int lIntStockMin = Integer.valueOf((String) lObjFormulario.getValue("STOCKMIN"));
	        	lObjProducto.setStockMin(lIntStockMin); 
        	}
	        if(lObjFormulario.getValue("CODIGO_COMPRAS")!= null && lObjFormulario.getValue("CODIGO_COMPRAS") != ""){
	        	String lStrCodigoCompras = (String) lObjFormulario.getValue("CODIGO_COMPRAS");
	        	lObjProducto.setCodigoCompras(lStrCodigoCompras); 
        	}
	        if(lObjFormulario.getValue("UNIDADES")!= null && lObjFormulario.getValue("UNIDADES") != ""){
	        	String lStrUnidades = (String) lObjFormulario.getValue("UNIDADES");
	        	lObjProducto.setUnidades(lStrUnidades); 
        	}
	        
	        String lStrCodigoEAN = (String) lObjFormulario.getValue("CODIGOEAN");
	        lObjProducto.setDescripcion(lStrDescripcion);
	        lObjProducto.setLote(lStrLote);
	        
        }
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	ProductoDelegate productoDelegate = new ProductoDelegate();		
			if(lObjProducto != null && lObjProducto.getDescripcion()!= null && lObjFormulario.getValue("CANTIDAD")!= null){
				
				/* Convertir Check's*/
				convertirChecks(lObjProducto,lObjFormulario);	
				
				if(lObjProducto.getLote() != null && lObjFormulario.getValue("CANTIDAD")!= null && !"".equals(lObjFormulario.getValue("CANTIDAD"))){
					//productoDelegate.insert(lObjProducto);
					
					/**Si hemos aadido alguna ubicacion externa generamos automaticamente la entrada del producto*/
					if(lObjFormulario.getValue("UBICACION")!= null && lObjFormulario.getValue("UBICACION") != ""){
						String lStrUbicacion = (String) lObjFormulario.getValue("UBICACION");
						productoDelegate.insert(lObjProducto, lStrUbicacion);
					}
					else productoDelegate.insert(lObjProducto);
					limpiarForm(lObjFormulario);
					
					/**Obtenemos el codigo del producto recien insertado para mandar al usuario a la ficha del producto*/
					lObjProducto.setCodigo(productoDelegate.obtenerUltimoElementoInsertado());
					
					lStrResult = "SUCCESS";
					response.sendRedirect("fichaProducto.do?CODIGO="+lObjProducto.getCodigo());
				}else{
					limpiarForm(lObjFormulario);			
					lStrResult = "ERROR";
				}
			}
		} catch (ApplicationException e) {
			limpiarForm(lObjFormulario);			
			lStrResult = "ERROR";
			e.printStackTrace();
		} catch (Throwable e) {			
			limpiarForm(lObjFormulario);			
			lStrResult = "ERROR";
			e.printStackTrace();
		}
          
        request.setAttribute("producto", lObjProducto);
        request.setAttribute("codigo", lObjProducto.getCodigo());
        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
        
        return mapping.findForward(lStrResult);
    }
	
	public void limpiarForm(FormularioMAP lObjFormulario){
		/**Limpiamos los valores del Form*/
		lObjFormulario.setValue("CODIGO","");
		lObjFormulario.setValue("CODIGOEAN","");
		lObjFormulario.setValue("CODIGO_COMPRAS","");
        lObjFormulario.setValue("DESCRIPCION","");
        lObjFormulario.setValue("LOTE","");
        lObjFormulario.setValue("CANTIDAD","");
        lObjFormulario.setValue("UNIDADES","");
        lObjFormulario.setValue("UBICACION","");
        /***/
	}
	
	public void insertLocal(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception {
		
		aStrForward="exito";		
		
		System.out.println("insert :)");
	}
	
	/**
	 * Funcin que convierte el chek Lote
	 * @param pObjDTO
	 * @param pObjFormulario
	 * @throws Exception
	 * @throws ApplicationCoreException
	 */
	private void convertirChecks(Producto pObjDTO,FormularioMAP pObjFormulario) throws Exception, ApplicationException {
        String lStrLote = null;
        lStrLote = aObjAux.convierteCheck((String) pObjFormulario.getValue("LOTE"));
        pObjDTO.setLote(lStrLote);
	}
}
