/**
 * 
 */
package es.postigo.action;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.postigo.delegate.ProductoDelegate;
import es.postigo.dto.Producto;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.ProductoDaoException;
import es.postigo.struts.forms.FormularioMAP;

/**
 * @author informatica4
 *
 */
public class FichaProductoAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        
		String lStrResult = "ok";
		
		/**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
		
		FormularioMAP lObjFormulario = (FormularioMAP) form;
		Producto lObjProducto = new Producto();
		
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	ProductoDelegate productoDelegate = new ProductoDelegate();	
        	if(request.getParameter("CODIGO") != null && request.getParameter("CODIGO")!=null){
				lObjProducto = productoDelegate.getRegistro(request.getParameter("CODIGO"));
			}
        	if(request.getParameter("metodo") != null && request.getParameter("metodo")!=null){
				String lStrMetodo = request.getParameter("metodo");
				
				/**Rellenamos el objeto con los datos del formulario*/
				if(lObjFormulario.getValue("CODIGO")!= null && lObjFormulario.getValue("CODIGO") != ""){
		        	lObjProducto.setCodigo((String) lObjFormulario.getValue("CODIGO"));
	        	}//else lObjProducto.setCodigo("");
				if(lObjFormulario.getValue("CODIGOEAN")!= null && lObjFormulario.getValue("CODIGOEAN") != ""){
					lObjProducto.setCodigoean((String) lObjFormulario.getValue("CODIGOEAN"));
	        	}//else lObjProducto.setCodigoean("");
				if(lObjFormulario.getValue("DESCRIPCION")!= null && lObjFormulario.getValue("DESCRIPCION") != ""){
					lObjProducto.setDescripcion((String) lObjFormulario.getValue("DESCRIPCION"));
	        	}else lObjProducto.setDescripcion("");			
				if(lObjFormulario.getValue("CANTIDAD")!= null && lObjFormulario.getValue("CANTIDAD") != ""){
					lObjProducto.setCantidad(Integer.valueOf((String)lObjFormulario.getValue("CANTIDAD")));
				}else lObjProducto.setCantidad(1);
				if(lObjFormulario.getValue("UNIDADES")!= null && lObjFormulario.getValue("UNIDADES") != ""){
					lObjProducto.setUnidades((String) lObjFormulario.getValue("UNIDADES"));
				}//else lObjProducto.setUnidades("");
				if(lObjFormulario.getValue("LOTE")!= null && lObjFormulario.getValue("LOTE") != ""){
					lObjProducto.setLote((String) lObjFormulario.getValue("LOTE"));
				}else lObjProducto.setLote("0");
				if(lObjFormulario.getValue("CODIGO_COMPRAS")!= null && lObjFormulario.getValue("CODIGO_COMPRAS") != ""){
					lObjProducto.setCodigoCompras((String) lObjFormulario.getValue("CODIGO_COMPRAS"));
				}else lObjProducto.setCodigoCompras("");
				if(lObjFormulario.getValue("STOCKMIN")!= null && lObjFormulario.getValue("STOCKMIN") != ""){
					lObjProducto.setStockMin(Integer.valueOf((String)lObjFormulario.getValue("STOCKMIN")));
				}
				
				if("UPDATE".equals(lStrMetodo)){
					/**Llamamos al metodo y actualizamos el producto/ubicacin*/
					lStrResult = update(lObjProducto);
				}
				if("DELETE".equals(lStrMetodo)){
					/**Llamamos al metodo y eliminamos el producto/ubicacin*/
					lStrResult = delete(lObjProducto);
				}
				if("IMPRIMIR".equals(lStrMetodo)){
					int lIntCantidad = 1; 
					if(lObjFormulario.getValue("CANTIDADETIQUETAS")!= null && lObjFormulario.getValue("CANTIDADETIQUETAS") != ""){
						lIntCantidad = Integer.valueOf((String)lObjFormulario.getValue("CANTIDADETIQUETAS"));
					}
					
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					lStrResult = imprimirEtiqueta( lObjProducto, lIntCantidad, request, response);
				}
			}
        	
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
		}
		
        request.setAttribute("producto", lObjProducto);
        /**Navegabilidad */
        String lStrVolver = "";
        if(request.getParameter("volver") != null){
			  lStrVolver = request.getParameter("volver");
		}
        request.setAttribute("volver", lStrVolver);        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
                
        return mapping.findForward(lStrResult);
    }
	
	public String update(Producto pObjPU){
		try {
			ProductoDelegate lObjProductoDelegate = new ProductoDelegate();			
			lObjProductoDelegate.update(pObjPU);
			return "SUCCESS";
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (ProductoDaoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}
	}
	
	public String delete(Producto pObjProducto){
		ProductoDelegate lObjProductoDelegate;
		try {
			lObjProductoDelegate = new ProductoDelegate();
			lObjProductoDelegate.delete(pObjProducto.getCodigo());
			return "SUCCESS";
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (ProductoDaoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}	
	}
	
	public String imprimirEtiqueta(Producto pObjProducto, int pIntCantidad, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteEtiquetaProducto reporte = new ServletReporteEtiquetaProducto();
			for(int i = 0; i < pIntCantidad; i++){
				reporte.doGet(pObjProducto, request, response);
			}
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
	
}
