/**
 * 
 */
package es.postigo.action;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.postigo.delegate.UbicacionDelegate;
import es.postigo.dto.Ubicacion;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.UbicacionDaoException;
import es.postigo.struts.forms.FormularioMAP;

/**
 * @author informatica4
 *
 */
public class FichaUbicacionAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        
		String lStrResult = "ok";
		
		/**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
		
		FormularioMAP lObjFormulario = (FormularioMAP) form;
		Ubicacion lObjUbicacion = new Ubicacion();
		
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	UbicacionDelegate ubicacionDelegate = new UbicacionDelegate();	
        	if(request.getParameter("CODIGO") != null && request.getParameter("CODIGO")!=null){
				lObjUbicacion = ubicacionDelegate.getRegistro(request.getParameter("CODIGO"));
			}
        	if(request.getParameter("metodo") != null && request.getParameter("metodo")!=null){
				String lStrMetodo = request.getParameter("metodo");
				
				/**Rellenamos el objeto con los datos del formulario*/
				if(lObjFormulario.getValue("CODIGO")!= null && lObjFormulario.getValue("CODIGO") != ""){
		        	lObjUbicacion.setCodigo((String) lObjFormulario.getValue("CODIGO"));
	        	}//else lObjUbicacion.setCodigo("");
				if(lObjFormulario.getValue("CODIGOEAN")!= null && lObjFormulario.getValue("CODIGOEAN") != ""){
					lObjUbicacion.setCodigoean((String) lObjFormulario.getValue("CODIGOEAN"));
	        	}//else lObjUbicacion.setCodigoean("");
				if(lObjFormulario.getValue("DESCRIPCION")!= null && lObjFormulario.getValue("DESCRIPCION") != ""){
					lObjUbicacion.setDescripcion((String) lObjFormulario.getValue("DESCRIPCION"));
	        	}else lObjUbicacion.setDescripcion("");
				
				if("UPDATE".equals(lStrMetodo)){
					/**Llamamos al metodo y actualizamos el producto/ubicacin*/
					lStrResult = update(lObjUbicacion);
				}
				if("DELETE".equals(lStrMetodo)){
					/**Llamamos al metodo y eliminamos el producto/ubicacin*/
					lStrResult = delete(lObjUbicacion);
				}
				if("IMPRIMIR".equals(lStrMetodo)){
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					lStrResult = imprimirEtiqueta( lObjUbicacion, request, response);
				}
			}
        	
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
		}
          
        request.setAttribute("ubicacion", lObjUbicacion);   
        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
        
        return mapping.findForward(lStrResult);
    }
	
	public String update(Ubicacion pObjPU){
		try {
			UbicacionDelegate lObjUbicacionDelegate = new UbicacionDelegate();			
			lObjUbicacionDelegate.update(pObjPU);
			return "SUCCESS";
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (UbicacionDaoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}
	}
	
	public String delete(Ubicacion pObjUbicacion){
		UbicacionDelegate lObjUbicacionDelegate;
		try {
			lObjUbicacionDelegate = new UbicacionDelegate();
			lObjUbicacionDelegate.delete(pObjUbicacion.getCodigo());
			return "SUCCESS";
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (UbicacionDaoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}	
	}
	
	public String imprimirEtiqueta(Ubicacion pObjUbicacion, HttpServletRequest request, HttpServletResponse response){		
        try {
        	ServletReporteEtiquetaUbicacion reporte = new ServletReporteEtiquetaUbicacion();
			reporte.doGet(pObjUbicacion, request, response);
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
}
