/**
 * 
 */
package es.postigo.action;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import es.postigo.delegate.MovimientosDelegate;
import es.postigo.dto.Movimientos;
import es.postigo.dto.User;
import es.postigo.exceptions.ApplicationException;
import es.postigo.struts.forms.FormularioMAP;

/**
 * @author informatica4
 *
 */
public class ListadoBusquedaAction extends GenericoAction{
	
	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        DynaActionForm registerForm = (DynaActionForm) form;  
        int lIntPagActual = 1;
        String lStrABuscar = "";
        
        /**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
        
		if(request.getParameter("pag") != null && request.getParameter("pag")!=null){
			lIntPagActual = Integer.valueOf(request.getParameter("pag").toString());
		}
		
		if(request.getParameter("BUSQUEDA") != null && request.getParameter("BUSQUEDA")!=null){
			lStrABuscar = request.getParameter("BUSQUEDA").toString();
		}
        
        // Extraemos los datos del formulario   
        String  login = (String) registerForm.get("login"); 
        String  pass = (String) registerForm.get("pass");  
        List<Movimientos> listaMovimientos = new ArrayList<Movimientos>(); 
        int lIntNumPaginas = 0;
        int lIntRegPagina = 10;
        int lIntTotalReg = 0;
       
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	MovimientosDelegate movimientosDelegate = new MovimientosDelegate();
        	//Montamos la consulta
        	String lStrSQL = "SELECT * FROM MOVIMIENTOS ";
        	
        	//Aadimos los parametros de busqueda al WHERE
        	String lStrWhere = "WHERE 1 = 1 ";
        	if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
        		lStrWhere = "WHERE UBI_ORIGEN = '"+ lStrABuscar +"' OR UBI_DESTINO = '"+ lStrABuscar +"' OR COD_PRODUCTO = '"+ lStrABuscar +"' ";
        	}
        	
        	String lStrOrder = "ORDER BY FECHA DESC ";
        	String lStrPaginacion = "LIMIT "+ (lIntPagActual-1)*lIntRegPagina +", "+ lIntRegPagina;
        	
			listaMovimientos = movimientosDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder+lStrPaginacion);
        	
			//Paginacin
			if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
				lIntTotalReg = listaMovimientos.size();
			}else{
				lIntTotalReg = obtenerNumRegistros();
			}
			lIntNumPaginas = lIntTotalReg/lIntRegPagina;
			if(lIntTotalReg%lIntRegPagina > 0){
				lIntNumPaginas += 1;
			}
			
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
          
        request.setAttribute("listaMovimientos", listaMovimientos);
        request.setAttribute("numPaginas", lIntNumPaginas);
        request.setAttribute("totalReg", lIntTotalReg);
        request.setAttribute("pagActual", lIntPagActual);
        String lStrResult = "ok";
        return mapping.findForward(lStrResult);
    }
	
	public int obtenerNumRegistros() throws Exception{		
		List<Movimientos> listaMovimientos = new ArrayList<Movimientos>(); 		
		try {
			MovimientosDelegate lObjMovimientosDelegate = new MovimientosDelegate();
			listaMovimientos = lObjMovimientosDelegate.obtenerListado("SELECT * FROM MOVIMIENTOS ORDER BY FECHA DESC");
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return listaMovimientos.size();		
	}

}
