/**
 * 
 */
package es.postigo.action;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import es.postigo.delegate.InventarioDelegate;
import es.postigo.dto.Inventario;
import es.postigo.dto.Producto;
import es.postigo.dto.ProductoUbicacion;
import es.postigo.dto.User;
import es.postigo.exceptions.ApplicationException;
import es.postigo.struts.forms.FormularioMAP;

/**
 * @author informatica4
 *
 */
public class ListadoInventarioAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        DynaActionForm registerForm = (DynaActionForm) form;  
        int lIntPagActual = 1;
        String lStrABuscar = "";
        String lStrResult = "";
        String lStrMostrarTodo = "";
        
        /**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
        
		if(request.getParameter("pag") != null && request.getParameter("pag")!=null){
			lIntPagActual = Integer.valueOf(request.getParameter("pag").toString());
		}
		
		if(request.getParameter("BUSQUEDA") != null && request.getParameter("BUSQUEDA")!=null){
			lStrABuscar = request.getParameter("BUSQUEDA").toString();
		}
		
		if(request.getParameter("MOSTRARTODOS") != null && request.getParameter("MOSTRARTODOS")!=null){
			lStrMostrarTodo = request.getParameter("MOSTRARTODOS").toString();
		}
        
        // Extraemos los datos del formulario   
        String  login = (String) registerForm.get("login"); 
        String  pass = (String) registerForm.get("pass");  
        List<Inventario> listaInventario = new ArrayList<Inventario>(); 
        int lIntNumPaginas = 0;
        int lIntRegPagina = 10;
        int lIntTotalReg = 0;
       
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	InventarioDelegate inventarioDelegate = new InventarioDelegate();
        	//Montamos la consulta
        	//String lStrSQL = "SELECT * FROM INVENTARIO ";
        	String lStrSQL = "SELECT I.COD_UBICACION,"
        		+"PU.DESCRIPCION AS DESC_COD_UBICACION,"
        		+"I.COD_PRODUCTO,"
        		+"PU2.DESCRIPCION AS DESC_COD_PRODUCTO,"
        		+"I.CANTIDAD "
        		+"FROM INVENTARIO I "
        		+"LEFT JOIN UBICACION PU "
  			  	+"ON (I.COD_UBICACION = PU.CODIGO) "
  			  	+"LEFT JOIN PRODUCTO PU2 "
  			  	+"ON (I.COD_PRODUCTO = PU2.CODIGO) ";
        	
        	//Aadimos los parametros de busqueda al WHERE
        	String lStrWhere = "";
        	if(request.getParameter("MOSTRARTODOS")!=null && request.getParameter("MOSTRARTODOS")!= ""){
        		lStrWhere = "WHERE 1 = 1 ";
        	}else{
        		lStrWhere = "WHERE 1 = 1 AND I.CANTIDAD > 0 ";
        	}
        	if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
        		//lStrWhere = "WHERE COD_UBICACION = '"+ lStrABuscar +"' OR COD_PRODUCTO = '"+ lStrABuscar +"' OR CODEAN_PRODUCTO = '" + lStrABuscar + "' OR CODEAN_UBICACION = '" + lStrABuscar + "' ";
        		if(request.getParameter("MOSTRARTODOS")!=null && request.getParameter("MOSTRARTODOS")!= ""){
        			lStrWhere = "WHERE COD_UBICACION = '"+ lStrABuscar +"' OR PU.DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR COD_PRODUCTO = '"+ lStrABuscar +"' OR PU2.DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR CODEAN_PRODUCTO = '" + lStrABuscar + "' OR CODEAN_UBICACION = '" + lStrABuscar + "' ";
        		}else{
        			lStrWhere = "WHERE I.CANTIDAD > 0 AND (COD_UBICACION = '"+ lStrABuscar +"' OR PU.DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR COD_PRODUCTO = '"+ lStrABuscar +"' OR PU2.DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR CODEAN_PRODUCTO = '" + lStrABuscar + "' OR CODEAN_UBICACION = '" + lStrABuscar + "') ";
        		}
        	}
        	
        	String lStrOrder = "ORDER BY COD_UBICACION ";
        	String lStrPaginacion = "LIMIT "+ (lIntPagActual-1)*lIntRegPagina +", "+ lIntRegPagina;
        	
			listaInventario = inventarioDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder+lStrPaginacion);
        	
			//Paginacin
			if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
				lIntTotalReg = inventarioDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder).size();
			}else{
				if(request.getParameter("MOSTRARTODOS")!=null && request.getParameter("MOSTRARTODOS")!= ""){
					lIntTotalReg = obtenerNumRegistrosConNulosYNegativos();
				}else{
					lIntTotalReg = obtenerNumRegistros();
				}
			}
			lIntNumPaginas = lIntTotalReg/lIntRegPagina;
			if(lIntTotalReg%lIntRegPagina > 0){
				lIntNumPaginas += 1;
			}			
			
			//Si queremos imprimir el listado, pasamos 
			if(request.getParameter("metodo") != null && request.getParameter("metodo")!=null){
				String lStrMetodo = request.getParameter("metodo");
				
				if("IMPRIMIR".equals(lStrMetodo)){
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					 List<Inventario> listaInventarioIMP = inventarioDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder);
					lStrResult = imprimirListado(listaInventarioIMP, request, response);
				}
				if("IMPRIMIRXLS".equals(lStrMetodo)){
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					 List<Inventario> listaInventarioIMP = inventarioDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder);
					lStrResult = imprimirListadoXLS(listaInventarioIMP, request, response);
				}
			}else{	
				lStrResult = "ok";
			}
			
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		/* Convertir Check's*/
        Inventario lObjInventario = new Inventario();
        if(request.getParameter("MOSTRARTODOS") != null && request.getParameter("MOSTRARTODOS")!=null){
        	lObjInventario.setMostrarTodo("1");
        }else{
        	lObjInventario.setMostrarTodo("0");
        }
          
        request.setAttribute("listaInventario", listaInventario);
        request.setAttribute("numPaginas", lIntNumPaginas);
        request.setAttribute("totalReg", lIntTotalReg);
        request.setAttribute("pagActual", lIntPagActual);
        request.setAttribute("busqueda",lStrABuscar);
        request.setAttribute("mostrartodos", lStrMostrarTodo);
        request.setAttribute("inventario", lObjInventario);
        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
        
        return mapping.findForward(lStrResult);
    }
	
	public int obtenerNumRegistros() throws Exception{		
		List<Inventario> listaInventario = new ArrayList<Inventario>(); 		
		try {
			InventarioDelegate lObjInventarioDelegate = new InventarioDelegate();
			String lStrSQL = "SELECT I.COD_UBICACION,"
        		+"PU.DESCRIPCION AS DESC_COD_UBICACION,"
        		+"I.COD_PRODUCTO,"
        		+"PU2.DESCRIPCION AS DESC_COD_PRODUCTO,"
        		+"I.CANTIDAD "
        		+"FROM INVENTARIO I "
        		+"LEFT JOIN UBICACION PU "
  			  	+"ON (I.COD_UBICACION = PU.CODIGO) "
  			  	+"LEFT JOIN PRODUCTO PU2 "
  			  	+"ON (I.COD_PRODUCTO = PU2.CODIGO) "
  			  	+"WHERE I.CANTIDAD > 0 "
  			  	+"ORDER BY COD_UBICACION";
			
			listaInventario = lObjInventarioDelegate.obtenerListado(lStrSQL/*"SELECT * FROM INVENTARIO ORDER BY COD_UBICACION"*/);
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return listaInventario.size();		
	}
	
	public int obtenerNumRegistrosConNulosYNegativos() throws Exception{		
		List<Inventario> listaInventario = new ArrayList<Inventario>(); 		
		try {
			InventarioDelegate lObjInventarioDelegate = new InventarioDelegate();
			String lStrSQL = "SELECT I.COD_UBICACION,"
        		+"PU.DESCRIPCION AS DESC_COD_UBICACION,"
        		+"I.COD_PRODUCTO,"
        		+"PU2.DESCRIPCION AS DESC_COD_PRODUCTO,"
        		+"I.CANTIDAD "
        		+"FROM INVENTARIO I "
        		+"LEFT JOIN UBICACION PU "
  			  	+"ON (I.COD_UBICACION = PU.CODIGO) "
  			  	+"LEFT JOIN PRODUCTO PU2 "
  			  	+"ON (I.COD_PRODUCTO = PU2.CODIGO) "
  			  	//+"WHERE I.CANTIDAD > 0 "
  			  	+"ORDER BY COD_UBICACION";
			
			listaInventario = lObjInventarioDelegate.obtenerListado(lStrSQL/*"SELECT * FROM INVENTARIO ORDER BY COD_UBICACION"*/);
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return listaInventario.size();		
	}
	
	public String imprimirListado(List<Inventario> pObjListaInventario, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteInventario reporte = new ServletReporteInventario();
			reporte.doGet(pObjListaInventario, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
	
	public String imprimirListadoXLS(List<Inventario> pObjListaInventario, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteInventario reporte = new ServletReporteInventario();
			reporte.doGetXLS(pObjListaInventario, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
	
}
