/**
 * 
 */
package es.postigo.action;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import es.postigo.delegate.UserDelegate;
import es.postigo.dto.User;
import es.postigo.exceptions.ApplicationException;

/**
 * @author informatica4
 *
 */
public class ListadoUsuarioAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        DynaActionForm registerForm = (DynaActionForm) form;  
        int lIntPagActual = 1;
        String lStrABuscar = "";
        String lStrResult = "";
        
        /**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
        
		if(request.getParameter("pag") != null && request.getParameter("pag")!=null){
			lIntPagActual = Integer.valueOf(request.getParameter("pag").toString());
		}
		
		if(request.getParameter("BUSQUEDA") != null && request.getParameter("BUSQUEDA")!=null){
			lStrABuscar = request.getParameter("BUSQUEDA").toString();
		}
        
        // Extraemos los datos del formulario   
        String  login = (String) registerForm.get("login"); 
        String  pass = (String) registerForm.get("pass");  
        List<User> listaUsuarios = new ArrayList<User>(); 
        int lIntNumPaginas = 0;
        int lIntRegPagina = 10;
        int lIntTotalReg = 0;
       
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	UserDelegate usuarioDelegate = new UserDelegate();
        	//Montamos la consulta
        	//String lStrSQL = "SELECT * FROM INVENTARIO ";
        	String lStrSQL = "SELECT USER, PASS FROM USUARIO ";
        	
        	//Aadimos los parametros de busqueda al WHERE
        	String lStrWhere = "WHERE 1 = 1 ";
        	if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
        		lStrWhere = "WHERE USER LIKE '%"+ lStrABuscar.toUpperCase() +"%' ";        		
        	}
        	
        	String lStrOrder = "ORDER BY USER ";
        	String lStrPaginacion = "LIMIT "+ (lIntPagActual-1)*lIntRegPagina +", "+ lIntRegPagina;
        	
			listaUsuarios = usuarioDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder+lStrPaginacion);
        	
			//Paginacin
			if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
				lIntTotalReg = usuarioDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder).size();
			}else{
				lIntTotalReg = obtenerNumRegistros();
			}
			lIntNumPaginas = lIntTotalReg/lIntRegPagina;
			if(lIntTotalReg%lIntRegPagina > 0){
				lIntNumPaginas += 1;
			}			
			
			//Si queremos imprimir el listado, pasamos 
			if(request.getParameter("metodo") != null && request.getParameter("metodo")!=null){
				String lStrMetodo = request.getParameter("metodo");
				
				if("IMPRIMIR".equals(lStrMetodo)){
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					 List<User> listaUsuariosIMP = usuarioDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder);
					lStrResult = imprimirListado( listaUsuariosIMP, request, response);
				}
			}else{	
				lStrResult = "ok";
			}
			
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
          
        request.setAttribute("listaUsuarios", listaUsuarios);
        request.setAttribute("numPaginas", lIntNumPaginas);
        request.setAttribute("totalReg", lIntTotalReg);
        request.setAttribute("pagActual", lIntPagActual);
        request.setAttribute("busqueda",lStrABuscar);
        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
        
        return mapping.findForward(lStrResult);
    }
	
	public int obtenerNumRegistros() throws Exception{		
		List<User> listaUsuarios = new ArrayList<User>(); 		
		try {
			UserDelegate lObjUserDelegate = new UserDelegate();
			String lStrSQL = "SELECT USER, PASS FROM USUARIO ORDER BY USER";
			
			listaUsuarios = lObjUserDelegate.obtenerListado(lStrSQL);
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return listaUsuarios.size();		
	}
	
	public String imprimirListado(List<User> pObjListaUser, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteUser reporte = new ServletReporteUser();
			reporte.doGet(pObjListaUser, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}

}
