/**
 * 
 */
package es.postigo.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.postigo.delegate.InventarioDelegate;
import es.postigo.delegate.ProductoDelegate;
import es.postigo.delegate.UbicacionDelegate;
import es.postigo.dto.Inventario;
import es.postigo.dto.Producto;
import es.postigo.dto.Ubicacion;
import es.postigo.exceptions.ApplicationException;
import es.postigo.struts.forms.FormularioMAP;

/**
 * @author informatica4
 *
 */
public class MovimientoProductoAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception{
		  
		String lStrResult = "ok";
		/**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
		
		FormularioMAP lObjFormulario = (FormularioMAP) form;
		Producto lObjProducto = new Producto();
		//Ubicacion lObjUbicacion = new Ubicacion();
		Ubicacion lObjUbicacionOrigen = new Ubicacion();
		Ubicacion lObjUbicacionDestino = new Ubicacion();
		Inventario lObjInventario = new Inventario();
		Inventario lObjInventarioAux = new Inventario();
		
		if(request.getParameter("menu") != null && request.getParameter("menu")!=null){
			  lObjFormulario = new FormularioMAP();
		}
		if(request.getParameter("obtenerDesc") != null && request.getParameter("obtenerDesc")!=null){
			response.setHeader("Cache-Control", "no-cache");
		
			// Extraemos los datos del formulario   
			/** Damos de baja el stock de la ubicacin origen */
			String lStrCodUbicacionOrigen = (String) lObjFormulario.getValue("COD_UBICACION_ORIGEN");
			String lStrCodUbicacionDestino = (String) lObjFormulario.getValue("COD_UBICACION_DESTINO");
			String lStrCodProducto = (String) lObjFormulario.getValue("COD_PRODUCTO");
			ProductoDelegate lObjProductoDelegate = new ProductoDelegate();
			UbicacionDelegate lObjUbicacionDelegate = new UbicacionDelegate();
			
			try{
				//rellenamos descripcion ubicacion origen
				if(lStrCodUbicacionOrigen != null && !"".equals(lStrCodUbicacionOrigen)){
					//Ubicacion origen
					lObjUbicacionOrigen = lObjUbicacionDelegate.getRegistroPorCodigoEAN(lStrCodUbicacionOrigen);
					lObjInventario.setCodEanUbicacion(lStrCodUbicacionOrigen);
					lObjInventario.setCodUbicacion(lObjUbicacionOrigen.getCodigo());
				}
				//rellenamos descripcion ubicacion destino
				if(lStrCodUbicacionDestino != null && !"".equals(lStrCodUbicacionDestino)){
					//Ubicacion destino
					lObjUbicacionDestino = lObjUbicacionDelegate.getRegistroPorCodigoEAN(lStrCodUbicacionDestino);
		    	    lObjInventarioAux.setCodEanUbicacion(lStrCodUbicacionDestino);
	    		    lObjInventarioAux.setCodUbicacion(lObjUbicacionDestino.getCodigo());				
				}
				//Rellenamos descripcion producto
				if(lStrCodProducto!=null && !"".equals(lStrCodProducto)){
					lObjProducto = lObjProductoDelegate.getRegistroPorCodigoEAN(lStrCodProducto);
					lObjInventario.setCodEanProducto(lStrCodProducto);
					lObjInventario.setCodProducto(lObjProducto.getCodigo());
					lObjInventarioAux.setCodEanProducto(lStrCodProducto);
					lObjInventarioAux.setCodProducto(lObjProducto.getCodigo());
				}
			}catch(Exception e){
				/** Limpiamos los valores del Form */
				lObjFormulario.setValue("COD_UBICACION_ORIGEN","");
				lObjFormulario.setValue("COD_PRODUCTO","");
				lObjFormulario.setValue("CANTIDAD","");
				lObjFormulario.setValue("COD_UBICACION_DESTINO","");
				/***/
				lStrResult = "ERROR";
				/**TODO: Cambiar mensaje de error y poner no existe la descripcion para este codigo*/
				e.printStackTrace();				
			}
			//Si tenemos Origen, Producto y Destino, procedemos a realizar la baja de la ubicacion origen y la insercion de la cantidad indicada en la ubicacion destino. 
			if(lStrCodUbicacionOrigen!=null && !"".equals(lStrCodUbicacionOrigen) && lStrCodUbicacionDestino!=null && !"".equals(lStrCodUbicacionDestino) && lStrCodProducto!=null && !"".equals(lStrCodProducto)){
				try {
					if((String)lObjFormulario.getValue("CANTIDAD") != null && !"".equals((String) lObjFormulario.getValue("CANTIDAD"))){
						lObjInventario.setCantidad((String) lObjFormulario.getValue("CANTIDAD"));
						lObjInventarioAux.setCantidad((String) lObjFormulario.getValue("CANTIDAD"));
	   
						/** Realizariamos las acciones en los objetos de negocio */  					
						InventarioDelegate inventarioDelegate = new InventarioDelegate();		
						if(lObjInventario != null && lObjInventario.getCodUbicacion()!=null && lObjInventario.getCodProducto()!=null && lObjFormulario.getValue("CANTIDAD")!= null && !"".equals(lObjFormulario.getValue("CANTIDAD"))){
							//productoUbicacionDelegate.update(lObjInventario);
							Inventario lObjInv = inventarioDelegate.getRegistro(lObjInventario.getCodUbicacion(), lObjInventario.getCodProducto());
							if(lObjInv != null){
								/**TODO: movimientoInventario(lObjInventario, lObjInventarioAux);*/
								inventarioDelegate.decrementarInventario(lObjInventario, "998000000000");	
								Inventario lObjInvAux = inventarioDelegate.getRegistro(lObjInventarioAux.getCodUbicacion(), lObjInventarioAux.getCodProducto());
								if(lObjInvAux != null){
									inventarioDelegate.incrementarInventario(lObjInventarioAux, "998000000000");
								}else{
									inventarioDelegate.insert(lObjInventarioAux);
								}
								/**Limpiamos los valores del Form*/
								lObjFormulario.setValue("COD_UBICACION_ORIGEN","");
								lObjFormulario.setValue("COD_PRODUCTO","");
								lObjFormulario.setValue("CANTIDAD","");
								lObjFormulario.setValue("COD_UBICACION_DESTINO","");
								/***/
							}					
							lStrResult = "SUCCESS";
						}else{
							//Mostramos la misma pantalla sin la cantidad, porque este campo no tena un formato numrico valido.
							lObjFormulario.setValue("COD_UBICACION_ORIGEN",lObjFormulario.getValue("COD_UBICACION_ORIGEN"));
							lObjFormulario.setValue("COD_PRODUCTO",lObjFormulario.getValue("COD_PRODUCTO"));
							lObjFormulario.setValue("CANTIDAD","");
							lObjFormulario.setValue("COD_UBICACION_DESTINO",lObjFormulario.getValue("COD_UBICACION_DESTINO"));

							lObjInventario.setCodEanUbicacion((String) lObjFormulario.getValue("COD_UBICACION_ORIGEN"));
							lObjInventario.setCodEanProducto((String) lObjFormulario.getValue("COD_PRODUCTO"));
							lObjInventario.setCantidad("");
							lObjInventario.setCodEanUbicacion((String) lObjFormulario.getValue("COD_UBICACION_DESTINO"));
						}
					}
				} catch (ApplicationException e) {
					// TODO Auto-generated catch block
					/** Limpiamos los valores del Form */
					lObjFormulario.setValue("COD_UBICACION_ORIGEN","");
					lObjFormulario.setValue("COD_PRODUCTO","");
					lObjFormulario.setValue("CANTIDAD","");
					lObjFormulario.setValue("COD_UBICACION_DESTINO","");
					/***/
					lStrResult = "ERROR";
					e.printStackTrace();
				} catch (Throwable e) {
					// TODO Auto-generated catch block
					/** Limpiamos los valores del Form */
					lObjFormulario.setValue("COD_UBICACION_ORIGEN","");
					lObjFormulario.setValue("COD_PRODUCTO","");
					lObjFormulario.setValue("CANTIDAD","");
					lObjFormulario.setValue("COD_UBICACION_DESTINO","");
					/***/
					lStrResult = "ERROR";
					e.printStackTrace();
				}
			}			
		}
		  
		request.setAttribute("inventario", lObjInventario);
		request.setAttribute("producto", lObjProducto);
		//request.setAttribute("ubicacion", lObjUbicacion);
		request.setAttribute("ubicacionOrigen", lObjUbicacionOrigen);
		request.setAttribute("ubicacionDestino", lObjUbicacionDestino);
		
		/**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
		
		return mapping.findForward(lStrResult);
	}
}
