/**
 * 
 */
package es.postigo.action;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import es.postigo.delegate.MovimientosDelegate;
import es.postigo.dto.Movimientos;
import es.postigo.exceptions.ApplicationException;

/**
 * @author informatica4
 *
 */
public class MovimientosAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        DynaActionForm registerForm = (DynaActionForm) form;  
        int lIntPagActual = 1;
        String lStrABuscar = "";
        String lStrResult = "";
        
        /**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
        
		if(request.getParameter("pag") != null && request.getParameter("pag")!=null){
			lIntPagActual = Integer.valueOf(request.getParameter("pag").toString());
		}
		
		if(request.getParameter("BUSQUEDA") != null && request.getParameter("BUSQUEDA")!=null){
			lStrABuscar = request.getParameter("BUSQUEDA").toString();
		}
        
        // Extraemos los datos del formulario   
        String  login = (String) registerForm.get("login"); 
        String  pass = (String) registerForm.get("pass");  
        List<Movimientos> listaMovimientos = new ArrayList<Movimientos>(); 
        int lIntNumPaginas = 0;
        int lIntRegPagina = 10;
        int lIntTotalReg = 0;
       
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	MovimientosDelegate movimientosDelegate = new MovimientosDelegate();
        	//Montamos la consulta
        	//String lStrSQL = "SELECT * FROM MOVIMIENTOS ";
        	
        	String lStrSQL = "SELECT M.UBI_ORIGEN,"
				  +"PU.descripcion AS DESC_UBI_ORIGEN,"
				  +"PU.CODIGOEAN AS CODEAN_UBI_ORIGEN,"
				  +"M.UBI_DESTINO,"
				  +"PU2.descripcion AS DESC_UBI_DESTINO,"
				  +"PU2.CODIGOEAN AS CODEAN_UBI_DESTINO,"
				  +"M.COD_PRODUCTO,"
				  +"PU3.descripcion AS DESC_COD_PRODUCTO,"
				  +"PU3.CODIGOEAN AS CODEAN_PRODUCTO,"
				  +"M.CANTIDAD,"
				  +"M.FECHA "
				  +"FROM MOVIMIENTOS M "
				  +"LEFT JOIN UBICACION PU "
				  +"ON (M.UBI_ORIGEN = PU.CODIGO) "
				  +"LEFT JOIN UBICACION PU2 "
				  +"ON (M.UBI_DESTINO = PU2.CODIGO) "
				  +"LEFT JOIN PRODUCTO PU3 "
				  +"ON (M.COD_PRODUCTO = PU3.CODIGO) ";			
        	
        	//Aadimos los parametros de busqueda al WHERE
        	String lStrWhere = "WHERE 1 = 1 ";
        	if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
        		lStrWhere = "WHERE UBI_ORIGEN = '"+ lStrABuscar +"' OR PU.DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR UBI_DESTINO = '"+ lStrABuscar +"' OR PU2.DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR COD_PRODUCTO = '"+ lStrABuscar +"' OR PU3.DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR PU3.CODIGOEAN = '" + lStrABuscar + "' OR PU2.CODIGOEAN = '" + lStrABuscar + "' OR PU.CODIGOEAN = '" + lStrABuscar + "' ";
        	}
        	
        	String lStrOrder = "ORDER BY FECHA DESC ";
        	String lStrPaginacion = "LIMIT "+ (lIntPagActual-1)*lIntRegPagina +", "+ lIntRegPagina;
        	
			listaMovimientos = movimientosDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder+lStrPaginacion);
        	
			//Paginacin
			if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
				lIntTotalReg = movimientosDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder).size();
			}else{
				lIntTotalReg = obtenerNumRegistros();
			}
			lIntNumPaginas = lIntTotalReg/lIntRegPagina;
			if(lIntTotalReg%lIntRegPagina > 0){
				lIntNumPaginas += 1;
			}
			
			//Si queremos imprimir el listado, pasamos 
			if(request.getParameter("metodo") != null && request.getParameter("metodo")!=null){
				String lStrMetodo = request.getParameter("metodo");
				
				if("IMPRIMIR".equals(lStrMetodo)){
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					 List<Movimientos> listaMovimientosIMP = movimientosDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder);
					lStrResult = imprimirListado(listaMovimientosIMP, request, response);
				}
				if("IMPRIMIRXLS".equals(lStrMetodo)){
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					 List<Movimientos> listaMovimientosIMP = movimientosDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder);
					lStrResult = imprimirListadoXLS(listaMovimientosIMP, request, response);
				}
			}else{	
				lStrResult = "ok";
			}
			
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
          
        request.setAttribute("listaMovimientos", listaMovimientos);
        request.setAttribute("numPaginas", lIntNumPaginas);
        request.setAttribute("totalReg", lIntTotalReg);
        request.setAttribute("pagActual", lIntPagActual);
        request.setAttribute("busqueda",lStrABuscar);
        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
        
        return mapping.findForward(lStrResult);
    }
	
	public int obtenerNumRegistros() throws Exception{		
		List<Movimientos> listaMovimientos = new ArrayList<Movimientos>(); 		
		try {
			MovimientosDelegate lObjMovimientosDelegate = new MovimientosDelegate();
			String lStrSQL = "SELECT M.UBI_ORIGEN,"
			  +"PU.descripcion AS DESC_UBI_ORIGEN,"
			  +"M.UBI_DESTINO,"
			  +"PU2.descripcion AS DESC_UBI_DESTINO,"
			  +"M.COD_PRODUCTO,"
			  +"PU3.descripcion AS DESC_COD_PRODUCTO,"
			  +"M.CANTIDAD,"
			  +"M.FECHA "
			  +"FROM MOVIMIENTOS M "
			  +"LEFT JOIN UBICACION PU "
			  +"ON (M.UBI_ORIGEN = PU.CODIGO) "
			  +"LEFT JOIN UBICACION PU2 "
			  +"ON (M.UBI_DESTINO = PU2.CODIGO) "
			  +"LEFT JOIN PRODUCTO PU3 "
			  +"ON (M.COD_PRODUCTO = PU3.CODIGO) "
			  +"ORDER BY FECHA DESC";
			listaMovimientos = lObjMovimientosDelegate.obtenerListado(lStrSQL/*"SELECT * FROM MOVIMIENTOS ORDER BY FECHA DESC"*/);
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return listaMovimientos.size();		
	}
	
	public String imprimirListado(List<Movimientos> pObjListaMovimientos, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteMovimientos reporte = new ServletReporteMovimientos();
			reporte.doGet(pObjListaMovimientos, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
	
	public String imprimirListadoXLS(List<Movimientos> pObjListaMovimientos, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteMovimientos reporte = new ServletReporteMovimientos();
			reporte.doGetXLS(pObjListaMovimientos, request, response);
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}

}
