/**
 * 
 */
package es.postigo.action;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import es.postigo.delegate.ProductoDelegate;
import es.postigo.dto.Producto;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.ProductoDaoException;

/**
 * @author informatica4
 *
 */
public class ProductoAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        DynaActionForm registerForm = (DynaActionForm) form;  
        
        /**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
		
		//FormularioMAP lObjFormulario = (FormularioMAP) form;
		
		int lIntPagActual = 1;
        String lStrABuscar = "";
        String lStrOrder = "";
    	String lStrCampoOrden = "";
        
		if(request.getParameter("pag") != null && request.getParameter("pag")!=null){
			lIntPagActual = Integer.valueOf(request.getParameter("pag").toString());			
		}
		
		if(request.getParameter("BUSQUEDA") != null && request.getParameter("BUSQUEDA")!=null){
			lStrABuscar = request.getParameter("BUSQUEDA").toString();
		}
        
        String lStrResult = "ok";
        
        // Extraemos los datos del formulario   
        List<Producto> listaProductos = new ArrayList<Producto>(); 
        //List<ProductoUbicacion> listaUbicaciones = new ArrayList<ProductoUbicacion>(); 
        int lIntNumPaginas = 0;
        int lIntRegPagina = 10;
        int lIntTotalReg = 0;
        
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	ProductoDelegate productoDelegate = new ProductoDelegate();		
			//listaProductos = productoUbicacionDelegate.obtenerListado("SELECT * FROM PRODUCTO WHERE SUBSTR(codigo,1,3) = '000' ORDER BY CODIGO");
        	//Montamos la consulta
        	String lStrSQL = "SELECT * FROM PRODUCTO ";
        	
        	//Aadimos los parametros de busqueda al WHERE
        	String lStrWhere = "WHERE SUBSTR(codigo,1,3) = '000' ";
        	if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
        		lStrWhere += "AND (CODIGO LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR CODIGOEAN = '" + lStrABuscar + "') ";
        	}
        	
        	/**Orden dinamico de los listados (ORDEN ASC y DESC), ademas de permitir ordenar por CAMPO_ORDEN*/
        	lStrOrder = "ORDER BY ";
        	//lStrCampoOrden = "CODIGO ";
        	
        	if(request.getParameter("CAMPO_ORDEN") != null && !"".equals(request.getParameter("CAMPO_ORDEN"))){
        		lStrCampoOrden = request.getParameter("CAMPO_ORDEN").toString() + " ";
        		lStrOrder += lStrCampoOrden;
        	}else lStrOrder = " ";//lStrOrder = lStrCampoOrden;
        	
        	if(request.getParameter("ORDEN") != null && !"".equals(request.getParameter("ORDEN"))){
        		//lStrOrderU = "ORDER BY CODIGO " + (String) lObjFormulario.getValue("ORDEN");
        		lStrOrder += request.getParameter("ORDEN").toString() + " ";
        	}
        	/**FIN ORDEN*/
        	
        	String lStrPaginacion = "LIMIT "+ (lIntPagActual-1)*lIntRegPagina +", "+ lIntRegPagina;
        	
        	listaProductos = productoDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder+lStrPaginacion);
        	
			//Paginacin
			if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
				lIntTotalReg = productoDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder).size();
			}else{
				lIntTotalReg = obtenerNumProductos();
			}
			lIntNumPaginas = lIntTotalReg/lIntRegPagina;
			if(lIntTotalReg%lIntRegPagina > 0){
				lIntNumPaginas += 1;
			}
        	
			//listaes = productoDelegate.obtenerListado("SELECT * FROM PRODUCTO WHERE SUBSTR(codigo,1,3) != '000' ORDER BY CODIGO");
			//Montamos la consulta
        	String lStrSQLU = "SELECT * FROM PRODUCTO ";
        	
        	//Aadimos los parametros de busqueda al WHERE
        	String lStrWhereU = "WHERE SUBSTR(codigo,1,3) != '000' ";
        	if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
        		lStrWhereU += "AND (CODIGO LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR CODIGOEAN = '" + lStrABuscar + "') ";
        	}
        	/**TODO: Preguntar en compras por los campos en los que desean o por los que desean filtrar a la hora de hacer las busquedas en los listados.*/
        	
			//Si queremos imprimir el listado, pasamos 
			if(request.getParameter("metodo") != null && request.getParameter("metodo")!=null){
				String lStrMetodo = request.getParameter("metodo");
				
				if("IMPRIMIR".equals(lStrMetodo)){
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					 List<Producto> listaProductoIMP = productoDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder);
					lStrResult = imprimirListado( listaProductoIMP, request, response);
				}
				if("IMPRIMIRXLS".equals(lStrMetodo)){
					List<Producto> listaProductoIMP = productoDelegate.obtenerListado(lStrSQL+lStrWhere+lStrOrder);
					lStrResult = imprimirListadoXLS( listaProductoIMP, request, response);
				}
			}else{	
				lStrResult = "SUCCESS";
			}
			
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
			throw new ProductoDaoException( "ApplicationException: " + e.getMessage(), e );
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
			throw new ProductoDaoException( "Exception: " + e.getMessage(), e );
		}
          
        request.setAttribute("listaProductos", listaProductos);
        request.setAttribute("numPaginas", lIntNumPaginas);
        request.setAttribute("totalReg", lIntTotalReg);
        request.setAttribute("pagActual", lIntPagActual);
        request.setAttribute("busqueda",lStrABuscar);
        request.setAttribute("campoOrden", lStrCampoOrden);
        request.setAttribute("orden", lStrOrder);
        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
        
        return mapping.findForward(lStrResult);
    }
	
	public void insertLocal(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception {
		
		aStrForward="exito";		
		
		System.out.println("insert :)");
	}
	
	public int obtenerNumProductos() throws Exception{		
		List<Producto> listaProductos = new ArrayList<Producto>(); 		
		try {
			ProductoDelegate lObjProductoDelegate = new ProductoDelegate();
			listaProductos = lObjProductoDelegate.obtenerListado("SELECT * FROM PRODUCTO WHERE SUBSTR(codigo,1,3) = '000' ORDER BY CODIGO");
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return listaProductos.size();		
	}
	
	public String imprimirListado(List<Producto> pObjListaProducto, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteProducto reporte = new ServletReporteProducto();
			reporte.doGet(pObjListaProducto, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
	
	public String imprimirListadoXLS(List<Producto> pObjListaProducto, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteProducto reporte = new ServletReporteProducto();
			reporte.doGetXLS(pObjListaProducto, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
	
}
