package es.postigo.action;

import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.jasperreports.engine.JRExporter;
import net.sf.jasperreports.engine.JRExporterParameter;
import net.sf.jasperreports.engine.JRResultSetDataSource;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperPrintManager;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.util.JRLoader;

import com.mysql.jdbc.PreparedStatement;


import es.postigo.dto.Ubicacion;
import es.postigo.utility.ConexionBD;

/**
 * Servlet implementation class ServletReporte
 */
public class ServletReporteEtiquetaUbicacion extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public ServletReporteEtiquetaUbicacion() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(Ubicacion pObjUbicacion, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		 processRequest(pObjUbicacion, request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(Ubicacion pObjUbicacion, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(pObjUbicacion, request, response);
	}
	
	protected void processRequest(Ubicacion pObjUbicacion, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
		/**Descomentar para mostrar PDF*/
        response.setHeader("Content-Disposition", "attachment; filename=\"reporte.pdf\";");
        response.setHeader("Cache-Control", "no-cache");
        response.setHeader("Pragma", "no-cache");
        response.setDateHeader("Expires", 0);

        response.setContentType("application/pdf");        

        ServletOutputStream out = response.getOutputStream();

        try{
        	Connection con = ConexionBD.obtieneConexion();
        	String sqlConsulta = "SELECT * FROM UBICACION WHERE CODIGO = '" + pObjUbicacion.getCodigo() + "'";  
          
        	PreparedStatement stmt = (PreparedStatement) con.prepareStatement(sqlConsulta);
        	ResultSet rs = (ResultSet) stmt.executeQuery();
        
        	//Ruta relativa
        	JasperReport reporte = (JasperReport) JRLoader.loadObject(request.getSession().getServletContext().getRealPath("/WEB-INF/reports/reporte.jasper"));
        	//Ruta absoluta		
            //JasperReport reporte = (JasperReport) JRLoader.loadObject("C:\\Archivos de programa\\Apache Software Foundation\\Tomcat 6.0\\webapps\\reports\\reporte.jasper");

            Map parametros = new HashMap();
            //parametros.put("autor", "Juan");
            //parametros.put("titulo", "Reporte");

            JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros, new JRResultSetDataSource(rs));
            /**Le paso el 2 parametro a false para que no pregunte a la hora de imprimir*/
            JasperPrintManager.printReport( jasperPrint, false);

            /**Descomentar para mostrar PDF*/
            JRExporter exporter = new JRPdfExporter();
            exporter.setParameter(JRExporterParameter.JASPER_PRINT, jasperPrint);
            exporter.setParameter(JRExporterParameter.OUTPUT_STREAM, out);
            exporter.exportReport();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

}
