package es.postigo.action;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.ResultSet;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import net.sf.jasperreports.engine.JRExporter;
import net.sf.jasperreports.engine.JRExporterParameter;
import net.sf.jasperreports.engine.JRResultSetDataSource;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.export.JRPdfExporter;
import net.sf.jasperreports.engine.export.JRXlsExporter;
import net.sf.jasperreports.engine.export.JRXlsExporterParameter;
import net.sf.jasperreports.engine.util.JRLoader;

import com.mysql.jdbc.PreparedStatement;

import es.postigo.dto.Producto;
import es.postigo.dto.Ubicacion;
import es.postigo.utility.ConexionBD;

/**
 * Servlet implementation class ServletReporte
 */
public class ServletReporteProducto extends HttpServlet {
	private static final long serialVersionUID = 1L;
       
    /**
     * @see HttpServlet#HttpServlet()
     */
    public ServletReporteProducto() {
        super();
        // TODO Auto-generated constructor stub
    }

	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGet(List<Producto> pObjListadoProducto, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		 processRequest(pObjListadoProducto, request, response);
	}
	
	/**
	 * @see HttpServlet#doGet(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doGetXLS(List<Producto> pObjListadoProducto, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		 processRequestXLS(pObjListadoProducto, request, response);
	}

	/**
	 * @see HttpServlet#doPost(HttpServletRequest request, HttpServletResponse response)
	 */
	protected void doPost(List<Producto> pObjListadoProducto, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException {
		processRequest(pObjListadoProducto, request, response);
	}
	
	protected void processRequest(List<Producto> pObjListadoProducto, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
		/**Descomentar para mostrar PDF*/
        response.setHeader("Content-Disposition", "attachment; filename=\"reporteProductos.pdf\";");
        response.setHeader("Cache-Control", "no-cache");
        response.setHeader("Pragma", "no-cache");
        response.setDateHeader("Expires", 0);

        response.setContentType("application/pdf");        

        ServletOutputStream out = response.getOutputStream();

        try{
        	Connection con = ConexionBD.obtieneConexion();
        	String sqlConsulta = "SELECT * FROM PRODUCTO WHERE SUBSTR(codigo,1,3) = '000' ORDER BY CODIGO";
          
        	PreparedStatement stmt = (PreparedStatement) con.prepareStatement(sqlConsulta);
        	ResultSet rs = (ResultSet) stmt.executeQuery();
        
        	//Ruta relativa
        	JasperReport reporte = (JasperReport) JRLoader.loadObject(request.getSession().getServletContext().getRealPath("/WEB-INF/reports/reporteProductos.jasper"));
        	Map parametros = new HashMap();
            
            JasperPrint jasperPrint = JasperFillManager.fillReport(reporte, parametros, new JRResultSetDataSource(rs));
            /**Le paso el 2 parametro a false para que no pregunte a la hora de imprimir*/
            //JasperPrintManager.printReport( jasperPrint, false);

            /**Descomentar para mostrar PDF*/
            JRExporter exporter = new JRPdfExporter();
            exporter.setParameter(JRExporterParameter.JASPER_PRINT, jasperPrint);
            exporter.setParameter(JRExporterParameter.OUTPUT_STREAM, out);
            exporter.exportReport();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }
	
	protected void processRequestXLS(List<Producto> pObjListadoProducto, HttpServletRequest request, HttpServletResponse response) throws ServletException, IOException
    {
		int bit;
		File f;
		InputStream in;
		ServletOutputStream out;
		
		try{
			Connection con = ConexionBD.obtieneConexion();
			String sqlConsulta = "SELECT * FROM PRODUCTO WHERE SUBSTR(codigo,1,3) = '000' ORDER BY CODIGO";
	        
	    	PreparedStatement stmt = (PreparedStatement) con.prepareStatement(sqlConsulta);
	    	ResultSet rs = (ResultSet) stmt.executeQuery();
			
	    	//Ruta relativa
	    	JasperReport reporte = (JasperReport) JRLoader.loadObject(request.getSession().getServletContext().getRealPath("/WEB-INF/reports/reporteProductos.jasper"));
	    	Map parametros = new HashMap();
			
	    	JasperPrint jasperPrint = JasperFillManager.fillReport (reporte, parametros, new JRResultSetDataSource(rs));
			String xlsFileName = "reporteProductos.xls";
			
			//Creacion del XLS
			JRXlsExporter exporter = new JRXlsExporter ();
			exporter.setParameter (JRExporterParameter.JASPER_PRINT, jasperPrint);
			exporter.setParameter (JRExporterParameter.OUTPUT_FILE_NAME, xlsFileName);
			exporter.setParameter (JRXlsExporterParameter.IS_ONE_PAGE_PER_SHEET, Boolean.TRUE);
			exporter.exportReport ();

			// En este punto ya esta Creado el XLS
			// Ahora leemos el fichero y forzamos al navegador a que nos descargue el fichero.
			f = new File ( xlsFileName);

			response.setContentType ("application/vnd.ms-excel"); //Tipo de fichero.
			response.setHeader ("Content-Disposition", "attachment;filename=\"" + xlsFileName + "\""); //Configurar cabecera http

			in = new FileInputStream (f);
			out = response.getOutputStream ();

			bit = 256;
			while ((bit) >= 0)
			{
			bit = in.read ();
			out.write (bit);
			}

			out.flush ();
			out.close ();
			in.close ();
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
    }

}
