/**
 * 
 */
package es.postigo.action;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Properties;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

//import org.apache.log4j.Logger;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

import es.postigo.action.utility.AuxiliarMVC;
import es.postigo.delegate.TCDelegate;
import es.postigo.dto.AuxiliarSQL;
import es.postigo.dto.ListadoDTO;
import es.postigo.dto.MetadatoDTO;
import es.postigo.exceptions.ApplicationCoreException;
import es.postigo.utility.Auxiliar;

//import es.prodevelop.delegate.TCDelegate;
//import es.prodevelop.delegate.UsuarioAplicacionDelegate;
//import es.prodevelop.dto.AuxiliarSQL;
//import es.prodevelop.dto.ListadoDTO;
//import es.prodevelop.dto.MetadatoDTO;
//import es.prodevelop.dto.PaginacionDTO;
//import es.prodevelop.exception.ApplicationCoreException;
//import es.prodevelop.modelo.dto.CodigoDescripcionDTO;
//import es.prodevelop.modelo.dto.GlobalConfig;
//import es.prodevelop.modelo.dto.GlobalFiltro;
//import es.prodevelop.modelo.dto.GuUsuapliConfig;
//import es.prodevelop.modelo.dto.GuUsuapliFiltro;
//import es.prodevelop.modelo.dtov.GlobalConfigDTO;
//import es.prodevelop.mvc.form.FormularioMAP;
//import es.prodevelop.mvc.tag.AuxliarTC;
//import es.prodevelop.mvc.utility.AuxiliarMVC;
//import es.prodevelop.service.servicelocator.ServiceLocatorCoreDao;

/**
 * @author informatica4
 *
 */
public class TCAction extends DispatchAction {

	/** El a obj aux. */
	protected AuxiliarMVC aObjAux = new AuxiliarMVC();

	/** El a str forward. */
	protected String aStrForward = "error.jsp";

	/** El es popup. */
	protected boolean esPopup = false;

	/** El a obj listado dto. */
	private ListadoDTO aObjListadoDTO;

	/** El a str columnaspordefecto. */
	private String aStrColumnaspordefecto;

	// Numero maximo para la exportacion de registros de excel
	public static final int NUM_MAX_ROWS_EXCEL = 20000; // 65535

	/** El a obj log. */
	//protected final Logger aObjLog = Logger.getLogger(this.getClass());

	/**
	 * Quitar columnas.
	 *
	 * @param pObjColumnas
	 *            el objeto Columnas
	 * @param pStrQuitadas
	 *            el string Quitadas
	 *
	 * @return un objeto MetadatoDTO[]
	 *
	 * @throws Exception
	 *             the exception
	 */
	private MetadatoDTO[] quitarColumnas(MetadatoDTO[] pObjColumnas, String pStrQuitadas) throws Exception {

		if (pStrQuitadas != null) {

			AuxiliarMVC lObjAuxiliar = new AuxiliarMVC();
			String[] lObjQuitadas = pStrQuitadas.split(",");
			boolean lBooDejar = true;
			if (lObjQuitadas.length > 0) {
				MetadatoDTO[] lObjColumnas = new MetadatoDTO[pObjColumnas.length - lObjQuitadas.length];

				int k = 0;
				for (int i = 0; i < pObjColumnas.length; i++) {
					for (int j = 0; j < lObjQuitadas.length; j++) {
						if (pObjColumnas[i].getNomcolbd().equalsIgnoreCase(lObjQuitadas[j])) {
							lBooDejar = false;
						}
					}
					if (lBooDejar) {
						lObjColumnas[k] = new MetadatoDTO();
						lObjColumnas[k] = pObjColumnas[i];
						k++;
					}
					lBooDejar = true;
				}
				pObjColumnas = lObjColumnas;
			}
		}
		return pObjColumnas;
	}

	// M�TODOS PRIVADOS

	/**
	 * Obtener filas.
	 *
	 * @return un objeto int
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	private int obtenerFilas() throws ApplicationCoreException {

		try {
			Properties lObjProperties = new Properties();
			lObjProperties = Auxiliar.cargarFicheroPropiedades("proyecto.properties");
			int lIntNumRegistros = Integer.parseInt(lObjProperties.getProperty("REGPAGINACION"));

			return lIntNumRegistros;
		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.FICHERO_NO_PRESENTE, e.toString(), this
					.getClass().getSimpleName(), "obtenerFilas");
		}
	}

	/**
	 * Guardafiltro.
	 *
	 * @param mapping
	 *            el mapping
	 * @param form
	 *            el form
	 * @param request
	 *            el request
	 * @param response
	 *            el response
	 *
	 * @return un objeto ActionForward
	 *
	 * @throws Exception
	 *             the exception
	 */
//	public ActionForward guardaFiltro(ActionMapping mapping, ActionForm form, HttpServletRequest request,
//			HttpServletResponse response) throws Exception {
//
//		aStrForward = "guardafiltro";
//
//		try {
//			HttpSession lObjSession = request.getSession();
//			String lStrActionActual = (String) lObjSession.getAttribute("ACTION");
//			GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO) lObjSession.getAttribute(lStrActionActual);
//
//			String lStrTabla = lObjConfiguracion.getTabla();
//			String lStrGuardarFiltro = (String) request.getParameter("guardarfiltro");
//
//			String lStrWhereHumano = lObjConfiguracion.getWhereHumanoActual();
//			if((lObjConfiguracion.getWhereHumanoActualUsuario()!=null) && (!lObjConfiguracion.getWhereHumanoActualUsuario().equalsIgnoreCase("")))
//			{
//				lStrWhereHumano += " AND "+lObjConfiguracion.getWhereHumanoActualUsuario();
//			}
//			
//			String lStrWhereSql = lObjConfiguracion.getWhereActualUsuario();
////			if((lObjConfiguracion.getWhereActualUsuario()!=null) && (!lObjConfiguracion.getWhereActualUsuario().equalsIgnoreCase("")))
////			{
////				lStrWhereSql += " AND "+lObjConfiguracion.getWhereActualUsuario();
////			}
//			String lStrNombreFiltro = "";
//			String lStrEsEtiqueta = "N";
//
//			if(lObjConfiguracion.getTipoFiltroAplicado().equalsIgnoreCase(GlobalConfigDTO.PREDEFINIDO))
//			{
//				GlobalFiltro lObjFiltroGTmp = lObjConfiguracion.getFiltroPrdedefinido(lObjConfiguracion.getFiltroAplicado());
//				if(lObjFiltroGTmp!=null)
//				{
//					lStrNombreFiltro = lObjFiltroGTmp.getLabelfiltro();
//					lStrEsEtiqueta = "S";
//				}
//
//			}
//			else if(lObjConfiguracion.getTipoFiltroAplicado().equalsIgnoreCase(GlobalConfigDTO.USUARIO))
//			{
//				GuUsuapliFiltro lObjFiltroOTmp = lObjConfiguracion.getFiltroUsuario(lObjConfiguracion.getFiltroAplicado());
//				if(lObjFiltroOTmp!=null)
//				{
//					lStrNombreFiltro = lObjFiltroOTmp.getIdusufiltro();
//					lStrEsEtiqueta = "N";
//				}
//			}
//
//			if (lStrNombreFiltro == null) {
//				lStrNombreFiltro = "";
//			}
//
//			if (lStrWhereHumano == null) {
//				lStrWhereHumano = "No se ha definido un filtro";
//			} else {
//				if (lStrWhereHumano.equals("borradodelfiltroactual")) {
//					lStrWhereHumano = "No se ha definido un filtro";
//				}
//			}
//
//			if (lStrTabla == null) {
//				lStrTabla = "Sin determinar";
//			}
//
//			// cambiarlo por el operador
//			String lStrIdOper = this.getOperador(request);
//
//			if (lStrGuardarFiltro != null) {
//				long lLonIdFiltro = guardarFiltro(lStrGuardarFiltro, lStrIdOper, lObjConfiguracion);
//				lObjConfiguracion.setFiltroAplicado(String.valueOf(lLonIdFiltro));
//				lObjConfiguracion.setTipoFiltroAplicado(GlobalConfigDTO.USUARIO);
//				lObjSession.setAttribute(lStrActionActual, lObjConfiguracion);
//			}
//
//			request.setAttribute("pStrInforme", lStrTabla);
//			request.setAttribute("pStrWhereHumano", lStrWhereHumano);
//			request.setAttribute("pStrWhereSql", (lStrWhereSql != null) ? lStrWhereSql : "");
//			request.setAttribute("pStrNombreFiltro", lStrNombreFiltro);
//			request.setAttribute("pStrNombreEsEtiqueta", lStrEsEtiqueta);
//			request.setAttribute("pObjConf", lObjConfiguracion);
//
//		} catch (ApplicationCoreException e) {
//			lanzarError(e, request);
//			aStrForward = "errorpopup";
//		} catch (Throwable e) {
//			ApplicationCoreException ex = new ApplicationCoreException(
//					ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.getMessage(), this.getClass().getSimpleName(),
//					"guardafiltro");
//			lanzarError(ex, request);
//			aStrForward = "errorpopup";
//		} finally {
//			ActionForward lObjRetorno = new ActionForward(aStrForward);
//			return lObjRetorno;
//		}
//	}

	/**
	 * Cargar configuracion.
	 *
	 * @param pStrIdAplicacion
	 *            el string IdAplicacion
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
//	private void cargarConfiguracion(String pStrIdAplicacion, String pStrTabla, String pStrUsuario,
//			AuxiliarSQL pObjSesionSQL) throws ApplicationCoreException {
//
//		try {
//			UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();
//
//			if (pStrIdAplicacion != null) {
//				GuUsuapliConfig lObjConfig = new GuUsuapliConfig();
//				lObjConfig = lObjUsApDel.obtenerConfiguracionUsuario(pStrUsuario, pStrIdAplicacion, pStrTabla);
//				pObjSesionSQL.setAStrAgrupacion(lObjConfig.getGrupo());
//				pObjSesionSQL.setAStrColumnas(lObjConfig.getCampos());
//				pObjSesionSQL.setAStrOrder(lObjConfig.getOrden());
//				pObjSesionSQL.setAStrTabla(lObjConfig.getIdinforme());
//				pObjSesionSQL.setAStrWhereFiltro(lObjConfig.getWherefiltro());
//				pObjSesionSQL.setAStrFiltroHumano(lObjConfig.getWhereesp());
//			}
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "cargarConfiguracion");
//		}
//	}

	/**
	 * Guardar configuracion.
	 *
	 * @param pStrConfiguracion
	 *            el string Configuracion
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pStrIdAplicacion
	 *            el string IdAplicacion
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
//	private void guardarConfiguracion(String pStrConfiguracion, String pStrUsuario, String pStrIdAplicacion,
//			AuxiliarSQL pObjSesionSQL) throws ApplicationCoreException {
//
//		try {
//			UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();
//
//			if (pStrConfiguracion != null) {
//				if (lObjUsApDel.existeConfiguracion(pStrUsuario, pStrIdAplicacion, pObjSesionSQL.getAStrTabla())) {
//					lObjUsApDel.deleteConfiguracion(pStrUsuario, pStrIdAplicacion, pObjSesionSQL.getAStrTabla());
//				}
//				GuUsuapliConfig lObjConfig = new GuUsuapliConfig();
//				lObjConfig.setIdinforme(pObjSesionSQL.getAStrTabla());
//				lObjConfig.setIdusu(pStrUsuario);
//				lObjConfig.setOrden(pObjSesionSQL.getAStrOrder());
//				lObjConfig.setCampos(pObjSesionSQL.getAStrColumnas());
//				lObjConfig.setGrupo(pObjSesionSQL.getAStrAgrupacion());
//
//				lObjUsApDel.insertarConfiguracion(lObjConfig);
//			}
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "guardarConfiguracion");
//		}
//	}

	/**
	 * Eliminar configuracion.
	 *
	 * @param pStrIdAplicacion
	 *            el string IdAplicacion
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
//	private void eliminarConfiguracion(String pStrIdAplicacion, String pStrUsuario, AuxiliarSQL pObjSesionSQL)
//			throws ApplicationCoreException {
//
//		try {
//			UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();
//
//			if ((pStrIdAplicacion != null)
//					&& (lObjUsApDel.existeConfiguracion(pStrUsuario, pStrIdAplicacion, pObjSesionSQL.getAStrTabla()))) {
//				lObjUsApDel.deleteConfiguracion(pStrUsuario, pStrIdAplicacion, pObjSesionSQL.getAStrTabla());
//			}
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "eliminarConfiguracion");
//		}
//	}

	/**
	 * Obtener hash map final.
	 *
	 * @param request
	 *            el request
	 * @param pStrElegidas
	 *            el string Elegidas
	 * @param pStrAgrupar
	 *            el string Agrupar
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrOrdenar
	 *            el string Ordenar
	 * @param pStrWherePuerto
	 *            el string WherePuerto
	 * @param pStrWhereFiltroHumano
	 *            el string WhereFiltroHumano
	 * @param pStrWhereFiltroSql
	 *            el string WhereFiltroSql
	 * @param pStrWhereFiltro
	 *            el string WhereFiltro
	 * @param pStrNombreFiltro
	 *            el string NombreFiltro
	 * @param pIntCursor
	 *            el integer Cursor
	 * @param pStrPorDefecto
	 *            el string PorDefecto
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pStrSesionNombre
	 *            el string SesionNombre
	 * @param pIntFilas
	 *            el integer Filas
	 *
	 * @return un objeto HashMap
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
//	private HashMap obtenerHashMapFinal(HttpServletRequest request, String pStrElegidas, String pStrAgrupar,
//			String pStrTabla, String pStrOrdenar, String pStrWherePuerto, String pStrWhereFiltroHumano,
//			String pStrWhereFiltroSql, String pStrWhereFiltro, String pStrNombreFiltro, int pIntCursor,
//			String pStrPorDefecto, AuxiliarSQL pObjSesionSQL, String pStrSesionNombre, int pIntFilas)
//			throws ApplicationCoreException {
//
//		HashMap lObjHashMap = new HashMap();
//		try {
//			UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();
//			String lStrUsuario = (String) request.getSession().getAttribute("CODUSUARIO");
//			String lStrIdAplicacion = (String) request.getSession().getAttribute("IDAPLICACION");
//			if (lStrUsuario != null) {
//				if (lObjUsApDel.existeConfiguracion(lStrUsuario, lStrIdAplicacion, pStrTabla)) {
//					cargarConfiguracion(lStrIdAplicacion, pStrTabla, lStrUsuario, pObjSesionSQL);
//				}
//			}
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "obtenerHashMapFinal");
//		}
//
//		try {
//			String lStrWhereFiltro = AuxiliarMVC.obtieneWhereFiltro(pStrWhereFiltroHumano, pStrWhereFiltroSql,
//					pStrWhereFiltro, pStrNombreFiltro, request, pObjSesionSQL);
//
//			String lStrWhere = "";
//
//			if (pStrWherePuerto == null) {
//				pStrWherePuerto = "";
//			}
//			if (lStrWhereFiltro == null) {
//				lStrWhereFiltro = "";
//			}
//
//			if ((pStrWherePuerto.equals("")) && (lStrWhereFiltro.equals(""))) {
//				lStrWhere = "";
//			} else {
//				if (pStrWherePuerto.equals("")) {
//					lStrWhereFiltro = lStrWhereFiltro.substring(4);
//				}
//				lStrWhere = " WHERE " + pStrWherePuerto + lStrWhereFiltro;
//			}
//
//			pStrElegidas = AuxiliarMVC.obtieneElegidas(pStrElegidas, pObjSesionSQL, pStrPorDefecto);
//			pStrAgrupar = AuxiliarMVC.obtieneAgrupar(pStrAgrupar, pObjSesionSQL);
//			pStrOrdenar = AuxiliarMVC.obtieneOrdenar(pStrOrdenar, pObjSesionSQL);
//			// Visualizaci�n de la agrupaci�n en primer lugar
//			pStrElegidas = AuxiliarMVC.cambiosVisualizarAgrupacion(pStrAgrupar, pStrElegidas);
//
//			// Obtiene la condici�n
//			String lStrCondicion = AuxiliarMVC.obtenerCondicion(pStrAgrupar, pStrOrdenar);
//			lStrCondicion = lStrWhere + lStrCondicion;
//
//			request.getSession().setAttribute(pStrSesionNombre, pObjSesionSQL);
//
//			TCDelegate lObjAuxDel = new TCDelegate();
//			lObjHashMap = lObjAuxDel.obtenerHashMap(pStrElegidas, pStrTabla, lStrWhere, lStrCondicion, pIntCursor,
//					pIntFilas);
//
//			lObjHashMap.put("pStrAgrupar", pStrAgrupar);
//
//			return lObjHashMap;
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "obtenerHashMapFinal");
//		}
//
//	}

	/**
	 * Lee yobtiene sql.
	 *
	 * @param request
	 *            el request
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pStrSesionNombre
	 *            el string SesionNombre
	 * @param pStrPorDefecto
	 *            el string PorDefecto
	 * @param pStrWherePuerto
	 *            el string WherePuerto
	 *
	 * @return un objeto HashMap
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	private HashMap leeYobtieneSQL(HttpServletRequest request, String pStrTabla, AuxiliarSQL pObjSesionSQL,
			String pStrSesionNombre, String pStrPorDefecto, String pStrWherePuerto) throws ApplicationCoreException {

		String lStrElegidas = (String) request.getParameter("elegidas");
		String lStrAgrupar = (String) request.getParameter("agrupar");
		String lStrOrdenar = (String) request.getParameter("ordenar");
		String lStrCursor = (String) request.getParameter("Cursor");
		String lStrWhereFiltroHumano = (String) request.getParameter("wherefiltrohumano");
		String lStrWhereFiltroSql = (String) request.getParameter("wherefiltrosql");
		String lStrWhereFiltro = (String) request.getParameter("wherefiltro");
		String lStrNombreFiltro = (String) request.getParameter("nombrefiltro");
		String lStrEliminarConfiguracion = (String) request.getParameter("eliminarconfiguracion");

		if (lStrEliminarConfiguracion != null) {
			pObjSesionSQL.setAStrColumnas(null);
			pObjSesionSQL.setAStrOrder(null);
			pObjSesionSQL.setAStrAgrupacion(null);
		}

		// gestion del cursor
		HashMap lHMSesion = null;
		if (request.getSession().getAttribute("HashMapCursores") == null)
			lHMSesion = new HashMap();
		else
			lHMSesion = (HashMap) request.getSession().getAttribute("HashMapCursores");

		int lIntCursor = 0;
		if (lStrCursor != null) {
			lIntCursor = Integer.parseInt(lStrCursor);
			pObjSesionSQL.setAStrCursor(lStrCursor);
			lHMSesion.put(pStrTabla, lStrCursor);
			request.getSession().setAttribute("HashMapCursores", lHMSesion);
		} else {
			if (lHMSesion.get(pStrTabla) == null) {
				lIntCursor = 0;
			} else {
				lIntCursor = Integer.parseInt((String) lHMSesion.get(pStrTabla));
			}
		}

		int lIntNumFilas = obtenerFilas();

		if (request.getParameter("excel") != null) {
			lIntCursor = 0;
			lIntNumFilas = NUM_MAX_ROWS_EXCEL;
			request.setAttribute("pStrTabla", pStrTabla);
			request.setAttribute("pStrFiltro", lStrWhereFiltroHumano);
			request.setAttribute("pStrNomFiltro", lStrNombreFiltro);
		}

		HashMap lObjHashMap = new HashMap();
//		lObjHashMap = obtenerHashMapFinal(request, lStrElegidas, lStrAgrupar, pStrTabla, lStrOrdenar, pStrWherePuerto,
//				lStrWhereFiltroHumano, lStrWhereFiltroSql, lStrWhereFiltro, lStrNombreFiltro, lIntCursor,
//				pStrPorDefecto, pObjSesionSQL, pStrSesionNombre, lIntNumFilas);

		lObjHashMap.put("pStrCursor", String.valueOf(lIntCursor));

		return lObjHashMap;
	}

	/**
	 * Pasa parametros.
	 *
	 * @param request
	 *            el request
	 * @param pObjHashMap
	 *            el objeto HashMap
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	protected void pasaParametros(HttpServletRequest request, HashMap pObjHashMap) throws ApplicationCoreException {

		ArrayList lObjVector = (ArrayList) pObjHashMap.get("pObjVector");
		request.setAttribute("pStrActual", (String) pObjHashMap.get("pStrCursor"));
		request.setAttribute("pStrAvanzar", (String) lObjVector.get(0));
		request.setAttribute("pStrRetroceder", (String) lObjVector.get(1));
		request.setAttribute("pStrCursorAvanzar", (String) lObjVector.get(2));
		request.setAttribute("pStrCursorRetroceder", (String) lObjVector.get(3));
		request.setAttribute("pStrCursorFinal", (String) lObjVector.get(5));
		request.setAttribute("pStrCursorInicio", (String) lObjVector.get(6));
		request.setAttribute("pStrActualNumPag", (String) lObjVector.get(7));
		request.setAttribute("pStrTotalNumPag", (String) lObjVector.get(8));
		request.setAttribute("pStrTotalRegistros", (String) lObjVector.get(9));
		request.setAttribute("pStrAgrupar", (String) pObjHashMap.get("pStrAgrupar"));
		request.setAttribute("pObjColumnas", pObjHashMap.get("pObjColumnas"));
	}

	/**
	 * Es primero tc.
	 *
	 * @param lIntNumero
	 *            el l int numero
	 *
	 * @return true, si satisfactorio
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	private boolean esPrimeroTC(int lIntNumero) throws ApplicationCoreException {

		boolean lBooRetorno = false;
		Properties lObjPropiedades = Auxiliar
				.cargarFicheroPropiedades("proyecto.properties");
		String lStrRegpagina = lObjPropiedades.getProperty("REGPAGINACION");
		int lIntRegpagina = Integer.parseInt(lStrRegpagina);
		if ((lIntNumero - 1) % lIntRegpagina == 0) {
			lBooRetorno = true;
		}

		return lBooRetorno;
	}

	/**
	 * Obtener listado dto.
	 *
	 * @param request
	 *            el request
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrNombreSesion
	 *            el string NombreSesion
	 *
	 * @return un objeto ListadoDTO
	 */
	// AGONZALEZ - Lo hago pblico
	public ListadoDTO obtenerListadoDTO(HttpServletRequest request, String pStrTabla, String pStrNombreSesion) {

		ListadoDTO lObjSesionSQL = (ListadoDTO) request.getSession().getAttribute(pStrNombreSesion);
		// if (request.getSession().getAttribute(pStrNombreSesion) == null ||
		// request.getParameter("inicio") != null) {
		if (request.getSession().getAttribute(pStrNombreSesion) == null
				|| (request.getParameter("inicio") != null && request.getParameter("inicio").equals("si"))) {
			lObjSesionSQL = new ListadoDTO();
			request.getSession().setAttribute(pStrNombreSesion, lObjSesionSQL);
		}

		if (lObjSesionSQL == null) {
			request.getSession().setAttribute(pStrNombreSesion, new AuxiliarSQL());
			lObjSesionSQL = (ListadoDTO) request.getSession().getAttribute(pStrNombreSesion);
		}
		// NUEVO ALBERTO 01/12/2008
		if (request.getParameter("inicio") != null && request.getParameter("inicio").equals("filtroacceso")) {
			lObjSesionSQL.reset();
		}

		// Borrado del objeto de Sesi�n si cambiamos de tabla
		if (lObjSesionSQL.getTabla() == null) {
			lObjSesionSQL.setTabla(pStrTabla);
		} else {
			String lStrIdNuevo = pStrTabla;
			String lStrIdViejo = lObjSesionSQL.getTabla();
			if (!(lStrIdNuevo.equals(lStrIdViejo))) {
				lObjSesionSQL.setAgrupacion(null);
				lObjSesionSQL.setColumnas(null);
				lObjSesionSQL.setExportar(false);
				lObjSesionSQL.setFiltrofijo(null);
				lObjSesionSQL.setFiltrousuario(null);
				lObjSesionSQL.setNombrefiltro(null);
				lObjSesionSQL.setFiltrohumano(null);
				lObjSesionSQL.setFiltroglobal(null);
				lObjSesionSQL.setOrden(null);
				lObjSesionSQL.setTabla(lStrIdNuevo);
			}
		}

		return lObjSesionSQL;
	}

	/**
	 * Obtener listado dto lupa.
	 *
	 * @param request
	 *            el request
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrNombreSesion
	 *            el string NombreSesion
	 *
	 * @return un objeto ListadoDTO
	 */
	private ListadoDTO obtenerListadoDTOLupa(HttpServletRequest request, String pStrTabla, String pStrNombreSesion) {

		if (request.getSession().getAttribute(pStrNombreSesion) == null) {
			request.getSession().setAttribute(pStrNombreSesion, new ListadoDTO());
		}
		ListadoDTO lObjSesionSQL = (ListadoDTO) request.getSession().getAttribute(pStrNombreSesion);
		if (lObjSesionSQL == null) {
			request.getSession().setAttribute(pStrNombreSesion, new AuxiliarSQL());
			lObjSesionSQL = (ListadoDTO) request.getSession().getAttribute(pStrNombreSesion);
		}

		return lObjSesionSQL;
	}

	/**
	 * Rellena listado dto.
	 *
	 * @param request
	 *            el request
	 * @param pStrElegidas
	 *            el string Elegidas
	 *
	 * @throws Exception
	 *             the exception
	 */
	private void rellenaListadoDTO(HttpServletRequest request, String pStrElegidas) throws Exception {

		// Construir la SQL
		this.aObjListadoDTO.setAgrupacion(obtieneAgrupar((String) request.getParameter("agrupar")));
		this.aObjListadoDTO.setOrden(obtieneOrdenar((String) request.getParameter("sqlordenar")));
		this.aObjListadoDTO.setColumnas(obtieneColumnas((String) request.getParameter("columnas"), pStrElegidas));
		this.aObjListadoDTO.setFiltrohumano(obtieneWherefiltrohumano(
				(String) request.getParameter("wherefiltrohumano"), (String) request.getParameter("quitafiltro")));
		this.aObjListadoDTO.setNombrefiltro(obtieneNombrefiltro((String) request.getParameter("nombrefiltro"),
				(String) request.getParameter("quitafiltro")));
		this.aObjListadoDTO.setFiltrousuario(obtieneWherefiltro((String) request.getParameter("wherefiltro"),
				(String) request.getParameter("quitafiltro")));
		this.aObjListadoDTO.setSelfiltro(obtieneSelfiltro((String) request.getParameter(ListadoDTO.SELFILTRO),
				(String) request.getParameter("quitafiltro")));
		this.aObjListadoDTO.setSelfiltroglobal(obtieneSelfiltroglobal((String) request
				.getParameter(ListadoDTO.SELFILTROGLOBAL), (String) request.getParameter("quitafiltroglobal")));
		this.aObjListadoDTO.setFiltrofijo(obtieneWherefijo((String) request.getParameter("filtrofijo"),
				(String) request.getParameter("idioma"), request));
		this.aObjListadoDTO.setFiltroIdioma(obtieneWhereIdioma((String) request.getParameter("idioma"),
				(String) request.getParameter("inicio"), request));
		this.aObjListadoDTO.setFiltroglobal(obtieneWhereglobal((String) request.getParameter("filtroglobal"),
				(String) request.getParameter("quitafiltroglobal")));
		this.aObjListadoDTO.setCampobdfiltro(this.obtieneCampobdfiltro(aObjListadoDTO.getCampobdfiltro()));

		// Guardar / Eliminar configuraci�n
		String lStrUsuario = getOperador(request);
		String lStrGuardarconfiguracion = (String) request.getParameter("guardarconfiguracion");
		String lStrEliminarconfiguracion = (String) request.getParameter("eliminarconfiguracion");
//		if (lStrGuardarconfiguracion != null) {
//			this.guardarConfiguracion(lStrGuardarconfiguracion, lStrUsuario, this.aObjListadoDTO, request);
//		}

		if (lStrEliminarconfiguracion != null) {
			this.eliminarConfiguracion(lStrEliminarconfiguracion, lStrUsuario, this.aObjListadoDTO, request);
		}

		// Obtencion de los filtros del usuario
		//UsuarioAplicacionDelegate lObjDelegate = new UsuarioAplicacionDelegate();
		String lStrIdAplicacion = getAplicacion(request);

		//GuUsuapliFiltro[] lObjFiltrosUsuario = lObjDelegate.obtenerFiltrosUsuario(lStrUsuario,
				//this.aObjListadoDTO.getTabla());
		//ArrayList lObjFiltrosArray = AuxliarTC.transformaOperadorFiltrosArrayList(lObjFiltrosUsuario);
		ArrayList lObjFiltrosArray = new ArrayList();
		request.setAttribute(ListadoDTO.FILTROUSUARIO, lObjFiltrosArray);

	}

	/**
	 * Guardar configuracion.
	 *
	 * @param pStrIdAplicacion
	 *            el string IdAplicacion
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pObjRequest
	 *            el objeto Request
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
//	public void guardarConfiguracion(String pStrIdAplicacion, String pStrUsuario, ListadoDTO pObjSesionSQL,
//			HttpServletRequest pObjRequest) throws ApplicationCoreException {
//
//		try {
//			aStrForward = "exito";
//			UsuarioAplicacionDelegate lObjDelegate = new UsuarioAplicacionDelegate();
//			String lStrOperador = getOperador(pObjRequest);
//			String lStrIdAplicacion = getAplicacion(pObjRequest);
//
//			if (pStrIdAplicacion != null) {
//				if (lObjDelegate.existeConfiguracion(lStrOperador, lStrIdAplicacion, pObjSesionSQL.getTabla())) {
//					lObjDelegate.deleteConfiguracion(lStrOperador, lStrIdAplicacion, pObjSesionSQL.getTabla());
//				}
//				GuUsuapliConfig lObjConfig = new GuUsuapliConfig();
//				lObjConfig.setIdinforme(pObjSesionSQL.getTabla());
//				lObjConfig.setIdusu(lStrOperador);
//				lObjConfig.setOrden(pObjSesionSQL.getOrden());
//				lObjConfig.setCampos(pObjSesionSQL.getColumnas());
//				lObjConfig.setGrupo(pObjSesionSQL.getAgrupacion());
//
//				// guardamos el filtro
//
//				lObjConfig.setWhereesp(pObjSesionSQL.getFiltrohumano());
//				lObjConfig.setWherefiltro(pObjSesionSQL.getFiltrousuario());
//
//				lObjDelegate.insertarConfiguracion(lObjConfig);
//			}
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "guardarConfiguracion");
//		}
//	}

	/**
	 * Eliminar configuracion.
	 *
	 * @param pStrIdAplicacion
	 *            el string IdAplicacion
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pObjRequest
	 *            el objeto Request
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public void eliminarConfiguracion(String pStrIdAplicacion, String pStrUsuario, ListadoDTO pObjSesionSQL,
			HttpServletRequest pObjRequest) throws ApplicationCoreException {

		try {
			aStrForward = "exito";
			//UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();
			String lStrIdAplicacion = getAplicacion(pObjRequest);

//			if ((pStrIdAplicacion != null)
//					&& (lObjUsApDel.existeConfiguracion(pStrUsuario, lStrIdAplicacion, pObjSesionSQL.getTabla()))) {
//				lObjUsApDel.deleteConfiguracion(pStrUsuario, lStrIdAplicacion, pObjSesionSQL.getTabla());
//			}
			pObjSesionSQL.setAgrupacion(null);
			pObjSesionSQL.setColumnas(this.aStrColumnaspordefecto);
			pObjSesionSQL.setExportar(false);
			// pObjSesionSQL.setFiltrofijo(null);
			pObjSesionSQL.setCampobdfiltro(null);
			pObjSesionSQL.setSelfiltroglobal(null);
			pObjSesionSQL.setFiltrousuario(null);
			pObjSesionSQL.setOrden(null);
		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
					.getClass().getSimpleName(), "eliminarConfiguracion");
		}
	}

	/**
	 * Exportar excel.
	 *
	 * @param request
	 *            el request
	 * @param pStrForward
	 *            el string Forward
	 * @param pStrVista
	 *            el string Vista
	 *
	 * @return un objeto String
	 */
	public String exportarExcel(HttpServletRequest request, String pStrForward, String pStrVista) {

		String lStrExcel = (String) request.getParameter("excel");
		aStrForward = "exportarexcel";
		if (lStrExcel != null) {
			aStrForward = "/jsp/tc/nexportaraexcel.jsp";
		} else {
			aStrForward = pStrForward;
		}
		request.setAttribute("pStrVista", pStrVista);
		request.setAttribute("pStrFiltro", this.aObjListadoDTO.getFiltrohumano());
		request.setAttribute("pStrNomFiltro", this.aObjListadoDTO.getNombrefiltro());
		return aStrForward;
	}

	/**
	 * Exportar excel.
	 *
	 * @param request
	 *            el request
	 * @param pStrForward
	 *            el string Forward
	 * @param pStrVista
	 *            el string Vista
	 *
	 * @return un objeto String
	 */
//	public String exportarExcel(HttpServletRequest request, String pStrForward, GlobalConfig pObjConfiguracion) {
//
//		String lStrExcel = (String) request.getParameter("excel");
//		aStrForward = "exportarexcel";
//		if (lStrExcel != null) {
//			aStrForward = "/jsp/tc/nexportaraexcel.jsp";
//		} else {
//			aStrForward = pStrForward;
//		}
//		request.setAttribute("pStrVista", pObjConfiguracion.getTabla());
//		request.setAttribute("pStrFiltro", pObjConfiguracion.getWherefiltrofijo());
//		request.setAttribute("pStrNomFiltro", pObjConfiguracion.getInffiltrofijo());
//		return aStrForward;
//	}

	/**
	 * Guardar filtro.
	 *
	 * @param pStrNombre
	 *            el string Nombre
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pStrIdApli
	 *            el string IdApli
	 * @param lObjSesionSQL
	 *            el l obj sesion sql
	 *
	 * @return un objeto long
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public long guardarFiltro(String pStrNombre, String pStrUsuario, String pStrIdApli, ListadoDTO lObjSesionSQL)
			throws ApplicationCoreException {

		try {
			//UsuarioAplicacionDelegate lObjOperador = new UsuarioAplicacionDelegate();
			long lIntRet = 0;
			if (pStrNombre != null) {
				//GuUsuapliFiltro lObjFiltro = new GuUsuapliFiltro();
//				lObjFiltro.setIdinforme(lObjSesionSQL.getTabla());
//				lObjFiltro.setIdusr(pStrUsuario);
//				lObjFiltro.setIdusufiltro(pStrNombre);
//				lObjFiltro.setWheesp(lObjSesionSQL.getFiltrohumano());
				String lStrWhereFiltro = lObjSesionSQL.getFiltrousuario();
				String[] lObjWhereFiltro = lStrWhereFiltro.split("%");
				lStrWhereFiltro = "";
				for (int i = 0; i < lObjWhereFiltro.length; i++) {
					if (i == (lObjWhereFiltro.length - 1)) {
						lStrWhereFiltro = lStrWhereFiltro + lObjWhereFiltro[i];
					} else {
						lStrWhereFiltro = lStrWhereFiltro + lObjWhereFiltro[i] + "%";
					}
				}
//				lObjFiltro.setWhefiltro(lStrWhereFiltro);
//				lObjOperador.insertarFiltro(lObjFiltro);
//				lIntRet = lObjFiltro.getIdfiltro();
			}
			return lIntRet;
		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
					.getClass().getSimpleName(), "guardarFiltro");
		}
	}

	/**
	 * Carga configuracion por defecto.
	 *
	 * @param pStrTabla
	 *            el string Tabla
	 * @param request
	 *            el request
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 * @throws Exception
	 *             the exception
	 */
	private void cargaConfiguracionPorDefecto(String pStrTabla, HttpServletRequest request)
			throws ApplicationCoreException, Exception {

		//UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();
		String lStrIdOperador = getOperador(request);
		String lStrIdAplicacion = getAplicacion(request);

		if (lStrIdOperador != null) {
//			if (lObjUsApDel.existeConfiguracion(lStrIdOperador, lStrIdAplicacion, pStrTabla)) {
//				cargarConfiguracion((String) request.getParameter("inicio"), (String) request
//						.getParameter("listadopopup"), lStrIdAplicacion, pStrTabla, lStrIdOperador, this.aObjListadoDTO);
//			}
		}
	}

	/**
	 * Cargar configuracion.
	 *
	 * @param pStrMenuInicio
	 *            el string MenuInicio
	 * @param pStrIdAplicacion
	 *            el string IdAplicacion
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrIdOperador
	 *            el string IdOperador
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	private void cargarConfiguracion(String pStrMenuInicio, String pStrListadoPopUp, String pStrIdAplicacion,
			String pStrTabla, String pStrIdOperador, ListadoDTO pObjSesionSQL) throws ApplicationCoreException {

		try {
			//UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();

			if (pStrMenuInicio != null || pStrListadoPopUp != null) {
//				GuUsuapliConfig lObjConfig = new GuUsuapliConfig();
//				lObjConfig = lObjUsApDel.obtenerConfiguracionUsuario(pStrIdOperador, pStrIdAplicacion, pStrTabla);
//				pObjSesionSQL.setAgrupacion(lObjConfig.getGrupo());
//				pObjSesionSQL.setColumnas(lObjConfig.getCampos());
//				pObjSesionSQL.setOrden(lObjConfig.getOrden());
//				pObjSesionSQL.setTabla(lObjConfig.getIdinforme());
//				pObjSesionSQL.setFiltrohumano(lObjConfig.getWhereesp());
//				pObjSesionSQL.setFiltrousuario(lObjConfig.getWherefiltro());
			}
		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
					.getClass().getSimpleName(), "cargarConfiguracion");
		}
	}

	protected String generaSql(HttpServletRequest request, String pStrForward) throws Exception {
		//return this.generaSql(request, pStrForward,null);
		return this.generaSql(request, pStrForward);
	}

	/**
	 * Genera sql.
	 *
	 * @param request el request
	 *
	 * @return un objeto String contenente la SQL
	 *
	 * @throws Exception
	 *             the exception
	 */
//	protected String generaSql(HttpServletRequest request, String pStrForward, String pStrPrefijo) throws Exception {
//
//		String lStrSQL = "";
//
//		HttpSession lObjSession = request.getSession();
//		String lStrActionActual = lObjSession.getAttribute("ACTION").toString();
//
//		GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO)lObjSession.getAttribute(lStrActionActual);
//
//		this.actualizarGlobalDTO(request);
//
//		this.montarfiltrofijo(request);
//		
//		String lStrSqlfiltrobusqueda = crearWhereSQLFiltroBusqueda(request, lObjConfiguracion.getTabla(), lObjConfiguracion.getFiltrobusqueda());
//
//		//aadir aqui los filtros usuario
//		String lStrCondicionWhere = " WHERE 1=1 ";
//
//		if((lObjConfiguracion.getFiltrofijoprepared()!=null)&&(!lObjConfiguracion.getFiltrofijoprepared().equalsIgnoreCase("")))
//		{
//			lStrCondicionWhere += " AND " + lObjConfiguracion.getFiltrofijoprepared();
//		}
//
//		//Si hay que filtrar por idioma
//		if((lObjConfiguracion.getIdioma()!=null)&&(lObjConfiguracion.getIdioma().equalsIgnoreCase("S")))
//		{
//			lStrCondicionWhere += " AND CODIDIOMA='"+lObjSession.getAttribute("IDIOMA")+"' ";
//		}
//
//		if((lObjConfiguracion.getWhereActual()!=null) && (!lObjConfiguracion.getWhereActual().equalsIgnoreCase("")))
//		{
//			lStrCondicionWhere += " AND " + lObjConfiguracion.getWhereActual();
//		}
//
//		if((lObjConfiguracion.getWhereActualUsuario()!=null) && (!lObjConfiguracion.getWhereActualUsuario().equalsIgnoreCase("")))
//		{
//			lStrCondicionWhere += " AND " + lObjConfiguracion.getWhereActualUsuario();
//		}
//		
//		if(lStrSqlfiltrobusqueda != null){
//			lStrCondicionWhere += " AND " +	lStrSqlfiltrobusqueda;				
//		}
//		
//		if(lObjConfiguracion.getFiltroglobal()!=null&&!lObjConfiguracion.getFiltroglobal().equals("")){
//			lStrCondicionWhere += " AND " +	lObjConfiguracion.getFiltroglobal();
//		}
//		
//		/* PAGINACION */
//		String lStrExcel = (String) request.getParameter("excel");
//
//		if (lStrExcel != null) {
//			lObjConfiguracion.getPaginacion().setRegistrosPorPaginas(NUM_MAX_ROWS_EXCEL);
//		}
//
//		// AGRUPACION Y ORDENACION
//		String lStrSqlagrupar = lObjConfiguracion.getGrupo();
//		String lStrSqlordenar = lObjConfiguracion.getOrden();
//
//		String lStrAgruparOrdenar = null;
//		if ((lStrSqlagrupar != null) || (lStrSqlordenar != null)) {
//			lStrAgruparOrdenar = " ORDER BY ";
//		}
//		if (lStrSqlagrupar != null) {
//			lStrAgruparOrdenar += lStrSqlagrupar;
//		}
//		if (lStrSqlordenar != null) {
//			if ((lStrSqlagrupar != null) && (!lStrSqlagrupar.equalsIgnoreCase(""))) {
//				lStrAgruparOrdenar += " , ";
//				lStrAgruparOrdenar += lStrSqlordenar;
//			} else {
//				lStrAgruparOrdenar += lStrSqlordenar;
//			}
//		}
//
//
//		// Obtención del total de registros para la paginacion
//		TCDelegate lObjAuxiliarListadoDelegate = new TCDelegate();
//		lObjConfiguracion.getPaginacion().setRegistrosTotales(lObjAuxiliarListadoDelegate.obtenerNumeroRegistrosActual(lObjConfiguracion.getTabla(), lStrCondicionWhere));
//
//		lObjConfiguracion.getPaginacion().actualizaPaginacion(request);
//
////		// cuando se haga un insert o un delete, se entere el numero de registros
////		PaginacionDTO lObjPagSesion = (PaginacionDTO) lObjSession.getAttribute("PAGINACION_" + lStrActionActual);
////		if (lObjPagSesion != null) {
////			lObjPagSesion.setRegistrosTotales(lIntTotReg);
////		}
//
////		/* CREACIÓN DE LA CONSULTA DE PAGINACION */
////		int lIntIndice = lObjPaginacion.getIndice();
//
//
//		int lIntRegistrosPorPagina = (lObjConfiguracion.getPaginacion().getRegistrosPorPagina() - 1);
//		
//		String lStrBBDD = (String)lObjSession.getAttribute("BBDD");
//
//		String lStrBetween = "";
//		if(lStrBBDD.equalsIgnoreCase("ORACLE")){
//			lStrBetween = lObjConfiguracion.getPaginacion().getIndice() + " and " + (lObjConfiguracion.getPaginacion().getIndice() + lIntRegistrosPorPagina);
//	
//			if (lStrAgruparOrdenar != null) {
//				lStrSQL = "select * from ( select a.*, row_number() over (" + lStrAgruparOrdenar + ") r from " + lObjConfiguracion.getTabla()
//						+ " a " + lStrCondicionWhere + ")" + " where r between " + lStrBetween + " " + lStrAgruparOrdenar;
//			} else {
//					lStrSQL = "select * from ( select a.*, rownum r from " + lObjConfiguracion.getTabla() + " a " + lStrCondicionWhere + " )"
//					+ " where r between " + lStrBetween;
//			}
//		}
//		else if(lStrBBDD.equalsIgnoreCase("PGSQL") || lStrBBDD.equalsIgnoreCase("MySQL")){
//			lStrBetween = " LIMIT " + (lObjConfiguracion.getPaginacion().getIndice() + lIntRegistrosPorPagina) + " OFFSET " + (lObjConfiguracion.getPaginacion().getIndice() - 1);
//		
//			if(lStrAgruparOrdenar != null){
//				lStrSQL = "select * from " + lObjConfiguracion.getTabla() + lStrCondicionWhere + " " +lStrAgruparOrdenar + lStrBetween;
//			}
//			else{
//				lStrSQL = "select * from " + lObjConfiguracion.getTabla() + lStrCondicionWhere + lStrBetween;			
//			}			
//		}
//
//		//sirve para montar la url abajo
//		String idioma = "";
//		if(lObjConfiguracion.getIdioma().equalsIgnoreCase("S"))
//		{
//			idioma = "&idioma=si";
//		}
//
//		/* Si se ha guardado la configuracion o se ha eliminado */
//		if (pStrForward.equalsIgnoreCase("exito")) {
//			request.setAttribute("pStrUrlLista", lObjConfiguracion.getIdinforme()+"?"+lObjConfiguracion.getHandlerparameter()+"=obtenerListado"+idioma);
//		}
//
//		/* METADATOS */
//		//este trozo de codigo equivale al metodo ObtenerIntercambio
//		TCDelegate lObjAuxDel = new TCDelegate();
//		String lStrAgrupar =lObjConfiguracion.getGrupo();
//		String lStrElegidas = lObjConfiguracion.getCampos();
//		lStrElegidas = AuxiliarMVC.visualizarAgrupacion(lStrAgrupar, lStrElegidas);
//		MetadatoDTO[] lObjMetadatos =  lObjAuxDel.obtenerIntercambio(lObjConfiguracion.getTabla(), lStrElegidas,pStrPrefijo);
//		request.setAttribute(ListadoDTO.METADATOS, lObjMetadatos);
//
//		/* EXPORTAR A EXCEL */
//		aStrForward = this.exportarExcel(request, aStrForward, lObjConfiguracion);
//
//		/* MANDAMOS EL OBJETO PAGINACION AL TC */
//		lObjConfiguracion.getPaginacion().salvarEstado(request);
//
//		/*guardamos el objeto en session*/
//		lObjSession.setAttribute(lStrActionActual,lObjConfiguracion);
//
//		return lStrSQL;
//	}

	public static String crearWhereSQLFiltroBusqueda(HttpServletRequest request, String pStrTabla, String pStrValor)  throws Exception {
		String lStrSQL = null;
		
		AuxiliarMVC lObjAuxModelo = new AuxiliarMVC();
		if(pStrValor != null && !pStrValor.equals("")){
			lStrSQL = " ( ";
			TCDelegate lObjAuxDel = new TCDelegate();
			MetadatoDTO[] lObjMetadatos = null;

			lObjMetadatos = lObjAuxDel.obtenerIntercambio(pStrTabla,"*",null);
			
			HttpSession lObjSession = request.getSession();
			String lStrBBDD = (String)lObjSession.getAttribute("BBDD");
			
			//FIN MODIFICACIN
			for(int i=0; i < lObjMetadatos.length; i++){
				if(i != 0){
					lStrSQL += " OR ";
				}
				if(lObjMetadatos[i].getTipodato().equalsIgnoreCase("DATE") || lObjMetadatos[i].getTipodato().equalsIgnoreCase("TIMESTAMP")){
					if (lStrBBDD.equalsIgnoreCase("MySQL")){
						String lStrMascara = "%d/%m/%Y";
						lStrSQL += " UPPER(DATE_FORMAT("+ lObjMetadatos[i].getNomcolbd() +",'"+ lStrMascara +"')) LIKE '%"+ pStrValor.toUpperCase() +"%' ";
					} else {
						String lStrMascara = "dd/mm/rrrr HH24:MI";
						lStrSQL += " UPPER(TO_CHAR("+ lObjMetadatos[i].getNomcolbd() +",'"+ lStrMascara +"')) LIKE '%"+ pStrValor.toUpperCase() +"%' ";
					}
				}else
					if(lObjMetadatos[i].getTipodato().equalsIgnoreCase("NUMBER")){
						try{
							//pStrValor = pStrValor.replace(".", ",");
							lStrSQL += " ( "+ lObjMetadatos[i].getNomcolbd() +" IS NOT NULL AND TO_CHAR("+ lObjMetadatos[i].getNomcolbd() +", '999999999999.999999') LIKE '%"+ pStrValor +"%' ) ";
						}catch(NumberFormatException ex){
							//No ha podido parsear a entero el numero, no se puede aadir en la busqueda
							lStrSQL += " 1=0 ";
						}
					}else{
						if(lStrBBDD.equalsIgnoreCase("MySQL")){
							//vsevilla 10//11/2009 Modifcado para que no se tengan en cuenta los acentos
							lStrSQL += " UPPER("+ lObjMetadatos[i].getNomcolbd() +") LIKE '%"+ pStrValor.toUpperCase() +"%'";
						} else {
							lStrSQL += " translate(UPPER("+ lObjMetadatos[i].getNomcolbd() +"),'','AEIOUEOaeioueo') LIKE translate('%"+ pStrValor.toUpperCase() +"%','','AEIOUEOaeioueo')";
						}
					}
			}
			
			lStrSQL += " ) ";
		}
		return lStrSQL;
	}	
	

	/**
	 * Rellena Global dto.
	 *
	 * @param request
	 *            el request
	 *
	 * @throws Exception
	 *             the exception
	 */
//	protected void actualizarGlobalDTO(HttpServletRequest request) throws Exception {
//
//		HttpSession lObjSession = request.getSession();
//		String lStrActionActual = lObjSession.getAttribute("ACTION").toString();
//
//		GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO)lObjSession.getAttribute(lStrActionActual);
//
//		if(request.getParameter("agrupar")!=null)
//		{
//			if(request.getParameter("agrupar").equalsIgnoreCase(""))
//			{
//				lObjConfiguracion.setGrupo(null);
//			}
//			else
//			{
//				lObjConfiguracion.setGrupo(request.getParameter("agrupar"));
//			}
//		}
//
//		if(request.getParameter("sqlordenar")!=null)
//		{
//			if(request.getParameter("sqlordenar").equalsIgnoreCase(""))
//			{
//				lObjConfiguracion.setOrden(null);
//			}
//			else
//			{
//				lObjConfiguracion.setOrden(request.getParameter("sqlordenar"));
//			}
//		}
//
//		if(request.getParameter("columnas")!=null)
//		{
//			this.obtieneColumnas((String) request.getParameter("columnas"), lObjConfiguracion.getCampos(),lObjConfiguracion);
//		}
//
//		if(request.getParameter("filtrobusqueda")!=null){
//			lObjConfiguracion.setFiltrobusqueda(request.getParameter("filtrobusqueda"));
//		}
//		
//		if(lObjConfiguracion.getCombopuertos().equalsIgnoreCase("S")){
//			if(request.getParameter("filtroglobal")!=null&&request.getParameter("selfiltroglobal")!=null){
//				lObjConfiguracion.setCodpueselected(request.getParameter("selfiltroglobal"));
//				lObjConfiguracion.setFiltroglobal(request.getParameter("filtroglobal"));
//				lObjSession.setAttribute("filtroglobal", request.getParameter("filtroglobal"));
//				lObjSession.setAttribute("selfiltroglobal", request.getParameter("selfiltroglobal"));
//			}
//			else if(lObjSession.getAttribute("filtroglobal")!=null&&lObjSession.getAttribute("selfiltroglobal")!=null){
//				lObjConfiguracion.setCodpueselected((String)lObjSession.getAttribute("selfiltroglobal"));
//				lObjConfiguracion.setFiltroglobal((String)lObjSession.getAttribute("filtroglobal"));
//			}
//			
//			if(request.getParameter("quitafiltroglobal")!=null&&request.getParameter("quitafiltroglobal").equals("true")){
//				lObjConfiguracion.setFiltroglobal(null);
//				lObjConfiguracion.setCodpueselected(null);
//				lObjSession.removeAttribute("filtroglobal");
//				lObjSession.removeAttribute("selfiltroglobal");
//			}
//		}
//		this.obtieneWherefiltro((String) request.getParameter("wherefiltro"),(String) request.getParameter("quitafiltro"),lObjConfiguracion, (String)request.getParameter(ListadoDTO.SELFILTRO));
//		this.obtieneWherefiltrohumano((String) request.getParameter("wherefiltrohumano"), (String) request.getParameter("quitafiltro"),lObjConfiguracion);
//
//		// Guardar / Eliminar configuraci�n
//		String lStrGuardarconfiguracion = (String) request.getParameter("guardarconfiguracion");
//		String lStrEliminarconfiguracion = (String) request.getParameter("eliminarconfiguracion");
//		if (lStrGuardarconfiguracion != null) {
//			this.guardarConfiguracion(lObjConfiguracion, request);
//		}
//
//		if (lStrEliminarconfiguracion != null) {
//			this.eliminarConfiguracion(lObjConfiguracion, request);
//		}
//
////		// Obtencion de los filtros del usuario
////		UsuarioAplicacionDelegate lObjDelegate = new UsuarioAplicacionDelegate();
////		String lStrIdAplicacion = getAplicacion(request);
////
////		GuUsuapliFiltro[] lObjFiltrosUsuario = lObjDelegate.obtenerFiltrosOperador(lStrUsuario, lStrIdAplicacion,
////				this.aObjListadoDTO.getTabla());
////		ArrayList lObjFiltrosArray = AuxliarTC.transformaOperadorFiltrosArrayList(lObjFiltrosUsuario);
////		request.setAttribute(ListadoDTO.FILTROUSUARIO, lObjFiltrosArray);
//
//	}


	/**
	 * Compone el filtrofijo.
	 *
	 * @param request
	 *            el request
	 *
	 * @throws Exception
	 *             the exception
	 */
//	protected void montarfiltrofijo(HttpServletRequest request) throws Exception {
//
//		HttpSession lObjSession = request.getSession();
//		String lStrActionActual = lObjSession.getAttribute("ACTION").toString();
//
//		GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO)lObjSession.getAttribute(lStrActionActual);
//
//		if(request.getParameter(GlobalConfigDTO.PARAMSFILTROFIJO) != null)
//		{
//			try{
//
//				String lStrParams = (String)request.getParameter(GlobalConfigDTO.PARAMSFILTROFIJO);
//				lObjConfiguracion.ponerfiltrofijo(lStrParams);
//				//ALBER
//				lObjConfiguracion.setObjectoServicio(GlobalConfigDTO.PARAMSFILTROFIJO,request.getParameter(GlobalConfigDTO.PARAMSFILTROFIJO));
//
//				//RESETEAMOS LA PAGINACION
//				lObjConfiguracion.resetearPaginacion();
//			} catch (Throwable e) {
//					request.setAttribute("pStrDescError", e.getMessage());
//			}
//		}
//		else if((lObjConfiguracion!=null)&&(lObjConfiguracion.getWherefiltrofijo()!=null&&lObjConfiguracion.getWherefiltrofijo().contains("?")))
//		{
//			//traza filtrofijo incorecto
//			System.out.println("@ WARNING FILTROFIJO #################### ACTUAL-> "+lObjConfiguracion.getFiltrofijoprepared());
//			
//			//esto aunque se verifica cuando desde un mantenimiento se vuelve 
//			//al listado no es de considerar como un un comportamiento incorecto
//		}
//		else if(lObjConfiguracion!=null)
//		{
//			lObjConfiguracion.ponerfiltrofijo();
//		}
//		
//		
//		/* Para controlar el modo de padres a hijos*/
//		
//		if(request.getParameter(GlobalConfigDTO.PARAMSMODOPADRE) != null)
//		{
//			try{
//
//				lObjConfiguracion.setObjectoServicio(GlobalConfigDTO.PARAMSMODOPADRE,request.getParameter(GlobalConfigDTO.PARAMSMODOPADRE));
//
//			} catch (Throwable e) {
//					request.setAttribute("pStrDescError", e.getMessage());
//			}
//		}
//		if (lObjConfiguracion.getObjectoServicio(GlobalConfigDTO.PARAMSMODOPADRE)==null){
//			lObjConfiguracion.setObjectoServicio(GlobalConfigDTO.PARAMSMODOPADRE,"M");
//		}
//		
//		if(request.getParameter(GlobalConfigDTO.PARAMSCABECERA) != null)
//		{
//			try{
//				lObjConfiguracion.setObjectoServicio(GlobalConfigDTO.PARAMSCABECERA,request.getParameter(GlobalConfigDTO.PARAMSCABECERA));
//
//			} catch (Throwable e) {
//					request.setAttribute("pStrDescError", e.getMessage());
//			}
//		}
//
//	}

	/**
	 * Obtiene sql.
	 *
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrElegidas
	 *            el string Elegidas
	 * @param request
	 *            el request
	 *
	 * @return un objeto String
	 *
	 * @throws Exception
	 *             the exception
	 */
	protected String obtieneSQL(String pStrTabla, String pStrElegidas, HttpServletRequest request) throws Exception {

		String lStrSQL = "";

		// Pone las columnas por defecto
		this.aStrColumnaspordefecto = pStrElegidas;

		// Obtiene el objeto del listado
		String lStrNombreobjeto = "LISTADONIVEL1";
		// modif prey 16/09/2008
		if (request.getParameter("inicio") != null) {
			if (request.getParameter("nivel") == null) {
				lStrNombreobjeto = "LISTADONIVEL1";
				request.getSession().setAttribute("NOMBREOBJETOLISTADO", lStrNombreobjeto);
			} else {
				lStrNombreobjeto = request.getParameter("nivel");
				request.getSession().setAttribute("NOMBREOBJETOLISTADO", lStrNombreobjeto);
			}
		} else {
			if (request.getParameter("nivel") != null) {
				lStrNombreobjeto = request.getParameter("nivel");
				request.getSession().setAttribute("NOMBREOBJETOLISTADO", lStrNombreobjeto);
			}

		}

		this.aObjListadoDTO = this.obtenerListadoDTO(request, pStrTabla, lStrNombreobjeto);

		// Carga la configuraci�n por defecto si existe
		this.cargaConfiguracionPorDefecto(pStrTabla, request);

		// Se rellena con los par�metros del request
		this.rellenaListadoDTO(request, pStrElegidas);

		// Obtenci�n de los parametros necesarios del objeto
		String lStrSqlfiltrousuario = aObjListadoDTO.getFiltrousuario();
		String lStrSqlfiltrofijo = aObjListadoDTO.getFiltrofijo();
		String lStrSqlfiltroacceso = aObjListadoDTO.getFiltroacceso();
		String lStrIdioma = aObjListadoDTO.getFiltroIdioma();

		String lStrSqlfiltroglobal = null;
		if ((aObjListadoDTO.getCampobdfiltro() != null) && (aObjListadoDTO.getSelfiltroglobal() != null)) {
			if (aObjListadoDTO.getCampobdfiltro() != null) {
				lStrSqlfiltroglobal = aObjListadoDTO.getCampobdfiltro() + "='" + aObjListadoDTO.getSelfiltroglobal()
						+ "'";
			}
		}
		// String lStrSqlfiltroglobal = aObjListadoDTO.getFiltroglobal();
		String lStrSqlagrupar = aObjListadoDTO.getAgrupacion();
		String lStrSqlordenar = aObjListadoDTO.getOrden();

		// FILTRADO

		/*
		 * AGONZALEZ 01/12/2008 COMENTO todo ESTO PORQUE NO HAY QUIEN LO
		 * ENTIENDA
		 *
		 *
		 * String lStrSqlfiltro = ""; if ((lStrSqlfiltrofijo != null) ||
		 * (lStrSqlfiltrousuario != null) || (lStrSqlfiltroglobal != null) ||
		 * (lStrSqlfiltroacceso != null)) { lStrSqlfiltro += " WHERE "; } if
		 * (lStrSqlfiltrofijo != null) { lStrSqlfiltro += lStrSqlfiltrofijo; }
		 * if (lStrSqlfiltrousuario != null) { // FILTROUSUARIO != NULL if
		 * (lStrSqlfiltrofijo != null) { // FILTROUSUARIO != NULL && FILTROFIJO
		 * != NULL lStrSqlfiltro += " AND "; lStrSqlfiltro +=
		 * lStrSqlfiltrousuario; if (lStrSqlfiltroglobal != null) { //
		 * FILTROUSUARIO != NULL && FILTROFIJO != NULL && // FILTROGLOBAL !=
		 * NULL lStrSqlfiltro += " AND "; lStrSqlfiltro += lStrSqlfiltroglobal;
		 * } } else { // FILTROUSUARIO != NULL && FILTROFIJO == NULL
		 * lStrSqlfiltro += lStrSqlfiltrousuario; if (lStrSqlfiltroglobal !=
		 * null) { // FILTROUSUARIO != NULL && FILTROFIJO == NULL && //
		 * FILTROGLOBAL != NULL lStrSqlfiltro += " AND "; lStrSqlfiltro +=
		 * lStrSqlfiltroglobal; } } } else { // FILTROUSUARIO == NULL if
		 * (lStrSqlfiltrofijo != null) { // FILTROUSUARIO == NULL && FILTROFIJO
		 * != NULL if (lStrSqlfiltroglobal != null) { // FILTROUSUARIO == NULL
		 * && FILTROFIJO != NULL && // FILTROGLOBAL != NULL lStrSqlfiltro +=
		 * " AND "; lStrSqlfiltro += lStrSqlfiltroglobal; } } else { //
		 * FILTROUSUARIO == NULL && FILTROFIJO == NULL if (lStrSqlfiltroglobal
		 * != null) { // FILTROUSUARIO == NULL && FILTROFIJO == NULL && //
		 * FILTROGLOBAL != NULL lStrSqlfiltro += lStrSqlfiltroglobal; } } }
		 */

		// NUEVO ALBERTO 01/12/2008
		String lStrSqlfiltro = " WHERE 1=1 ";

		if (lStrSqlfiltrofijo != null) {
			lStrSqlfiltro += " AND ";
			lStrSqlfiltro += lStrSqlfiltrofijo;

		}

		if (lStrIdioma != null) {
			lStrSqlfiltro += " AND " + lStrIdioma;
		}

		if (lStrSqlfiltroglobal != null) {
			lStrSqlfiltro += " AND ";
			lStrSqlfiltro += lStrSqlfiltroglobal;

		}

		if (lStrSqlfiltrousuario != null) {
			lStrSqlfiltro += " AND ";
			lStrSqlfiltro += lStrSqlfiltrousuario;

		}

		if (lStrSqlfiltroacceso != null) {
			lStrSqlfiltro += " AND ";
			lStrSqlfiltro += lStrSqlfiltroacceso;
		}

		// AGRUPACI�N Y ORDENACI�N
		String lStrAgruparOrdenar = null;
		if ((lStrSqlagrupar != null) || (lStrSqlordenar != null)) {
			lStrAgruparOrdenar = " ORDER BY ";
		}
		if (lStrSqlagrupar != null) {
			lStrAgruparOrdenar += lStrSqlagrupar;
		}
		if (lStrSqlordenar != null) {
			if (lStrSqlagrupar != null) {
				lStrAgruparOrdenar += " , ";
				lStrAgruparOrdenar += lStrSqlordenar;
			} else {
				lStrAgruparOrdenar += lStrSqlordenar;
			}
		}

		// CONDICION GENERAL
		String lStrCondicion = "";
		if (!lStrSqlfiltro.equals("")) {
			lStrCondicion += lStrSqlfiltro;
		}

//		/* PAGINACIÓN */
//		String lStrExcel = (String) request.getParameter("excel");
//		PaginacionDTO lObjPaginacion = null;
//		if (lStrExcel != null) {
//			lObjPaginacion = new PaginacionDTO(NUM_MAX_ROWS_EXCEL);
//		} else {
//			lObjPaginacion = new PaginacionDTO(20);
//		}

		// Obtención del total de registros
		TCDelegate lObjAuxiliarListadoDelegate = new TCDelegate();
		int lIntTotReg = lObjAuxiliarListadoDelegate.obtenerNumeroRegistrosActual(pStrTabla, lStrCondicion);
		//lObjPaginacion.setRegistrosTotales(lIntTotReg);

		// 02/11/2007 prey lo hago para q cuando se haga un insert o un delete,
		// se entere el numero de registros
//		PaginacionDTO lObjPagSesion = (PaginacionDTO) request.getSession()
//				.getAttribute("PAGINACION" + lStrNombreobjeto);
//		if (lObjPagSesion != null) {
//			lObjPagSesion.setRegistrosTotales(lIntTotReg);
//		}

		// fin 02/11/2007

		// Hacer la paginación
		//lObjPaginacion.obtenerPaginacion(request, pStrTabla, lStrNombreobjeto);

		/* CREACIÓN DE LA CONSULTA DE PAGINACION */
		//int lIntIndice = lObjPaginacion.getIndice();

		// CAMBIO 18/09/2007
		//int lIntRegistrosPorPagina = (lObjPaginacion.getRegistrosPorPagina() - 1);
		// int lIntRegistrosPorPagina = lObjPaginacion.getRegistrosPorPagina();

		//String lStrBetween = lIntIndice + " and " + (lIntIndice + lIntRegistrosPorPagina);

//		if (lStrAgruparOrdenar != null) {
//			lStrSQL = "select * from ( select a.*, row_number() over (" + lStrAgruparOrdenar + ") r from " + pStrTabla
//					+ " a " + lStrCondicion + ")" + " where r between " + lStrBetween + " " + lStrAgruparOrdenar;
//		} else {
//			lStrSQL = "select * from ( select a.*, rownum r from " + pStrTabla + " a " + lStrCondicion + " )"
//					+ " where r between " + lStrBetween;
//		}

		/* ACTUALIZAR EL OBJETO request PARA LA PAGINACIÓN */
		//lObjPaginacion.salvarEstado(request);
		request.setAttribute(ListadoDTO.SELFILTRO, this.aObjListadoDTO.getSelfiltro());
		request.setAttribute(ListadoDTO.SELFILTROGLOBAL, this.aObjListadoDTO.getSelfiltroglobal());
		request.setAttribute(ListadoDTO.GRUPO, this.aObjListadoDTO.getAgrupacion());
		request.setAttribute(ListadoDTO.FILTROACTUAL, this.aObjListadoDTO.getFiltrousuario());


		return lStrSQL;
	}

	/**
	 * Obtiene datos.
	 *
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrColumnas
	 *            el string Columnas
	 * @param pStrWhere
	 *            el string Where
	 * @param pObjMetadatos
	 *            el objeto Metadatos
	 *
	 * @return un objeto HashMap
	 *
	 * @throws Exception
	 *             the exception
	 */
	private HashMap obtieneDatos(String pStrTabla, String pStrColumnas, String pStrWhere, MetadatoDTO[] pObjMetadatos)
			throws Exception {

		TCDelegate lObjAuxiliarListadoDelegate = new TCDelegate();
		return lObjAuxiliarListadoDelegate.obtieneDatos(pStrTabla, pStrColumnas, pStrWhere, pObjMetadatos);
	}

	/**
	 * Obtiene datos lupa.
	 *
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrElegidas
	 *            el string Elegidas
	 * @param request
	 *            el request
	 *
	 * @return un objeto HashMap
	 *
	 * @throws Exception
	 *             the exception
	 */
//	private HashMap obtieneDatosLupa(String pStrTabla, String pStrElegidas, HttpServletRequest request)
//			throws Exception {
//
//		String lStrSQL = "";
//
//		// Obtiene el objeto del listado
//		this.aObjListadoDTO = this.obtenerListadoDTOLupa(request, pStrTabla, "LUPA");
//
//		// Se rellena con los par�metros del request
//		this.rellenaListadoDTO(request, pStrElegidas);
//
//		// Obtenci�n de los parametros necesarios del objeto
//		String lStrSqlfiltrousuario = aObjListadoDTO.getFiltrousuario();
//		String lStrSqlfiltrofijo = aObjListadoDTO.getFiltrofijo();
//		String lStrSqlagrupar = aObjListadoDTO.getAgrupacion();
//		String lStrSqlordenar = aObjListadoDTO.getOrden();
//
//		// FILTRADO
//		String lStrSqlfiltro = "";
//		if ((lStrSqlfiltrofijo != null) || (lStrSqlfiltrousuario != null)) {
//			lStrSqlfiltro += " WHERE ";
//		}
//		if (lStrSqlfiltrofijo != null) {
//			lStrSqlfiltro += lStrSqlfiltrofijo;
//		}
//		if (lStrSqlfiltrousuario != null) {
//			if (lStrSqlfiltrofijo != null) {
//				lStrSqlfiltro += " AND ";
//				lStrSqlfiltro += lStrSqlfiltrofijo;
//			} else {
//				lStrSqlfiltro += lStrSqlfiltrousuario;
//			}
//		}
//
//		// AGRUPACI�N Y ORDENACI�N
//		String lStrAgruparOrdenar = null;
//		if ((lStrSqlagrupar != null) || (lStrSqlordenar != null)) {
//			lStrAgruparOrdenar = " ORDER BY ";
//		}
//		if (lStrSqlagrupar != null) {
//			lStrAgruparOrdenar += lStrSqlagrupar;
//		}
//		if (lStrSqlordenar != null) {
//			if (lStrSqlagrupar != null) {
//				lStrAgruparOrdenar += " , ";
//				lStrAgruparOrdenar += lStrSqlordenar;
//			} else {
//				lStrAgruparOrdenar += lStrSqlordenar;
//			}
//		}
//
//		// CONDICION GENERAL
//		String lStrCondicion = "";
//		if (!lStrSqlfiltro.equals("")) {
//			lStrCondicion += lStrSqlfiltro;
//		}
//
//		/* PAGINACI�N */
//		PaginacionDTO lObjPaginacion = new PaginacionDTO(20);
//
//		// Obtenci�n del total de registros
//		TCDelegate lObjAuxiliarListadoDelegate = new TCDelegate();
//		int lIntTotReg = lObjAuxiliarListadoDelegate.obtenerNumeroRegistrosActual(pStrTabla, lStrCondicion);
//		lObjPaginacion.setRegistrosTotales(lIntTotReg);
//
//		// Hacer la paginaci�n
//		lObjPaginacion.obtenerPaginacion(request);
//
//		/* CREACI�N DE LA CONSULTA DE PAGINACION */
//		int lIntIndice = lObjPaginacion.getIndice();
//		int lIntRegistrosPorPagina = lObjPaginacion.getRegistrosPorPagina();
//
//		String lStrBetween = lIntIndice + " and " + (lIntIndice + lIntRegistrosPorPagina);
//
//		if (lStrAgruparOrdenar != null) {
//			lStrSQL = "select * from ( select a.*, row_number() over (" + lStrAgruparOrdenar + ") r from " + pStrTabla
//					+ " a " + lStrCondicion + ")" + " where r between " + lStrBetween + " " + lStrAgruparOrdenar;
//		} else {
//			lStrSQL = "select * from ( select a.*, rownum r from " + pStrTabla + " a " + lStrCondicion + ")"
//					+ " where r between " + lStrBetween;
//		}
//
//		/* ACTUALIZAR EL OBJETO request PARA LA PAGINACI�N */
//		lObjPaginacion.salvarEstado(request);
//		request.setAttribute(ListadoDTO.SELFILTRO, this.aObjListadoDTO.getSelfiltro());
//		request.setAttribute(ListadoDTO.GRUPO, this.aObjListadoDTO.getAgrupacion());
//
//		MetadatoDTO[] lObjColumnas = (MetadatoDTO[]) this.obtenerIntercambio(pStrTabla);
//
//		TCDelegate lObjAuxDel = new TCDelegate();
//		HashMap lObjHashMap = lObjAuxDel.obtieneDatosLupa(lStrSQL, lObjColumnas);
//
//		return lObjHashMap;
//	}

	/**
	 * Obtener intercambio.
	 *
	 * @param pStrTabla
	 *            el string Tabla
	 *
	 * @return un objeto MetadatoDTO[]
	 *
	 * @throws Exception
	 *             the exception
	 */
	protected MetadatoDTO[] obtenerIntercambio(String pStrTabla) throws Exception {

		TCDelegate lObjAuxDel = new TCDelegate();
		// El objeto de representaci�n del estado del listado ya existe,
		// puesto
		// que se llama primero
		// a obtener DATOS que a obtener METADATOS.
		String lStrAgrupar = this.aObjListadoDTO.getAgrupacion();
		String lStrElegidas = this.aObjListadoDTO.getColumnas();

		// Ponemos primera la columna por la que se agrupa (si es que se est�
		// agrupando)
		lStrElegidas = AuxiliarMVC.cambiosVisualizarAgrupacion(lStrAgrupar, lStrElegidas);

		return lObjAuxDel.obtenerIntercambio(pStrTabla, lStrElegidas,null);
	}


	/**
	 * Obtener intercambio.
	 *
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrElegidas
	 *            el string Elegidas
	 *
	 * @return un objeto MetadatoDTO[]
	 *
	 * @throws Exception
	 *             the exception
	 */
	protected MetadatoDTO[] obtenerIntercambio(String pStrTabla, String pStrElegidas) throws Exception {
		TCDelegate lObjAuxDel = new TCDelegate();
		return lObjAuxDel.obtenerIntercambio(pStrTabla, pStrElegidas,null);
	}

	/**
	 * Obtener intercambio
	 *
	 * @param pStrTabla
	 * 			el string Tabla
	 *
	 * @param pStrElegidas
	 * 			el string Elegidas
	 *
	 * @param pStrPrefijo
	 * 			Prefijo opcional para buscar las etiquetas en el properties
	 *
	 * @return un objeto MetadatoDTO[]
	 *
	 * @throws ApplicationCoreException
	 * 				the application exception
	 */
	protected MetadatoDTO[] obtenerIntercambio(String pStrTabla, String pStrElegidas, String pStrPrefijo) throws Exception {
		TCDelegate lObjAuxDel = new TCDelegate();
		return lObjAuxDel.obtenerIntercambio(pStrTabla, pStrElegidas, pStrPrefijo);
	}

	/**
	 * Obtener intercambio lupa.
	 *
	 * @param pStrTabla
	 *            el string Tabla
	 *
	 * @return un objeto MetadatoDTO[]
	 *
	 * @throws Exception
	 *             the exception
	 */
	private MetadatoDTO[] obtenerIntercambioLupa(String pStrTabla) throws Exception {

		TCDelegate lObjAuxDel = new TCDelegate();
		return lObjAuxDel.obtenerIntercambio(pStrTabla, "*", null);
	}

	/**
	 * Obtiene ordenar.
	 *
	 * @param pStrOrdenar
	 *            el string Ordenar
	 *
	 * @return un objeto String
	 */
	public String obtieneOrdenar(String pStrOrdenar) {

		if (pStrOrdenar == null) {
			pStrOrdenar = this.aObjListadoDTO.getOrden();
		} else {
			// Se env�a la orden de no ordenar
			if (pStrOrdenar.equalsIgnoreCase("")) {
				pStrOrdenar = null;
			}
			this.aObjListadoDTO.setOrden(pStrOrdenar);
		}
		return pStrOrdenar;
	}

	/**
	 * Obtiene agrupar.
	 *
	 * @param pStrAgrupar
	 *            el string Agrupar
	 *
	 * @return un objeto String
	 */
	public String obtieneAgrupar(String pStrAgrupar) {

		if (pStrAgrupar == null) {
			pStrAgrupar = this.aObjListadoDTO.getAgrupacion();
		} else {
			// Se env�a la orden de no agrupar
			if (pStrAgrupar.equalsIgnoreCase("")) {
				pStrAgrupar = null;
			}
			this.aObjListadoDTO.setAgrupacion(pStrAgrupar);
		}
		return pStrAgrupar;
	}

	/**
	 * Obtiene columnas.
	 *
	 * @param pStrColumnas
	 *            el string Columnas
	 * @param pStrElegidas
	 *            el string Elegidas
	 *
	 * @return un objeto String
	 */
	public String obtieneColumnas(String pStrColumnas, String pStrElegidas) {

		if (pStrColumnas == null) {
			// S�lo para la primera vez que se entra al listado
			if (this.aObjListadoDTO.getColumnas() == null) {
				this.aObjListadoDTO.setColumnas(pStrElegidas);
			}
		} else {
			this.aObjListadoDTO.setColumnas(pStrColumnas);
		}
		pStrColumnas = this.aObjListadoDTO.getColumnas();
		return pStrColumnas;
	}

	/**
	 * Obtiene wherefiltrohumano.
	 *
	 * @param pStrWherefiltrohumano
	 *            el string Wherefiltrohumano
	 * @param pStrQuitafiltro
	 *            el string Quitafiltro
	 *
	 * @return un objeto String
	 */
	public String obtieneWherefiltrohumano(String pStrWherefiltrohumano, String pStrQuitafiltro) {

		if (pStrWherefiltrohumano == null) {
			pStrWherefiltrohumano = this.aObjListadoDTO.getFiltrohumano();
		} else {
			/*
			 * String lStrWhereensesion = this.aObjListadoDTO.getFiltrohumano();
			 * if(lStrWhereensesion!=null){ pStrWherefiltrohumano =
			 * lStrWhereensesion + " Y " + pStrWherefiltrohumano; }
			 */
			// pStrWherefiltrohumano = pStrWherefiltrohumano.replaceAll("'",
			// "''");
			this.aObjListadoDTO.setFiltrohumano(pStrWherefiltrohumano);
		}
		// Se env�a la orden de quitar filtros
		if (pStrQuitafiltro != null) {
			pStrWherefiltrohumano = null;
		}
		return pStrWherefiltrohumano;
	}

	/**
	 * Obtiene nombrefiltro.
	 *
	 * @param pStrNombrefiltro
	 *            el string Nombrefiltro
	 * @param pStrQuitafiltro
	 *            el string Quitafiltro
	 *
	 * @return un objeto String
	 */
	public String obtieneNombrefiltro(String pStrNombrefiltro, String pStrQuitafiltro) {

		if (pStrNombrefiltro == null) {
			pStrNombrefiltro = this.aObjListadoDTO.getNombrefiltro();
		} else {
			/*
			 * String lStrWhereensesion = this.aObjListadoDTO.getNombrefiltro();
			 * if(lStrWhereensesion!=null){ pStrNombrefiltro = lStrWhereensesion
			 * + " , " + pStrNombrefiltro; }
			 */
			this.aObjListadoDTO.setNombrefiltro(pStrNombrefiltro);
		}
		// Se env�a la orden de quitar filtros
		if (pStrQuitafiltro != null) {
			pStrNombrefiltro = null;
		}
		return pStrNombrefiltro;
	}

	/**
	 * Obtiene wherefiltro.
	 *
	 * @param pStrWherefiltro
	 *            el string Wherefiltro
	 * @param pStrQuitafiltro
	 *            el string Quitafiltro
	 *
	 * @return un objeto String
	 *
	 * @throws Exception
	 *             the exception
	 */
	public String obtieneWherefiltro(String pStrWherefiltro, String pStrQuitafiltro) throws Exception {

		if (pStrWherefiltro == null) {
			pStrWherefiltro = this.aObjListadoDTO.getFiltrousuario();
		} else {
			/*
			 * String lStrWhereensesion =
			 * this.aObjListadoDTO.getFiltrousuario();
			 * if(lStrWhereensesion!=null){ pStrWherefiltro = lStrWhereensesion
			 * + " AND " + pStrWherefiltro; }
			 */
			this.aObjListadoDTO.setFiltrousuario(pStrWherefiltro);
		}
		// Se env�a la orden de quitar filtros
		if (pStrQuitafiltro != null) {
			pStrWherefiltro = null;
		}

		// Sustituimos los $$ por dos comillas simples para la sql
		/*
		 * if (pStrWherefiltro != null) { pStrWherefiltro =
		 * pStrWherefiltro.replaceAll("'", "''"); //pStrWherefiltro =
		 * pStrWherefiltro.replaceAll("@2@", "#%"); //pStrWherefiltro =
		 * pStrWherefiltro.replaceAll("@@22@@", " ESCAPE '#' "); }
		 */

		return pStrWherefiltro;
	}

	/**
	 * Obtiene wherefijo.
	 *
	 * @param pStrWherefijo
	 *            el string Wherefijo
	 * @param pStrIdioma
	 *            el string Idioma
	 * @param request
	 *            el request
	 *
	 * @return un objeto String
	 *
	 * @throws Exception
	 *             the exception
	 */
	public String obtieneWherefijo(String pStrWherefijo, String pStrIdioma, HttpServletRequest request)
			throws Exception {

		boolean lBolSinWhere = (pStrWherefijo == null);

		if (lBolSinWhere && (this.aObjListadoDTO.getFiltrofijo() != null)) {
			if (pStrWherefijo == null) {
				pStrWherefijo = this.aObjListadoDTO.getFiltrofijo();
			} else {
				pStrWherefijo += " AND " + this.aObjListadoDTO.getFiltrofijo();
			}
		}
		return pStrWherefijo;
	}

	public String obtieneWhereIdioma(String pStrIdioma, String pStrInicio, HttpServletRequest request) throws Exception {
		String lStrIdioma = aObjListadoDTO.getFiltroIdioma();

		if (pStrInicio != null) {
			if (pStrIdioma != null && pStrIdioma.equalsIgnoreCase("si")) {
				lStrIdioma = " CODIDIOMA='" + this.getIdioma(request) + "' ";
			} else {
				lStrIdioma = " 1 = 1 ";
			}
		} else {
			if (lStrIdioma == null && pStrIdioma != null && pStrIdioma.equalsIgnoreCase("si")) {
				lStrIdioma = " CODIDIOMA='" + this.getIdioma(request) + "' ";
			}
			// Comprobamos si idioma entra como no
			if (pStrIdioma != null && pStrIdioma.equalsIgnoreCase("no")) {
				lStrIdioma = " 1=1 ";
			}
		}

		return lStrIdioma;

	}

	/**
	 * Obtiene campobdfiltro.
	 *
	 * @param pStrCampobdfiltro
	 *            el string Campobdfiltro
	 *
	 * @return un objeto String
	 *
	 * @throws Exception
	 *             the exception
	 */
	public String obtieneCampobdfiltro(String pStrCampobdfiltro) throws Exception {

		if (pStrCampobdfiltro == null) {
			pStrCampobdfiltro = this.aObjListadoDTO.getCampobdfiltro();
		} else {
			/*
			 * String lStrWhereensesion =
			 * this.aObjListadoDTO.getFiltrousuario();
			 * if(lStrWhereensesion!=null){ pStrWherefijo = lStrWhereensesion +
			 * " AND " + pStrWherefijo; }
			 */
			this.aObjListadoDTO.setCampobdfiltro(pStrCampobdfiltro);
		}

		return pStrCampobdfiltro;
	}

	/**
	 * Obtiene whereglobal.
	 *
	 * @param pStrWhereglobal
	 *            el string Whereglobal
	 * @param pStrQuitafiltro
	 *            el string Quitafiltro
	 *
	 * @return un objeto String
	 *
	 * @throws Exception
	 *             the exception
	 */
	public String obtieneWhereglobal(String pStrWhereglobal, String pStrQuitafiltro) throws Exception {

		if (pStrWhereglobal == null) {
			pStrWhereglobal = this.aObjListadoDTO.getFiltroglobal();
		} else {
			/*
			 * String lStrWhereensesion =
			 * this.aObjListadoDTO.getFiltrousuario();
			 * if(lStrWhereensesion!=null){ pStrWhereglobal = lStrWhereensesion
			 * + " AND " + pStrWhereglobal; }
			 */
			this.aObjListadoDTO.setFiltroglobal(pStrWhereglobal);
		}
		// Se env�a la orden de quitar filtros
		if (pStrQuitafiltro != null) {
			pStrWhereglobal = null;
		}

		return pStrWhereglobal;
	}

	/**
	 * Obtiene selfiltro.
	 *
	 * @param pStrSelfiltro
	 *            el string Selfiltro
	 * @param pStrQuitafiltro
	 *            el string Quitafiltro
	 *
	 * @return un objeto String
	 */
	public String obtieneSelfiltro(String pStrSelfiltro, String pStrQuitafiltro) {

		if (pStrSelfiltro == null) {
			pStrSelfiltro = this.aObjListadoDTO.getSelfiltro();
		} else {
			this.aObjListadoDTO.setSelfiltro(pStrSelfiltro);
		}
		// Se env�a la orden de quitar filtros
		if (pStrQuitafiltro != null) {
			pStrSelfiltro = null;
		}
		return pStrSelfiltro;
	}

	/**
	 * Obtiene selfiltroglobal.
	 *
	 * @param pStrSelfiltro
	 *            el string Selfiltro
	 * @param pStrQuitafiltro
	 *            el string Quitafiltro
	 *
	 * @return un objeto String
	 */
	public String obtieneSelfiltroglobal(String pStrSelfiltro, String pStrQuitafiltro) {

		if (pStrSelfiltro == null) {
			pStrSelfiltro = this.aObjListadoDTO.getSelfiltroglobal();
		} else {
			this.aObjListadoDTO.setSelfiltroglobal(pStrSelfiltro);
		}
		// Se env�a la orden de quitar filtros
		if (pStrQuitafiltro != null) {
			pStrSelfiltro = null;
		}
		return pStrSelfiltro;
	}

	/**
	 * Lanza los errores
	 *
	 * @param pObjError
	 * @param lObjRequest
	 */
	protected void lanzarError(ApplicationCoreException pObjError, HttpServletRequest pObjRequest) {

		aStrForward = "error";
		if (pObjRequest.getParameter("popup") != null || esPopup) {
			aStrForward = "errorpopup";
		}

		int lIntCodigo = pObjError.getCodigo();

		if ((aStrForward != null) && (aStrForward.contains("popup"))) {
			aStrForward = "errorpopup";
		}

		switch (lIntCodigo) {
		case ApplicationCoreException.ERROR_ACCESO_DATOS:
			pObjRequest.setAttribute("pStrDescError", "error.BD");
			break;
		case ApplicationCoreException.SINSESION:
			aStrForward = "error";
			pObjRequest.setAttribute("pStrDescError", "error.sinsesion");
			break;
		case ApplicationCoreException.SINPERMISO:
			pObjRequest.setAttribute("pStrDescError", "error.sinpermiso");
			break;
		case ApplicationCoreException.REFERENCIAYAEXISTE:
			pObjRequest.setAttribute("pStrDescError", "error.lareferenciayaexiste");
			break;
		case ApplicationCoreException.MAXFILESIZE:
			pObjRequest.setAttribute("pStrDescError", "error.maxfilesize");
			break;
		case ApplicationCoreException.ERROR_SIN_USUARIO_ASIGNADO:
			// Redirigimos a la pagina de inicio
			aStrForward = "/jsp/login.jsp";
			pObjRequest.setAttribute("pStrDescError", "error.sinoperador");
			break;
		case ApplicationCoreException.ERROR_USUARIO_ASIGNADO:
			pObjRequest.setAttribute("pStrDescError", "rol.eliminar.asignado");
			break;
		case ApplicationCoreException.ERROR_USUARIO_BLOQUEADO:
			// Redirigimos a la pagina de inicio
			aStrForward = "/jsp/login.jsp";
			pObjRequest.setAttribute("pStrDescError", "error.operadorBloqueado");
			break;

		case ApplicationCoreException.NO_EXISTE_USUARIO_LDAP:
			pObjRequest.setAttribute("pStrDescError", "error.copiaoperador.noexisteLDAP");
			break;
		case ApplicationCoreException.EXISTE_USUARIO_BD:
			aStrForward = "error";
			pObjRequest.setAttribute("pStrDescError", "error.copiaoperador.existe");
			break;
		case ApplicationCoreException.NOEXISTEUSUARIOLDAP:
			pObjRequest.setAttribute("pStrDescError", "error.noexisteusuarioldap");
			break;
		case ApplicationCoreException.ERROR_RESTRICCION_INTEGRIDAD:
			pObjRequest.setAttribute("pStrDescError", "error.restriccion.integridad");
			break;			
		case ApplicationCoreException.ERROR_CONCURRENCIA:
			aStrForward = "errorconcurrencia";
			if (pObjRequest.getParameter("popup") != null || esPopup) {
				aStrForward = "errorconcurrenciapopup";
			}

			if ((aStrForward != null) && (aStrForward.contains("popup"))) {
				aStrForward = "errorconcurrenciapopup";
			}
			pObjRequest.setAttribute("pStrDescError", "error.concurrencia");
			break;
		case ApplicationCoreException.ERROR_DOCUMENTOS_ASOCIADOS:
			pObjRequest.setAttribute("pStrDescError", "error.ERROR_DOCUMENTOS_ASOCIADOS");
			break;
		default:
			if (!lanzarErrorLocal(pObjError, pObjRequest)){
				pObjRequest.setAttribute("pStrDescError", "error.desconocido");
			}
			break;
		}

		try {

			//aObjLog.error(pObjError);

		} catch (Throwable e) {
			//aObjLog.error(e.toString());
		}
	}

	/**
	 * Lanzar error local.
	 *
	 * @param pObjError
	 *            la clase excepcion
	 * @param pObjRequest
	 *            el request
	 * @return boolean
	 *            es una excepcin local controlada o no
	 *
	*/
	public boolean lanzarErrorLocal(ApplicationCoreException pObjError, HttpServletRequest pObjRequest) {
		return false;
	}

	/**
	 * Devuelve el login del usuario logeado
	 *
	 * @return
	 */
	protected String getOperador(HttpServletRequest pObjRequest) throws Exception {
		String lStrIdOperador ="";
		if (pObjRequest.getSession()!=null && pObjRequest.getSession().getAttribute("USR")!=null){
			lStrIdOperador = (String) pObjRequest.getSession().getAttribute("USR");
		}
		else{
			lStrIdOperador = "";
			//lStrIdOperador = SecurityContextHolder.getContext().getAuthentication().getName();
		}
		return lStrIdOperador;
	}

	/**
	 * Obtiene el aplicacion.
	 *
	 * @param pObjRequest
	 *            el objeto Request
	 *
	 * @return el aplicacion
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	protected String getAplicacion(HttpServletRequest pObjRequest) throws ApplicationCoreException {

		String lStrIdAplicacion = (String) pObjRequest.getSession().getAttribute("IDAPLICACION");
		return lStrIdAplicacion;
	}

	/**
	 * Obtiene el idioma.
	 *
	 * @param pObjRequest
	 *            el objeto Request
	 *
	 * @return el idioma
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	protected String getIdioma(HttpServletRequest pObjRequest) throws ApplicationCoreException {

		String lStrIdIdioma = (String) pObjRequest.getSession().getAttribute("IDIOMA");
		return lStrIdIdioma;
	}

	/**
	 * Obtiene el usuario general.
	 *
	 * @return el usuario general
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	protected String getUsuarioGeneral() throws ApplicationCoreException {

		Properties lObjProperties = Auxiliar
				.cargarFicheroPropiedades("aplicacion.properties");
		return (String) lObjProperties.get("id.tipoDeVinculoUSUARIOGENERAL");
	}

	/**
	 * Obtiene el vinculo cliente.
	 *
	 * @return el vinculo cliente
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	protected String getVinculoCliente() throws ApplicationCoreException {

		Properties lObjProperties = Auxiliar
				.cargarFicheroPropiedades("aplicacion.properties");
		return (String) lObjProperties.get("id.tipoDeVinculoCLIENTE");
	}

	/**
	 * Buscar descripcion ajax.
	 *
	 * @param mapping
	 *            el mapping
	 * @param form
	 *            el form
	 * @param request
	 *            el request
	 * @param response
	 *            el response
	 *
	 * @return un objeto ActionForward
	 *
	 * @throws Exception
	 *             the exception
	 */
	public ActionForward buscarDescripcionAJAX(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		aStrForward = "/xmlshow";
		String lStrDesc = "";

		try {
			String lStrSQL = (String) request.getParameter("sql");
			int lIntIdLupa = Integer.valueOf((String) request.getParameter("numColumnas"));

			TCDelegate lObjDeleg = new TCDelegate();
			lStrDesc = lObjDeleg.obtieneDescripcion(lStrSQL, lIntIdLupa);

		} catch (Throwable e) {
			e.printStackTrace();
		}

		response.setContentType("text/xml");
		request.setAttribute("strInput", lStrDesc);

		return new ActionForward(aStrForward);
	}


	public ActionForward compruebaNombreFiltro(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		aStrForward = "/xmlshow";
		String lStrDesc = "";

		try {
			String lStrNombre = (String) request.getParameter("nombre");
			String lStrIdOperador = getOperador(request);
			String lStrIdAplicacion = getAplicacion(request);
			String lStrIdInforme = aObjListadoDTO.getTabla();

//			UsuarioAplicacionDelegate lObjDeleg = new UsuarioAplicacionDelegate();
//			boolean lBolExiste = lObjDeleg.existeNombreFiltro(lStrIdOperador, lStrNombre, lStrIdAplicacion,
//					lStrIdInforme);
//			if (lBolExiste) {
//				lStrDesc = "EXISTE";
//			} else {
//				lStrDesc = "NOEXISTE";
//			}

		} catch (Throwable e) {
			e.printStackTrace();
			lStrDesc = "EXCEPTION";
		}

		response.setContentType("text/xml");
		request.setAttribute("strInput", lStrDesc);

		return new ActionForward(aStrForward);
	}

	public ActionForward comboDependiente(ActionMapping mapping, ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws Exception {

		aStrForward = "/xmlshow";
		String lStrXML = "";

		try {
			String lStrSQL = (String) request.getParameter("sql");

			TCDelegate lObjDeleg = new TCDelegate();
			lStrXML = lObjDeleg.obtieneComboDependiente(lStrSQL);

		} catch (Throwable e) {
			e.printStackTrace();
			lStrXML = "EXCEPTION";
		}

		response.setContentType("text/xml");
		request.setAttribute("strInput", lStrXML);

		return new ActionForward(aStrForward);
	}



	/**
	 * Agrupar.
	 *
	 * @param mapping
	 *            el mapping
	 * @param form
	 *            el form
	 * @param request
	 *            el request
	 * @param response
	 *            el response
	 *
	 * @return un objeto ActionForward
	 */
//	public ActionForward agrupar(ActionMapping mapping, ActionForm form, HttpServletRequest request,
//			HttpServletResponse response) {
//
//		aStrForward = "agrupar";
//
//		try {
//
//			HttpSession lObjSession = request.getSession();
//			String lStrActionActual = (String) lObjSession.getAttribute("ACTION");
//			GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO) lObjSession.getAttribute(lStrActionActual);
//
//			String lStrTabla = lObjConfiguracion.getTabla();
//
//			TCDelegate lObjAuDe = new TCDelegate();
//
//			// Obtiene un HashMap con todas las filas de la tabla
//			HashMap lObjColumnas = lObjAuDe.getTodasColumnas(lStrTabla);
//
//			lObjColumnas = this.excluirColumnasOcultas(lStrTabla,lObjColumnas,lObjConfiguracion);
//			
//			request.setAttribute("pStrSeleccionada", lObjConfiguracion.getGrupo());
//			request.setAttribute("pObjColumnas", lObjColumnas);
//			request.setAttribute("pStrAction", lStrActionActual);
//			request.setAttribute("pStrHandler", lObjConfiguracion.getHandlerparameter());
//		} catch (ApplicationCoreException e) {
//			lanzarError(e, request);
//		} catch (Throwable e) {
//			ApplicationCoreException ex = new ApplicationCoreException(
//					ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(), this.getClass().getSimpleName(),
//					"agrupar");
//			lanzarError(ex, request);
//		} finally {
//			ActionForward lObjRetorno = new ActionForward(aStrForward);
//			lObjRetorno.setContextRelative(true);
//			return lObjRetorno;
//		}
//	}


	/**
	 * Ordenar.
	 *
	 * @param mapping
	 *            el mapping
	 * @param form
	 *            el form
	 * @param request
	 *            el request
	 * @param response
	 *            el response
	 *
	 * @return un objeto ActionForward
	 *
	 * @throws Exception
	 *             the exception
	 */
//	public ActionForward ordenar(ActionMapping mapping, ActionForm form, HttpServletRequest request,
//			HttpServletResponse response) throws Exception {
//
//		aStrForward = "ordenar";
//
//		try {
//			HttpSession lObjSession = request.getSession();
//			String lStrActionActual = (String) lObjSession.getAttribute("ACTION");
//			GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO) lObjSession.getAttribute(lStrActionActual);
//
//			String lStrTabla = lObjConfiguracion.getTabla();
//
//			TCDelegate lObjTCDelegate = new TCDelegate();
//			// Obtiene un HashMap con todas las filas de la tabla
//			HashMap lObjColumnas = lObjTCDelegate.getTodasColumnas(lStrTabla);
//			
//			lObjColumnas = this.excluirColumnasOcultas(lStrTabla,lObjColumnas,lObjConfiguracion);
//			
//			String lStrOrdenActual = lObjConfiguracion.getOrden();
//
//			CodigoDescripcionDTO[] lObjOrdenActualNombre = null;
//			if ((lStrOrdenActual != null) && (!lStrOrdenActual.equals("null"))&& (!lStrOrdenActual.equals(""))) {
//				lStrOrdenActual = lStrOrdenActual.trim();
//				String[] lObjClausulas = lStrOrdenActual.split(",");
//				String lStrClausula;
//				lObjOrdenActualNombre = new CodigoDescripcionDTO[lObjClausulas.length];
//				for (int i = 0; i < lObjClausulas.length; i++) {
//					lStrClausula = lObjClausulas[i];
//					lStrClausula = lStrClausula.trim();
//					String[] lObjConjunto = lStrClausula.split(" ");
//					lObjOrdenActualNombre[i] = new CodigoDescripcionDTO();
//					lObjOrdenActualNombre[i].setAStrCodigo(lStrTabla + "." + lObjConjunto[0]);
//					
//					//AGONZALEZ - Falla si no tiene descriptor
//					String lStrDesOrden = "ASC";
//					if (lObjConjunto.length>1){
//						lStrDesOrden = lObjConjunto[1];
//					}
//					if (i < lObjClausulas.length - 1) {
//						lObjOrdenActualNombre[i].setAStrDescripcion(" = " + lStrDesOrden + ",");
//					} else {
//						lObjOrdenActualNombre[i].setAStrDescripcion(" = " + lStrDesOrden);
//					}
//					
//				}
//			} else {
//				lStrOrdenActual = "";
//				lObjOrdenActualNombre = new CodigoDescripcionDTO[0];
//			}
//
//			request.setAttribute("pStrOrdenActual", lStrOrdenActual);
//			request.setAttribute("pObjOrdenActualNombre", lObjOrdenActualNombre);
//			request.setAttribute("lObjColumnas", lObjColumnas);
//			request.setAttribute("pStrAction", lStrActionActual);
//			request.setAttribute("pStrHandler", lObjConfiguracion.getHandlerparameter());
//		} catch (ApplicationCoreException e) {
//			lanzarError(e, request);
//			aStrForward = "errorpopup";
//		} catch (Throwable e) {
//			ApplicationCoreException ex = new ApplicationCoreException(
//					ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(), this.getClass().getSimpleName(),
//					"ordenar");
//			lanzarError(ex, request);
//			aStrForward = "errorpopup";
//		} finally {
//			ActionForward lObjRetorno = new ActionForward(aStrForward);
//			lObjRetorno.setContextRelative(true);
//			return lObjRetorno;
//		}
//	}


	/**
	 * Columnas.
	 *
	 * @param mapping
	 *            el mapping
	 * @param form
	 *            el form
	 * @param request
	 *            el request
	 * @param response
	 *            el response
	 *
	 * @return un objeto ActionForward
	 *
	 * @throws Exception
	 *             the exception
	 */
//	public ActionForward columnas(ActionMapping mapping, ActionForm form, HttpServletRequest request,
//			HttpServletResponse response) throws Exception {
//
//		aStrForward = "columnas";
//
//		try {
//
//			HttpSession lObjSession = request.getSession();
//			String lStrActionActual = (String) lObjSession.getAttribute("ACTION");
//			GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO) lObjSession.getAttribute(lStrActionActual);
//
//			String lStrTabla = lObjConfiguracion.getTabla();
//			String lStrVisibles = (String) request.getParameter("visibles");
//
//			TCDelegate lObjAuDe = new TCDelegate();
//			ArrayList lColCampos = lObjAuDe.obtenerVisiblesNoVisibles(lStrTabla, lStrVisibles);
//
//			lColCampos = this.excluirColumnasOcultas(lStrTabla,lColCampos,lObjConfiguracion);
//			
//			request.setAttribute("pObjVisibles", lColCampos.get(0));
//			request.setAttribute("pObjNoVisibles", lColCampos.get(1));
//			request.setAttribute("pStrAction", lStrActionActual);
//			request.setAttribute("pStrHandler", lObjConfiguracion.getHandlerparameter());
//		} catch (ApplicationCoreException e) {
//			lanzarError(e, request);
//			aStrForward = "errorpopup";
//		} catch (Throwable e) {
//			ApplicationCoreException ex = new ApplicationCoreException(
//					ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(), this.getClass().getSimpleName(),
//					"columnas");
//			lanzarError(ex, request);
//			aStrForward = "errorpopup";
//		} finally {
//			ActionForward lObjRetorno = new ActionForward(aStrForward);
//			lObjRetorno.setContextRelative(true);
//			return lObjRetorno;
//		}
//	}


	/**
	 * Filtro.
	 *
	 * @param mapping
	 *            el mapping
	 * @param form
	 *            el form
	 * @param request
	 *            el request
	 * @param response
	 *            el response
	 *
	 * @return un objeto ActionForward
	 *
	 * @throws Exception
	 *             the exception
	 */
//	public ActionForward filtro(ActionMapping mapping, ActionForm form, HttpServletRequest request,
//			HttpServletResponse response) throws Exception {
//
//		aStrForward = "filtro";
//
//		try {
//
//			HttpSession lObjSession = request.getSession();
//			String lStrActionActual = (String) lObjSession.getAttribute("ACTION");
//			GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO) lObjSession.getAttribute(lStrActionActual);
//
//			String lStrTabla = lObjConfiguracion.getTabla();
//			
//			/*
//			 * El parametro "quitadas" parece q no se est usando nunca
//			 * 
//			 * String lStrQuitadas = (String) request.getParameter("quitadas");
//			 */
//			String lStrQuitadas = lObjConfiguracion.getOcultos();
//						
//			HashMap lObjHashMap = new HashMap();
//			TCDelegate lObjAuDe = new TCDelegate();
//			MetadatoDTO[] lObjColumnas = lObjAuDe.obtenerIntercambio(lStrTabla, "*", null);
//
//			if ((lStrQuitadas != null) && (!(lStrQuitadas.equalsIgnoreCase("undefined"))) && (!lStrQuitadas.equalsIgnoreCase(""))) {
//				lObjColumnas = quitarColumnas(lObjColumnas, lStrQuitadas);
//			}
//
//			/*
//			 * lStrWhereSql = lStrWhereSql.replaceAll("#%", "@2@");
//			 * lStrWhereSql = lStrWhereSql.replaceAll("ESCAPE '#'",
//			 * "@@22@@");
//			 */
//
//			/*
//			 * if (lStrWhereSql != null) { lStrWhereSql =
//			 * lStrWhereSql.replaceAll("%", "%25"); }
//			 */
//
//			request.setAttribute("pObjColumnas", lObjColumnas);
//			request.setAttribute("pObjConfiguracion", lObjConfiguracion);
//		} catch (ApplicationCoreException e) {
//			lanzarError(e, request);
//			aStrForward = "errorpopup";
//		} catch (Throwable e) {
//			ApplicationCoreException ex = new ApplicationCoreException(
//					ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(), this.getClass().getSimpleName(),
//					"filtro");
//			lanzarError(ex, request);
//			aStrForward = "errorpopup";
//		} finally {
//			ActionForward lObjRetorno = new ActionForward(aStrForward);
//			lObjRetorno.setContextRelative(true);
//			return lObjRetorno;
//		}
//	}


	/**
	 * Obtiene wherefiltro.
	 *
	 * @param pStrWherefiltro
	 *            el string Wherefiltro
	 * @param pStrQuitafiltro
	 *            el string Quitafiltro
	 *
	 * @return un objeto String
	 *
	 * @throws Exception
	 *             the exception
	 */
//	public String obtieneWherefiltro(String pStrWherefiltro, String pStrQuitafiltro, GlobalConfigDTO pObjConfiguracion, String pStrSelFiltro) throws Exception {
//
//		if ((pStrWherefiltro != null) && (pStrSelFiltro==null) && (pStrQuitafiltro == null)){
//			//el usuario est filtrando
//			pObjConfiguracion.setWhereActualUsuario(pStrWherefiltro);
//			//RESETEAMOS LA PAGINACION
//			pObjConfiguracion.resetearPaginacion();
//		}
//		else if((pStrSelFiltro!=null) && (pStrQuitafiltro == null)){
//			//el usuario est aplicando un filtro del combo
//						
//			pObjConfiguracion.resetearFiltros();
//			pObjConfiguracion.setIdFiltroAplicado(pStrSelFiltro);
//			pObjConfiguracion.setWhereHumanoActualUsuario(pObjConfiguracion.getFiltroHumanoUsuario(pObjConfiguracion.getFiltroAplicado(), ""));
//			pObjConfiguracion.setWhereActualUsuario(pStrWherefiltro);
//			
//			//RESETEAMOS LA PAGINACION
//			pObjConfiguracion.resetearPaginacion();
//		}
//		else if (pStrQuitafiltro != null) {
//			// Se envia la orden de quitar filtros
//			pObjConfiguracion.resetearFiltros();
//			pObjConfiguracion.setIdFiltroAplicado("");
//			
//			//RESETEAMOS LA PAGINACION
//			pObjConfiguracion.resetearPaginacion();
//		}
//		else if((pStrWherefiltro == null) && (pStrQuitafiltro==null) && (pStrSelFiltro==null))
//		{
//			/*
//			 * el usuario no est haciendo ninguna operacion con los filtros
//			 * puede estar entrando en el listado por 1 vez o estar utilizando las funcionalidades
//			 * del TC (agregar/quitar columnas, paginacion etc.)
//			 * 
//			 * Tenemos solo que asegurarnos que si hay un filtro seleccionado esto se est aplicando
//			 * el resto lo dejamos como est
//			 */
//
//			String idfiltro = pObjConfiguracion.getFiltroAplicado();
//			if((!idfiltro.equalsIgnoreCase("")) && (!idfiltro.equalsIgnoreCase("0")))
//			{
//				if(pObjConfiguracion.getTipoFiltroAplicado().equalsIgnoreCase(GlobalConfigDTO.PREDEFINIDO))
//				{
//					pObjConfiguracion.setWhereActual(pObjConfiguracion.getFiltroPrdedefinido(idfiltro).getWherefiltro());
//				}
//				else if (pObjConfiguracion.getTipoFiltroAplicado().equalsIgnoreCase(GlobalConfigDTO.USUARIO))
//				{
//					pObjConfiguracion.setWhereActual(pObjConfiguracion.getFiltroUsuario(idfiltro).getWhefiltro());
//				}
//			}
//
//		}
//
//		return pObjConfiguracion.getWhereActual();
//	}

	/**
	 * Obtiene wherefiltrohumano.
	 *
	 * @param pStrWherefiltrohumano
	 *            el string Wherefiltrohumano
	 * @param pStrQuitafiltro
	 *            el string Quitafiltro
	 *
	 * @return un objeto String
	 */
//	public String obtieneWherefiltrohumano(String pStrWherefiltrohumano, String pStrQuitafiltro, GlobalConfigDTO pObjConfiguracion) {
//
//		if (pStrWherefiltrohumano != null) {
//			pObjConfiguracion.setWhereHumanoActualUsuario(pStrWherefiltrohumano); 
//		}
//		else if (pStrQuitafiltro != null) {
//			// Se env�a la orden de quitar filtros
//			pObjConfiguracion.resetearFiltrosHumanos();
//		}
//		else if((pStrWherefiltrohumano == null) && (pStrQuitafiltro==null))
//		{
//			/*
//			 * el usuario no est haciendo ninguna operacion con los filtros
//			 * puede estar entrando en el listado por 1 vez o estar utilizando las funcionalidades
//			 * del TC (agregar/quitar columnas, paginacion etc.)
//			 * 
//			 * Tenemos solo que asegurarnos que si hay un filtro seleccionado esto se est aplicando
//			 * el resto lo dejamos como est
//			 */
//			
//			//si hay q aplicar un filtro por defecto lo aplicamos
//			String idfiltro = pObjConfiguracion.getFiltroAplicado();
//			if((!idfiltro.equalsIgnoreCase("")) && (!idfiltro.equalsIgnoreCase("0")))
//			{
//				if(pObjConfiguracion.getTipoFiltroAplicado().equalsIgnoreCase(GlobalConfigDTO.PREDEFINIDO))
//				{
//					pObjConfiguracion.setWhereHumanoActual(pObjConfiguracion.getFiltroPrdedefinido(idfiltro).getInffiltro());
//				}
//				else if (pObjConfiguracion.getTipoFiltroAplicado().equalsIgnoreCase(GlobalConfigDTO.USUARIO))
//				{
//					pObjConfiguracion.setWhereHumanoActual(pObjConfiguracion.getFiltroUsuario(idfiltro).getWheesp());
//				}
//			}
//		}
//
//		return pObjConfiguracion.getWhereHumanoActual();
//	}

	/**
	 * Obtiene columnas.
	 *
	 * @param pStrColumnas
	 *            el string Columnas
	 * @param pStrElegidas
	 *            el string Elegidas
	 *
	 * @return un objeto String
	 */
//	public String obtieneColumnas(String pStrColumnas, String pStrElegidas, GlobalConfigDTO pObjConfiguracion) {
//
//		if (pStrColumnas != null){
//			pObjConfiguracion.setCampos(pStrColumnas);
//		}
//
//		return pObjConfiguracion.getCampos();
//	}

	/**
	 * Filtroactual.
	 *
	 * @param mapping
	 *            el mapping
	 * @param form
	 *            el form
	 * @param request
	 *            el request
	 * @param response
	 *            el response
	 *
	 * @return un objeto ActionForward
	 *
	 * @throws Exception
	 *             the exception
	 */
//	public ActionForward filtroactual(ActionMapping mapping, ActionForm form, HttpServletRequest request,
//			HttpServletResponse response) throws Exception {
//
//		aStrForward = "filtroactual";
//
//		try {
//			HttpSession lObjSession = request.getSession();
//			String lStrActionActual = (String) lObjSession.getAttribute("ACTION");
//			GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO) lObjSession.getAttribute(lStrActionActual);
//
//			String lStrNombrefiltro = "tc.filtros.sindeterminar"; //el nombre que se pone por defecto
//			String lStrFiltroHumano = "";
//			String lStrEsEtiqueta = "S";
//			if(!lObjConfiguracion.getFiltroAplicado().equalsIgnoreCase("0"))
//			{
//				if((lObjConfiguracion.getWhereHumanoActualUsuario()!=null) && (!lObjConfiguracion.getWhereHumanoActualUsuario().equalsIgnoreCase("")))
//				{
//					lStrFiltroHumano = lObjConfiguracion.getWhereHumanoActualUsuario();
//				}
//				else if((lObjConfiguracion.getWhereHumanoActual()!=null) && (!lObjConfiguracion.getWhereHumanoActual().equalsIgnoreCase("")))
//				{
//					lStrFiltroHumano = lObjConfiguracion.getWhereHumanoActual();
//				}
//				else if(lObjConfiguracion.getTipoFiltroAplicado().equalsIgnoreCase(GlobalConfigDTO.PREDEFINIDO))
//				{
//					lStrNombrefiltro = lObjConfiguracion.getNombreFiltroPredefinido(lObjConfiguracion.getFiltroAplicado(),lStrNombrefiltro);
//					lStrFiltroHumano = lObjConfiguracion.getFiltroHumanoPredefinido(lObjConfiguracion.getFiltroAplicado(),lStrNombrefiltro);
//					lStrEsEtiqueta = "S";
//				}
//				else if(lObjConfiguracion.getTipoFiltroAplicado().equalsIgnoreCase(GlobalConfigDTO.USUARIO))
//				{
//					lStrNombrefiltro = lObjConfiguracion.getNombreFiltroUsuario(lObjConfiguracion.getFiltroAplicado(),lStrNombrefiltro);
//					lStrFiltroHumano = lObjConfiguracion.getFiltroHumanoUsuario(lObjConfiguracion.getFiltroAplicado(),lStrNombrefiltro);
//					lStrEsEtiqueta = "N";
//				}
//			}
//			request.setAttribute("pObjConf", lObjConfiguracion);
//			request.setAttribute("pStrNombreFiltro", lStrNombrefiltro);
//			request.setAttribute("pStrFiltroHumano", lStrFiltroHumano);
//			request.setAttribute("pStrEsEtiqueta", lStrEsEtiqueta);
//
//
//		} catch (Throwable e) {
//			ApplicationCoreException ex = new ApplicationCoreException(ApplicationCoreException.FICHERO_NO_PRESENTE, e
//					.toString(), this.getClass().getSimpleName(), "filtroactual");
//			lanzarError(ex, request);
//			aStrForward = "errorpopup";
//		} finally {
//			ActionForward lObjRetorno = new ActionForward(aStrForward);
//			lObjRetorno.setContextRelative(true);
//			return lObjRetorno;
//		}
//	}

	/**
	 * Borrafiltro.
	 *
	 * @param mapping
	 *            el mapping
	 * @param form
	 *            el form
	 * @param request
	 *            el request
	 * @param response
	 *            el response
	 *
	 * @return un objeto ActionForward
	 */
//	public ActionForward borrafiltro(ActionMapping mapping, ActionForm form, HttpServletRequest request,
//			HttpServletResponse response) {
//
//		aStrForward = "borrafiltro";
//
//		try {
//
//			HttpSession lObjSession = request.getSession();
//			String lStrActionActual = (String) lObjSession.getAttribute("ACTION");
//			GlobalConfigDTO lObjConfiguracion = (GlobalConfigDTO) lObjSession.getAttribute(lStrActionActual);
//
//			String lStrId = (String) request.getParameter("id");
//			UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();
//
//			GuUsuapliFiltro[] lObjFiltrosUsuario = null;
//
//			if (lStrId != null) {
//				lObjUsApDel.deleteFiltro(Integer.parseInt(lStrId));
//				lObjFiltrosUsuario = lObjUsApDel.obtenerFiltrosUsuario(getOperador(request), lStrActionActual);
//				lObjConfiguracion.setFiltrosusuario(lObjFiltrosUsuario);
//				lObjConfiguracion.setWhereActual("");
//				lObjConfiguracion.setWhereHumanoActual("");
//				if((lObjConfiguracion.getFiltroAplicado()!=null)&&(lObjConfiguracion.getFiltroAplicado().equalsIgnoreCase(lStrId)))
//				{
//					lObjConfiguracion.setFiltroAplicado("");
//				}
//				lObjSession.setAttribute(lStrActionActual, lObjConfiguracion);
//			}
//			else
//			{
//				lObjFiltrosUsuario = lObjUsApDel.obtenerFiltrosUsuario(getOperador(request), lStrActionActual);
//			}
//
//			request.setAttribute("pObjConf", lObjConfiguracion);
//
//			// Pasa los filtros
//			request.setAttribute("pObjFiltrosUsuario", lObjFiltrosUsuario);
//		} catch (ApplicationCoreException e) {
//			lanzarError(e, request);
//		} catch (Throwable e) {
//			ApplicationCoreException ex = new ApplicationCoreException(
//					ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(), this.getClass().getSimpleName(),
//					"borrafiltro");
//			lanzarError(ex, request);
//		} finally {
//
//			ActionForward lObjRetorno = new ActionForward(aStrForward);
//			return lObjRetorno;
//		}
//	}



	/**
	 * Guardar filtro.
	 *
	 * @param pStrNombre
	 *            el string Nombre
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pStrIdApli
	 *            el string IdApli
	 * @param pObjConf
	 *            el l obj de configuracion
	 *
	 * @return un objeto long
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
//	public long guardarFiltro(String pStrNombre, String pStrUsuario, GlobalConfigDTO pObjConf)
//			throws ApplicationCoreException {
//
//		try {
//			UsuarioAplicacionDelegate lObjOperador = new UsuarioAplicacionDelegate();
//			long lIntRet = 0;
//			if (pStrNombre != null) {
//				GuUsuapliFiltro lObjFiltro = new GuUsuapliFiltro();
//				lObjFiltro.setIdinforme(pObjConf.getIdinforme());
//				lObjFiltro.setIdusr(pStrUsuario);
//				lObjFiltro.setIdusufiltro(pStrNombre);
//
//				//sumamos los filtros humanos
//				String lStrWhereHumano = pObjConf.getWhereHumanoActual(); 			
//				if(!"".equalsIgnoreCase(lStrWhereHumano))
//				{
//					lStrWhereHumano += " AND ";
//				}
//				
//				if((pObjConf.getWhereHumanoActualUsuario()!=null) && (!pObjConf.getWhereHumanoActualUsuario().equalsIgnoreCase("")))
//				{
//					lStrWhereHumano += pObjConf.getWhereHumanoActualUsuario();
//				}
//				lObjFiltro.setWheesp(lStrWhereHumano);
//				
//				//sumamos los filtros sql
//				String lStrWhereFiltro = pObjConf.getWhereActual();
//				String[] lObjWhereFiltro = lStrWhereFiltro.split("%");
//				lStrWhereFiltro = "";
//				for (int i = 0; i < lObjWhereFiltro.length; i++) {
//					if (i == (lObjWhereFiltro.length - 1)) {
//						lStrWhereFiltro = lStrWhereFiltro + lObjWhereFiltro[i];
//					} else {
//						lStrWhereFiltro = lStrWhereFiltro + lObjWhereFiltro[i] + "%";
//					}
//				}
//				
//				if(!"".equalsIgnoreCase(lStrWhereFiltro))
//				{
//					lStrWhereFiltro += " AND ";
//				}
//				if((pObjConf.getWhereActualUsuario()!=null) && (!pObjConf.getWhereActualUsuario().equalsIgnoreCase("")))
//				{
//					lStrWhereFiltro += pObjConf.getWhereActualUsuario();
//				}								
//				lObjFiltro.setWhefiltro(lStrWhereFiltro);
//				
//				lObjOperador.insertarFiltro(lObjFiltro);
//				lIntRet = lObjFiltro.getIdfiltro();
//				pObjConf.getFiltrosusuario().add(lObjFiltro);
////				List<GuUsuapliFiltro> lListFiltros = pObjConf.getFiltrosusuario();
////				lListFiltros.add(lObjFiltro);
//			}
//			return lIntRet;
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "guardarFiltro");
//		}
//	}

	/**
	 * Guardar configuracion.
	 *
	 * @param pStrIdAplicacion
	 *            el string IdAplicacion
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pObjRequest
	 *            el objeto Request
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
//	public void guardarConfiguracion(GlobalConfigDTO lObjConfiguracion,HttpServletRequest pObjRequest) throws ApplicationCoreException {
//
//		try {
//			aStrForward = "exito";
//			UsuarioAplicacionDelegate lObjDelegate = new UsuarioAplicacionDelegate();
//			String lStrOperador = getOperador(pObjRequest);
//			String lStrIdAplicacion = getAplicacion(pObjRequest);
//
//			if (lObjDelegate.existeConfiguracion(lStrOperador, lStrIdAplicacion, lObjConfiguracion.getIdinforme())) {
//				lObjDelegate.deleteConfiguracion(lStrOperador, lStrIdAplicacion, lObjConfiguracion.getIdinforme());
//			}
//
//			GuUsuapliConfig lObjConfig = new GuUsuapliConfig();
//			lObjConfig.setIdinforme(lObjConfiguracion.getIdinforme());
//			lObjConfig.setIdusu(lStrOperador);
//			lObjConfig.setOrden(lObjConfiguracion.getOrden());
//			lObjConfig.setCampos(lObjConfiguracion.getCampos());
//			lObjConfig.setGrupo(lObjConfiguracion.getGrupo());
//			lObjConfig.setWhereesp(lObjConfiguracion.getWhereHumanoActualUsuario());
//
//			String lStrCondicionWhere = "";
////			//Si hay que filtrar por idioma
////			if((lObjConfiguracion.getIdioma()!=null)&&(lObjConfiguracion.getIdioma().equalsIgnoreCase("S")))
////			{
////				lStrCondicionWhere += " AND CODIDIOMA='"+pObjRequest.getSession().getAttribute("IDIOMA")+"' ";
////			}
//			if((lObjConfiguracion.getWhereActualUsuario()!=null) && (!lObjConfiguracion.getWhereActualUsuario().equalsIgnoreCase("")))
//			{
//				lStrCondicionWhere += " " + lObjConfiguracion.getWhereActualUsuario();
//			}
//			lObjConfig.setWherefiltro(lStrCondicionWhere);
//
//			// guardamos el filtro
//			lObjDelegate.insertarConfiguracion(lObjConfig);
//			setVolverListadoUrl(pObjRequest);
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "guardarConfiguracion");
//		}
//	}


	/**
	 * Eliminar configuracion.
	 *
	 * @param pStrIdAplicacion
	 *            el string IdAplicacion
	 * @param pStrUsuario
	 *            el string Usuario
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pObjRequest
	 *            el objeto Request
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
//	public void eliminarConfiguracion(GlobalConfigDTO lObjConfiguracion,	HttpServletRequest pObjRequest) throws ApplicationCoreException {
//
//		try {
//			aStrForward = "exito";
//			UsuarioAplicacionDelegate lObjUsApDel = new UsuarioAplicacionDelegate();
//			String lStrIdAplicacion = getAplicacion(pObjRequest);
//			String lStrOperador = getOperador(pObjRequest);
//			String lStrActionActual = (String)pObjRequest.getSession().getAttribute("ACTION");
//
//			if (lObjUsApDel.existeConfiguracion(lStrOperador, lStrIdAplicacion, lStrActionActual)) {
//				lObjUsApDel.deleteConfiguracion(lStrOperador, lStrIdAplicacion, lStrActionActual);
//			}
//
//			//vuelvo a coger la configuracion GLOBAL
//			List <GlobalConfig> lObjRetorno = ServiceLocatorCoreDao.getGlobalconfigDao().findWhereIdinformeEquals(lStrActionActual);
//
//			if(lObjRetorno.size()>0)
//			{
//				lObjConfiguracion.setOrden(lObjRetorno.get(0).getOrden());
//				lObjConfiguracion.setCampos(lObjRetorno.get(0).getCampos());
//				lObjConfiguracion.setGrupo(lObjRetorno.get(0).getGrupo());
//				lObjConfiguracion.setWherefiltrofijo(lObjRetorno.get(0).getWherefiltrofijo());
//				lObjConfiguracion.setInffiltrofijo(lObjRetorno.get(0).getInffiltrofijo());
//				lObjConfiguracion.setWhereActualUsuario("");
//				lObjConfiguracion.setWhereHumanoActualUsuario("");
//
//			}
//			setVolverListadoUrl(pObjRequest);
//		} catch (Throwable e) {
//			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(), this
//					.getClass().getSimpleName(), "eliminarConfiguracion");
//		}
//	}

	/**
	 * inserta en request el url para volver a listado desde la pagina de exito
	 * @param pObjRequest
	 */
	private void setVolverListadoUrl(HttpServletRequest pObjRequest){
		HttpSession lObjSession = pObjRequest.getSession();
		String lStrActionActual = (String) lObjSession.getAttribute("ACTION");

		String lStrUrl = lStrActionActual+".do?metodo=obtenerListado";
		pObjRequest.setAttribute("pStrUrlLista", lStrUrl);
	}

	/**
	 * Excluye las columnas que hay que mantener ocultas
	 *
	 * @param pStrTabla
	 *            
	 * @param pObjListaColumnas
	 *            
	 * @param pObjConfiguracion
	 *
	 * @throws Exception
	 *            
	 */
//	private HashMap excluirColumnasOcultas(String pStrTabla, HashMap pObjListaColumnas, GlobalConfigDTO pObjConfiguracion) throws Exception
//	{
//		HashMap lObjResultado = new HashMap();		
//		String[] lStrColumnasOcultas = AuxiliarMVC.splitCadena(pObjConfiguracion.getOcultos(), ",");
//		
//		Iterator it = pObjListaColumnas.keySet().iterator();
//		
//		while(it.hasNext())
//		{
//			String lStrTmpColumnaActual = (String) it.next();
//			boolean ocultarColumna = false;
//			
//			for(int i=0;i<lStrColumnasOcultas.length;i++)
//			{					
//				if(lStrTmpColumnaActual.equalsIgnoreCase(pStrTabla+"."+lStrColumnasOcultas[i]))
//				{
//					//hay que ocultar la columna
//					ocultarColumna=true;
//				}
//			}
//			
//			if(!ocultarColumna)
//			{
//				lObjResultado.put(lStrTmpColumnaActual, pObjListaColumnas.get(lStrTmpColumnaActual));
//			}
//		}
//				
//		return lObjResultado;
//	}
	
	/**
	 * Excluye las columnas que hay que mantener ocultas
	 *
	 * @param pStrTabla
	 *            
	 * @param pObjListaColumnas
	 *            
	 * @param pObjConfiguracion
	 *
	 * @throws Exception
	 *            
	 */
//	private ArrayList excluirColumnasOcultas(String pStrTabla, ArrayList pObjListasColumnas, GlobalConfigDTO pObjConfiguracion) throws Exception
//	{
//		String[] lStrColumnasOcultas = AuxiliarMVC.splitCadena(pObjConfiguracion.getOcultos(), ",");
//		
//		CodigoDescripcionDTO colVisibleOrig[] = (CodigoDescripcionDTO[])pObjListasColumnas.get(0);	
//		Collection resultListVisible = new ArrayList();
//		
//		for(int j=0; j<colVisibleOrig.length; j++)
//		{
//			boolean ocultarColumna = false;
//			
//			for(int i=0;i<lStrColumnasOcultas.length;i++)
//			{					
//				if(colVisibleOrig[j].getAStrDescripcion().equalsIgnoreCase(lStrColumnasOcultas[i]))
//				{
//					//hay que ocultar la columna
//					ocultarColumna=true;
//				}
//			}
//			
//			if(!ocultarColumna)
//			{
//				resultListVisible.add(colVisibleOrig[j]);
//			}
//		}
//
//		
//		CodigoDescripcionDTO colNoVisibleOrig[] = (CodigoDescripcionDTO[])pObjListasColumnas.get(1);
//		Collection resultListNoVisible = new ArrayList();
//		
//		for(int j=0; j<colNoVisibleOrig.length; j++)
//		{
//			boolean ocultarColumna = false;
//			
//			for(int i=0;i<lStrColumnasOcultas.length;i++)
//			{					
//				if(colNoVisibleOrig[j].getAStrDescripcion().equalsIgnoreCase(lStrColumnasOcultas[i]))
//				{
//					//hay que ocultar la columna
//					ocultarColumna=true;
//				}
//			}
//			
//			if(!ocultarColumna)
//			{
//				resultListNoVisible.add(colNoVisibleOrig[j]);
//			}
//		}		
//		
//		CodigoDescripcionDTO retVisible[] = new CodigoDescripcionDTO[resultListVisible.size()];
//		CodigoDescripcionDTO retNoVisible[] = new CodigoDescripcionDTO[resultListNoVisible.size()];
//		resultListVisible.toArray(retVisible);
//		resultListNoVisible.toArray(retNoVisible);
//		ArrayList lCampos = new ArrayList();
//		lCampos.add(0, retVisible);
//		lCampos.add(1, retNoVisible);
//		
//		return lCampos;
//	}	
	

}
