/**
 * 
 */
package es.postigo.action;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import es.postigo.delegate.UbicacionDelegate;
import es.postigo.dto.Ubicacion;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.UbicacionDaoException;

/**
 * @author informatica4
 *
 */
public class UbicacionAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        DynaActionForm registerForm = (DynaActionForm) form;  
        
        /**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
		
		//FormularioMAP lObjFormulario = (FormularioMAP) form;
		
		int lIntPagActualU = 1;
        String lStrABuscar = "";
        String lStrOrderU = "";
    	String lStrCampoOrdenU = "";
        
		if(request.getParameter("pag") != null && request.getParameter("pag")!=null){
			lIntPagActualU = Integer.valueOf(request.getParameter("pag").toString());
		}
		
		if(request.getParameter("BUSQUEDA") != null && request.getParameter("BUSQUEDA")!=null){
			lStrABuscar = request.getParameter("BUSQUEDA").toString();
		}
        
        String lStrResult = "ok";
        
        List<Ubicacion> listaUbicaciones = new ArrayList<Ubicacion>(); 
        int lIntNumPaginasU = 0;
        int lIntRegPaginaU = 10;
        int lIntTotalRegU = 0;
    	
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	UbicacionDelegate UbicacionDelegate = new UbicacionDelegate();		
			
			//Montamos la consulta
        	String lStrSQLU = "SELECT * FROM UBICACION ";
        	
        	//Aadimos los parametros de busqueda al WHERE
        	String lStrWhereU = "WHERE SUBSTR(codigo,1,3) != '000' ";
        	if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
        		lStrWhereU += "AND (CODIGO LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR DESCRIPCION LIKE '%"+ lStrABuscar.toUpperCase() +"%' OR CODIGOEAN = '" + lStrABuscar + "') ";
        	}
        	/**TODO: Preguntar en compras por los campos en los que desean o por los que desean filtrar a la hora de hacer las busquedas en los listados.*/
        	
        	/**Orden dinamico de los listados (ORDEN ASC y DESC), ademas de permitir ordenar por CAMPO_ORDEN*/
        	lStrOrderU = "ORDER BY ";
        	lStrCampoOrdenU = "CODIGO ";
        	
        	if(request.getParameter("CAMPO_ORDEN") != null && !"".equals(request.getParameter("CAMPO_ORDEN"))){
        		lStrCampoOrdenU = request.getParameter("CAMPO_ORDEN").toString() + " ";
        		lStrOrderU += lStrCampoOrdenU;
        	}else lStrOrderU += lStrCampoOrdenU;
        	
        	if(request.getParameter("ORDEN") != null && !"".equals(request.getParameter("ORDEN"))){
        		//lStrOrderU = "ORDER BY CODIGO " + (String) lObjFormulario.getValue("ORDEN");
        		lStrOrderU += request.getParameter("ORDEN").toString() + " ";
        	}
        	/**FIN ORDEN*/
        	
        	String lStrPaginacionU = "LIMIT "+ (lIntPagActualU-1)*lIntRegPaginaU +", "+ lIntRegPaginaU;
        	
        	listaUbicaciones = UbicacionDelegate.obtenerListado(lStrSQLU+lStrWhereU+lStrOrderU+lStrPaginacionU);
        	
			//Paginacin
        	if(request.getParameter("BUSQUEDA")!=null && request.getParameter("BUSQUEDA")!= ""){
				lIntTotalRegU = UbicacionDelegate.obtenerListado(lStrSQLU+lStrWhereU+lStrOrderU).size();
			}else{
				lIntTotalRegU = obtenerNumUbicaciones();
			}
			lIntNumPaginasU = lIntTotalRegU/lIntRegPaginaU;
			if(lIntTotalRegU%lIntRegPaginaU > 0){
				lIntNumPaginasU += 1;
			}
			
			//Si queremos imprimir el listado, pasamos 
			if(request.getParameter("metodo") != null && request.getParameter("metodo")!=null){
				String lStrMetodo = request.getParameter("metodo");
				
				if("IMPRIMIRU".equals(lStrMetodo)){
					/**Llamamos al metodo para imprimir la etiqueta del producto/ubicacin*/
					 List<Ubicacion> listaUbicacionIMP = UbicacionDelegate.obtenerListado(lStrSQLU+lStrWhereU+lStrOrderU);
					lStrResult = imprimirListadoUbicacion(listaUbicacionIMP, request, response);
				}
				if("IMPRIMIRUXLS".equals(lStrMetodo)){
					List<Ubicacion> listaUbicacionIMP = UbicacionDelegate.obtenerListado(lStrSQLU+lStrWhereU+lStrOrderU);
					lStrResult = imprimirListadoUbicacionXLS(listaUbicacionIMP, request, response);
				}
			}else{	
				lStrResult = "SUCCESS";
			}
			
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
			throw new UbicacionDaoException( "ApplicationException: " + e.getMessage(), e );
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
			throw new UbicacionDaoException( "Exception: " + e.getMessage(), e );
		}
          
        request.setAttribute("listaUbicaciones", listaUbicaciones);
        request.setAttribute("numPaginasU", lIntNumPaginasU);
        request.setAttribute("totalRegU", lIntTotalRegU);
        request.setAttribute("pagActualU", lIntPagActualU);
        request.setAttribute("busqueda",lStrABuscar);
        request.setAttribute("campoOrden", lStrCampoOrdenU);
        request.setAttribute("ordenU", lStrOrderU);
        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
        
        return mapping.findForward(lStrResult);
    }
	
	public void insertLocal(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response)throws Exception {
		
		aStrForward="exito";		
		
		System.out.println("insert :)");
	}
	
	public int obtenerNumUbicaciones() throws Exception{		
		List<Ubicacion> listaUbicaciones = new ArrayList<Ubicacion>(); 		
		try {
			UbicacionDelegate lObjUbicacionDelegate = new UbicacionDelegate();
			listaUbicaciones = lObjUbicacionDelegate.obtenerListado("SELECT * FROM UBICACION WHERE SUBSTR(codigo,1,3) != '000'ORDER BY CODIGO");
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}		
		return listaUbicaciones.size();		
	}
		
	public String imprimirListadoUbicacion(List<Ubicacion> pObjListaUbicacion, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteUbicacion reporte = new ServletReporteUbicacion();
			reporte.doGet(pObjListaUbicacion, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
	
	public String imprimirListadoUbicacionXLS(List<Ubicacion> pObjListaUbicacion, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteUbicacion reporte = new ServletReporteUbicacion();
			reporte.doGetXLS(pObjListaUbicacion, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}
}
