/**
 * 
 */
package es.postigo.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import es.postigo.delegate.UserDelegate;
import es.postigo.dto.User;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.UserDaoException;
import es.postigo.struts.forms.FormularioMAP;

/**
 * @author informatica4
 *
 */
public class UserAction extends GenericoAction{

	public ActionForward execute(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {  
        
		String lStrResult = "ok";
		
		/**Comprobar sesin.*/
		if(request.getSession().getAttribute("registerUser") == null){
			return mapping.findForward("inicio");
		}
		
		FormularioMAP lObjFormulario = (FormularioMAP) form;
		User lObjUser = new User();
		
        /** Realizariamos las acciones en los objetos de negocio */  
        try {
        	UserDelegate userDelegate = new UserDelegate();	
        	if(request.getParameter("USER") != null && request.getParameter("USER")!=null){
				lObjUser = userDelegate.getRegistro(request.getParameter("USER"));
			}
        	if(request.getParameter("metodo") != null && request.getParameter("metodo")!=null){
				String lStrMetodo = request.getParameter("metodo");
				
				/**Rellenamos el objeto con los datos del formulario*/
				if(lObjFormulario.getValue("PASS")!= null && lObjFormulario.getValue("PASS") != ""){
					lObjUser.setPass((String) lObjFormulario.getValue("PASS"));
	        	}//else lObjUser.setPass("");
				
				if("INSERT".equals(lStrMetodo)){
					/**Llamamos al metodo e insert el user/ubicacin*/
					lStrResult = insert(lObjUser);
				}
				if("UPDATE".equals(lStrMetodo)){
					/**Llamamos al metodo y actualizamos el user/ubicacin*/
					lStrResult = update(lObjUser);
				}
				if("DELETE".equals(lStrMetodo)){
					/**Llamamos al metodo y eliminamos el user/ubicacin*/
					lStrResult = delete(lObjUser);
				}
				/*if("IMPRIMIR".equals(lStrMetodo)){
					lStrResult = imprimirEtiqueta( lObjUser, request, response);
				}*/
			}
        	
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
		} catch (Throwable e) {
			// TODO Auto-generated catch block
			lStrResult = "ERROR";
			e.printStackTrace();
		}
		
        request.setAttribute("usuario", lObjUser);
        /**Navegabilidad */
        String lStrVolver = "";
        if(request.getParameter("volver") != null){
			  lStrVolver = request.getParameter("volver");
		}
        request.setAttribute("volver", lStrVolver);        
        /**Para saber en el action en el que nos encontramos y poder mostrar los titulos en la cabecera*/
        request.setAttribute("action_actual",(String) request.getRequestURI().substring(16, request.getRequestURI().length()-3));
                
        return mapping.findForward(lStrResult);
    }
	
	public String insert(User pObjPU){
		try {
			UserDelegate lObjUserDelegate = new UserDelegate();			
			lObjUserDelegate.insert(pObjPU);
			return "SUCCESS";
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (UserDaoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}
	}
	
	public String update(User pObjPU){
		try {
			UserDelegate lObjUserDelegate = new UserDelegate();			
			lObjUserDelegate.update(pObjPU);
			return "SUCCESS";
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (UserDaoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}
	}
	
	public String delete(User pObjUser){
		UserDelegate lObjUserDelegate;
		try {
			lObjUserDelegate = new UserDelegate();
			lObjUserDelegate.delete(pObjUser.getLogin());
			return "SUCCESS";
		} catch (ApplicationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (UserDaoException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}	
	}
	
	/*public String imprimirEtiqueta(User pObjUser, HttpServletRequest request, HttpServletResponse response){		
        try {        	
        	ServletReporteEtiquetaUser reporte = new ServletReporteEtiquetaUser();
			reporte.doGet(pObjUser, request, response);
			//return "SUCCESS";
			return "ok";
		} catch (ServletException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return "ERROR";
		}		
	}*/
	
}
