/**
 * 
 */
package es.postigo.action.utility;

/**
 * @author informatica4
 *
 * Descripcin: Clase auxiliar para realizar diferentes tareas
 * 
 */

import java.lang.reflect.InvocationTargetException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;
import java.util.Set;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.zip.Deflater;
import java.util.zip.Inflater;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.logging.LogFactory;

import es.postigo.delegate.TCDelegate;
import es.postigo.dto.AuxiliarSQL;
import es.postigo.exceptions.ApplicationCoreException;
import es.postigo.struts.forms.FormularioMAP;
import es.postigo.utility.Auxiliar;
import es.postigo.utility.Fecha;
import es.postigo.xml.ElementoXML;

//import es.prodevelop.delegate.TCDelegate;
//import es.prodevelop.dto.AuxiliarSQL;
//import es.prodevelop.exception.ApplicationCoreException;
//import es.prodevelop.mvc.form.FormularioMAP;
//import es.prodevelop.utility.Fecha;
//import es.prodevelop.xml.ElementoXML;

/**
 * El Class Auxiliar.
 */
public class AuxiliarMVC {

	/**
	 * Obtiene parametros.
	 *
	 * @param pStrParametros
	 *            el string Parametros
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @return un objeto String
	 */
	public String obtieneParametros(String pStrParametros, AuxiliarSQL pObjSesionSQL) {

		if (pStrParametros == null) {
			pStrParametros = pObjSesionSQL.getAStrParametros();
		} else {
			pObjSesionSQL.setAStrParametros(pStrParametros);
		}
		return pStrParametros;
	}

	/**
	 * Obtiene cod filtro.
	 *
	 * @param pStrCodFiltro
	 *            el string Codigo Filtro
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @return un objeto String
	 */
	public String obtieneCodFiltro(String pStrCodFiltro, AuxiliarSQL pObjSesionSQL) {

		if ((pStrCodFiltro != null) && (pStrCodFiltro.equalsIgnoreCase("null"))) {
			pStrCodFiltro = null;
			pObjSesionSQL.setAStrTCCodFiltro(null);
		}
		if (pStrCodFiltro == null) {
			pStrCodFiltro = pObjSesionSQL.getAStrTCCodFiltro();
		} else {
			pObjSesionSQL.setAStrTCCodFiltro(pStrCodFiltro);
		}
		return pStrCodFiltro;
	}

	/**
	 * Obtiene elegidas.
	 *
	 * @param pStrElegidas
	 *            el string Elegidas
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pStrPorDefecto
	 *            el string PorDefecto
	 *
	 * @return un objeto String
	 */
	public static String obtieneElegidas(String pStrElegidas, AuxiliarSQL pObjSesionSQL, String pStrPorDefecto) {

		if (pStrElegidas == null) {
			pStrElegidas = pObjSesionSQL.getAStrColumnas();
			if (pStrElegidas == null) {
				pStrElegidas = pStrPorDefecto;
			}
		} else {
			//PIF-595
			if (pStrPorDefecto!=null && !pStrPorDefecto.equals("")){
				pStrElegidas = pStrElegidas + "," + pStrPorDefecto;
				if (pStrPorDefecto.equals("*")){
					pStrElegidas = pStrPorDefecto;
				}
			}
			pObjSesionSQL.setAStrColumnas(pStrElegidas);
		}
		return pStrElegidas;
	}

	/**
	 * Obtiene agrupar.
	 *
	 * @param pStrAgrupar
	 *            el string Agrupar
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @return un objeto String
	 */
	public static String obtieneAgrupar(String pStrAgrupar, AuxiliarSQL pObjSesionSQL) {

		if (pStrAgrupar == null) {
			pStrAgrupar = pObjSesionSQL.getAStrAgrupacion();
		} else {
			if (!(pStrAgrupar.equals("vacia"))) {
				pObjSesionSQL.setAStrAgrupacion(pStrAgrupar);
			} else {
				pStrAgrupar = null;
				pObjSesionSQL.setAStrAgrupacion(pStrAgrupar);
			}
		}
		return pStrAgrupar;
	}

	/**
	 * Obtiene ordenar.
	 *
	 * @param pStrOrdenar
	 *            el string Ordenar
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @return un objeto String
	 */
	public static String obtieneOrdenar(String pStrOrdenar, AuxiliarSQL pObjSesionSQL) {

		if (pStrOrdenar == null) {
			pStrOrdenar = pObjSesionSQL.getAStrOrder();
		} else {
			pObjSesionSQL.setAStrOrder(pStrOrdenar);
		}
		return pStrOrdenar;
	}

	/**
	 * Obtiene where filtro.
	 *
	 * @param pStrWhereFiltroHumano
	 *            el string WhereFiltroHumano
	 * @param pStrWhereFiltroSql
	 *            el string WhereFiltroSql
	 * @param pStrWhereFiltro
	 *            el string WhereFiltro
	 * @param pStrNombreFiltro
	 *            el string NombreFiltro
	 * @param request
	 *            el request
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @return un objeto String
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public static String obtieneWhereFiltro(String pStrWhereFiltroHumano, String pStrWhereFiltroSql,
			String pStrWhereFiltro, String pStrNombreFiltro, HttpServletRequest request, AuxiliarSQL pObjSesionSQL)
			throws ApplicationCoreException {

		try {
			// Ajuste de los par�metros
			if (pStrWhereFiltro != null) {
				pStrWhereFiltro = pStrWhereFiltro.trim();
				if ((pStrWhereFiltro.equals("null")) | (pStrWhereFiltro.equals(""))) {
					pStrWhereFiltro = null;
				}
			}
			if (pStrWhereFiltroHumano != null) {
				pStrWhereFiltroHumano = pStrWhereFiltroHumano.trim();
				if (pStrWhereFiltroHumano.equals("")) {
					pStrWhereFiltroHumano = null;
				}
			}

			if (pStrWhereFiltro == null) {
				if (pStrWhereFiltroHumano == null) {
					// Los dos nulos, se leen de sesi�n
					pStrWhereFiltro = pObjSesionSQL.getAStrWhereFiltro();
					pStrWhereFiltroHumano = pObjSesionSQL.getAStrFiltroHumano();
					pStrNombreFiltro = pObjSesionSQL.getAStrNombreFiltro();
				} else {
					// Conocido el filtro humano, se traduce y se guardan en
					// sesi�n
					pStrWhereFiltro = pStrWhereFiltroSql;
					pObjSesionSQL.setAStrWhereFiltro(pStrWhereFiltro);
					pObjSesionSQL.setAStrFiltroHumano(pStrWhereFiltroHumano);
					pObjSesionSQL.setAStrNombreFiltro(pStrNombreFiltro);
				}
			} else {
				if (pStrWhereFiltroHumano == null) {
					// Conocido el filtro SQL, se desconoce el filtro humano.
					// Caso no corriente. Se leer�an de sesi�n
					pStrWhereFiltro = pObjSesionSQL.getAStrWhereFiltro();
					pStrWhereFiltroHumano = pObjSesionSQL.getAStrFiltroHumano();
					pStrNombreFiltro = pObjSesionSQL.getAStrNombreFiltro();
				} else {
					// Conocido ambos, se guardan en sesi�n
					pObjSesionSQL.setAStrWhereFiltro(pStrWhereFiltro);
					pObjSesionSQL.setAStrFiltroHumano(pStrWhereFiltroHumano);
					pObjSesionSQL.setAStrNombreFiltro(pStrNombreFiltro);
				}
			}

			if ((pStrWhereFiltroHumano != null) && (pStrWhereFiltroHumano.equals("borradodelfiltroactual"))) {
				pStrWhereFiltro = null;
				pStrWhereFiltroHumano = null;
				pStrNombreFiltro = null;
				pObjSesionSQL.setAStrWhereFiltro(pStrWhereFiltro);
				pObjSesionSQL.setAStrFiltroHumano(pStrWhereFiltroHumano);
				pObjSesionSQL.setAStrNombreFiltro(pStrNombreFiltro);
			}
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_DESCONOCIDO, e.toString(), AuxiliarMVC.class
					.getClass().getSimpleName(), "obtieneWhereFiltro");
		}
		return pStrWhereFiltro;
	}

	/**
	 * Asigna el where filtro.
	 *
	 * @param pStrWhereFiltroHumano
	 *            el string WhereFiltroHumano
	 * @param pStrWhereFiltro
	 *            el string WhereFiltro
	 * @param pStrNombreFiltro
	 *            el string NombreFiltro
	 * @param request
	 *            el request
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public void setWhereFiltro(String pStrWhereFiltroHumano, String pStrWhereFiltro, String pStrNombreFiltro,
			HttpServletRequest request, AuxiliarSQL pObjSesionSQL) throws ApplicationCoreException {

		try {
			// Ajuste de los par�metros
			if (pStrWhereFiltro != null) {
				pStrWhereFiltro = pStrWhereFiltro.trim();
				if ((pStrWhereFiltro.equals("null")) | (pStrWhereFiltro.equals(""))) {
					pStrWhereFiltro = null;
				}
			}
			if (pStrWhereFiltroHumano != null) {
				pStrWhereFiltroHumano = pStrWhereFiltroHumano.trim();
				if (pStrWhereFiltroHumano.equals("")) {
					pStrWhereFiltroHumano = null;
				}
			}

			if (pStrNombreFiltro != null) {
				pStrNombreFiltro = pStrNombreFiltro.trim();
				if (pStrNombreFiltro.equals("")) {
					pStrNombreFiltro = null;
				}
			}

			if (pStrWhereFiltro != null) {
				pObjSesionSQL.setAStrWhereFiltro(pStrWhereFiltro);
			}
			if (pStrWhereFiltroHumano != null) {
				pObjSesionSQL.setAStrFiltroHumano(pStrWhereFiltroHumano);
			}
			if (pStrNombreFiltro != null) {
				pObjSesionSQL.setAStrNombreFiltro(pStrNombreFiltro);
			}

		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_DESCONOCIDO, e.toString(), AuxiliarMVC.class
					.getClass().getSimpleName(), "setWhereFiltro");
		}
	}

	/**
	 * Cambios visualizar agrupacion.
	 *
	 * @param pStrAgrupar
	 *            el string Agrupar
	 * @param pStrElegidas
	 *            el string Elegidas
	 *
	 * @return un objeto String
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public static String cambiosVisualizarAgrupacion(String pStrAgrupar, String pStrElegidas)
			throws ApplicationCoreException {

		try {
			String lStrElegidas = pStrElegidas;
			boolean lBooSolouna = false;
			if ((pStrAgrupar != null) && (!(pStrAgrupar.equals("vacia")))) {
				String[] lObjCamposBD = pStrElegidas.split(",");
				pStrElegidas = "";
				for (int i = 0; i < lObjCamposBD.length; i++) {
					lObjCamposBD[i] = lObjCamposBD[i].trim();

					if (!(lObjCamposBD[i].equalsIgnoreCase(pStrAgrupar))) {
						if (i == lObjCamposBD.length - 1) {
							pStrElegidas = pStrElegidas + lObjCamposBD[i];
						} else {
							pStrElegidas = pStrElegidas + lObjCamposBD[i] + ",";
						}
					} else {
						if ((i == lObjCamposBD.length - 1)) {
							if (lStrElegidas.equalsIgnoreCase(pStrAgrupar)) {
								lBooSolouna = true;
							} else {
								pStrElegidas = pStrElegidas.substring(0, pStrElegidas.lastIndexOf(','));
							}
						}
					}
				}
				if (lBooSolouna) {
					pStrElegidas = pStrAgrupar;
				} else {
					pStrElegidas = pStrAgrupar + "," + pStrElegidas;
				}
			}
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(),
					AuxiliarMVC.class.getClass().getSimpleName(), "cambiosVisualizarAgrupacion");
		}
		return pStrElegidas;
	}

	
	/**
	 * Cambios visualizar agrupacion.
	 * 
	 * @param pStrAgrupar
	 *            el string Agrupar
	 * @param pStrElegidas
	 *            el string Elegidas
	 * 
	 * @return un objeto String
	 * 
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public static String visualizarAgrupacion(String pStrAgrupar, String pStrElegidas)
			throws ApplicationCoreException {

		try {
			if(!pStrElegidas.equalsIgnoreCase("*"))
			{
				String lStrElegidas = pStrElegidas;
				boolean lBooSolouna = false;
				if ((pStrAgrupar != null) && (!(pStrAgrupar.equals("vacia"))) && (!pStrAgrupar.equalsIgnoreCase(""))) {
					String[] lObjCamposBD = pStrElegidas.split(",");
					pStrElegidas = "";
					for (int i = 0; i < lObjCamposBD.length; i++) {
						lObjCamposBD[i] = lObjCamposBD[i].trim();
	
						if (!(lObjCamposBD[i].equalsIgnoreCase(pStrAgrupar))) {
							if (i == lObjCamposBD.length - 1) {
								pStrElegidas = pStrElegidas + lObjCamposBD[i];
							} else {
								pStrElegidas = pStrElegidas + lObjCamposBD[i] + ",";
							}
						} else {
							if ((i == lObjCamposBD.length - 1)) {
								if (lStrElegidas.equalsIgnoreCase(pStrAgrupar)) {
									lBooSolouna = true;
								} else {
									pStrElegidas = pStrElegidas.substring(0, pStrElegidas.lastIndexOf(','));
								}
							}
						}
					}
					if (lBooSolouna) {
						pStrElegidas = pStrAgrupar;
					} else {
						pStrElegidas = pStrAgrupar + "," + pStrElegidas;
					}
				}
			}
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_TRATAMIENTO_DATOS, e.toString(),
					AuxiliarMVC.class.getClass().getSimpleName(), "cambiosVisualizarAgrupacion");
		}
		return pStrElegidas;
	}
	
	/**
	 * Obtener condicion.
	 *
	 * @param pStrAgrupar
	 *            el string Agrupar
	 * @param pStrOrdenar
	 *            el string Ordenar
	 *
	 * @return un objeto String
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public static String obtenerCondicion(String pStrAgrupar, String pStrOrdenar) throws ApplicationCoreException {

		String lStrCondicion = "";
		if (((pStrAgrupar != null) && (!(pStrAgrupar.equals("vacia")))) || (pStrOrdenar != null)) {
			lStrCondicion = " order by ";

			if ((pStrAgrupar != null) && (!(pStrAgrupar.equals("vacia")))) {
				if ((pStrOrdenar == null)) {
					lStrCondicion = lStrCondicion + pStrAgrupar;
				} else {
					lStrCondicion = lStrCondicion + pStrAgrupar + ",";
				}
			}
			if (pStrOrdenar != null) {
				lStrCondicion = lStrCondicion + pStrOrdenar;
			}
		}
		return lStrCondicion;
	}

	/**
	 * Obtener objeto sesion sin borrado.
	 *
	 * @param request
	 *            el request
	 * @param pStrNombreSesion
	 *            el string NombreSesion
	 *
	 * @return un objeto AuxiliarSQL
	 */
	public AuxiliarSQL obtenerObjetoSesionSinBorrado(HttpServletRequest request, String pStrNombreSesion) {

		AuxiliarSQL lObjSesionSQL = (AuxiliarSQL) request.getSession().getAttribute(pStrNombreSesion);
		if (lObjSesionSQL == null) {
			request.getSession().setAttribute(pStrNombreSesion, new AuxiliarSQL());
			lObjSesionSQL = (AuxiliarSQL) request.getSession().getAttribute(pStrNombreSesion);
		}
		return lObjSesionSQL;
	}

	/**
	 * Obtener objeto sesion.
	 *
	 * @param request
	 *            el request
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrNombreSesion
	 *            el string NombreSesion
	 *
	 * @return un objeto AuxiliarSQL
	 */
	public AuxiliarSQL obtenerObjetoSesion(HttpServletRequest request, String pStrTabla, String pStrNombreSesion) {

		// Lectura y escritura del objeto de Sesi�n (completo)
		// El nombre del c�digo del puerto es variable en las tablas, por lo
		// que
		// es necesario
		// inicializarlo aqu�.
		AuxiliarSQL lObjSesionSQL = (AuxiliarSQL) request.getSession().getAttribute(pStrNombreSesion);
		if (lObjSesionSQL == null) {
			request.getSession().setAttribute(pStrNombreSesion, new AuxiliarSQL());
			lObjSesionSQL = (AuxiliarSQL) request.getSession().getAttribute(pStrNombreSesion);
		}

		// Borrado del objeto de Sesi�n si cambiamos de tabla
		if (lObjSesionSQL.getAStrTabla() == null) {
			lObjSesionSQL.setAStrTabla(pStrTabla);
		} else {
			String lStrIdNuevo = pStrTabla;
			String lStrIdViejo = lObjSesionSQL.getAStrTabla();
			if (!(lStrIdNuevo.equals(lStrIdViejo))) {

				lObjSesionSQL.setAStrColumnas(null);
				lObjSesionSQL.setAStrOrder(null);
				lObjSesionSQL.setAStrAgrupacion(null);
				lObjSesionSQL.setAStrWhereFiltro(null);
				lObjSesionSQL.setAStrFiltroHumano(null);
				lObjSesionSQL.setAStrNombreFiltro(null);
				lObjSesionSQL.setAStrTCCodFiltro(null);
				lObjSesionSQL.setAStrCursor(null);
				lObjSesionSQL.setAStrTabla(lStrIdNuevo);
			}
		}
		return lObjSesionSQL;
	}

	/**
	 * Lee yobtiene lupa sql.
	 *
	 * @param request
	 *            el request
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pStrPorDefecto
	 *            el string PorDefecto
	 * @param pStrWherePuerto
	 *            el string WherePuerto
	 *
	 * @return un objeto HashMap
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public HashMap leeYobtieneLupaSQL(HttpServletRequest request, String pStrTabla, AuxiliarSQL pObjSesionSQL,
			String pStrPorDefecto, String pStrWherePuerto) throws ApplicationCoreException {

		String lStrAgrupar = (String) request.getParameter("agrupar");
		String lStrOrdenar = (String) request.getParameter("ordenar");
		String lStrCursor = (String) request.getParameter("Cursor");
		String lStrWhereFiltroHumano = (String) request.getParameter("wherefiltrohumano");
		String lStrWhereFiltroSql = (String) request.getParameter("wherefiltrosql");
		String lStrWhereFiltro = (String) request.getParameter("wherefiltro");

		//NUEVO ALBER PIF-464
		String lStrElegidas = (String) request.getParameter("elegidas");
		if (lStrElegidas==null) lStrElegidas="*";

		int lIntCursor = 0;
		if (lStrCursor != null) {
			lIntCursor = Integer.parseInt(lStrCursor);
		}

		// Obtenemos los registros por pagina
		/**TODO: Descomentar 2 lineas.*/
		//Properties lObjPropiedades = es.prodevelop.utility.Auxiliar.cargarFicheroPropiedades("aplicacion.properties");
		//int lIntPaginas = Integer.valueOf(lObjPropiedades.getProperty("lupa.registros.pagina"));
		int lIntPaginas = 1;

		HashMap lObjHashMap = new HashMap();
		lObjHashMap = obtenerHashMapFinal(request, lStrElegidas, lStrAgrupar, pStrTabla, lStrOrdenar, pStrWherePuerto,
				lStrWhereFiltroHumano, lStrWhereFiltroSql, lStrWhereFiltro, "", lIntCursor, pStrPorDefecto,
				pObjSesionSQL, "AuxiliarLupaSQL", lIntPaginas);

		lObjHashMap.put("pStrCursor", String.valueOf(lIntCursor));

		return lObjHashMap;
	}

	/**
	 * Obtener hash map final.
	 *
	 * @param request
	 *            el request
	 * @param pStrElegidas
	 *            el string Elegidas
	 * @param pStrAgrupar
	 *            el string Agrupar
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrOrdenar
	 *            el string Ordenar
	 * @param pStrWherePuerto
	 *            el string WherePuerto
	 * @param pStrWhereFiltroHumano
	 *            el string WhereFiltroHumano
	 * @param pStrWhereFiltroSql
	 *            el string WhereFiltroSql
	 * @param pStrWhereFiltro
	 *            el string WhereFiltro
	 * @param pStrNombreFiltro
	 *            el string NombreFiltro
	 * @param pIntCursor
	 *            el integer Cursor
	 * @param pStrPorDefecto
	 *            el string PorDefecto
	 * @param pObjSesionSQL
	 *            el objeto SesionSQL
	 * @param pStrSesionNombre
	 *            el string SesionNombre
	 * @param pIntFilas
	 *            el integer Filas
	 *
	 * @return un objeto HashMap
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public HashMap obtenerHashMapFinal(HttpServletRequest request, String pStrElegidas, String pStrAgrupar,
			String pStrTabla, String pStrOrdenar, String pStrWherePuerto, String pStrWhereFiltroHumano,
			String pStrWhereFiltroSql, String pStrWhereFiltro, String pStrNombreFiltro, int pIntCursor,
			String pStrPorDefecto, AuxiliarSQL pObjSesionSQL, String pStrSesionNombre, int pIntFilas)
			throws ApplicationCoreException {

		HashMap lObjHashMap = new HashMap();

		try {
			String lStrWhereFiltro = obtieneWhereFiltro(pStrWhereFiltroHumano, pStrWhereFiltroSql, pStrWhereFiltro,
					pStrNombreFiltro, request, pObjSesionSQL);

			String lStrWhere = "";

			if (pStrWherePuerto == null) {
				pStrWherePuerto = "";
			}
			if (lStrWhereFiltro == null) {
				lStrWhereFiltro = "";
			}

			if ((pStrWherePuerto.equals("")) && (lStrWhereFiltro.equals(""))) {
				lStrWhere = "";
			} else {
				if (pStrWherePuerto.equals("")) {
					lStrWhereFiltro = lStrWhereFiltro.substring(4);
				}
				lStrWhere = " WHERE " + pStrWherePuerto + lStrWhereFiltro;
			}

			pStrElegidas = obtieneElegidas(pStrElegidas, pObjSesionSQL, pStrPorDefecto);
			pStrAgrupar = obtieneAgrupar(pStrAgrupar, pObjSesionSQL);
			pStrOrdenar = obtieneOrdenar(pStrOrdenar, pObjSesionSQL);
			// Visualizaci�n de la agrupaci�n en primer lugar
			pStrElegidas = cambiosVisualizarAgrupacion(pStrAgrupar, pStrElegidas);

			// Obtiene la condici�n
			String lStrCondicion = obtenerCondicion(pStrAgrupar, pStrOrdenar);
			lStrCondicion = lStrWhere + lStrCondicion;

			request.getSession().setAttribute(pStrSesionNombre, pObjSesionSQL);

			TCDelegate lObjTCDelegate = new TCDelegate();
			lObjHashMap = lObjTCDelegate.obtenerHashMap(pStrElegidas, pStrTabla, lStrWhere, lStrCondicion, pIntCursor,
					pIntFilas);

			lObjHashMap.put("pStrAgrupar", pStrAgrupar);

			return lObjHashMap;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS, e.toString(),
					AuxiliarMVC.class.getClass().getSimpleName(), "obtenerHashMapFinal");
		}

	}

	/**
	 * Comprueba administrador.
	 *
	 * @param pObjFuncGenUsuario
	 *            el objeto FuncGenUsuario
	 *
	 * @return true, si satisfactorio
	 *
	 * @throws Exception
	 *             the exception
	 */
	public boolean compruebaAdministrador(Vector pObjFuncGenUsuario) throws Exception {

		Enumeration lObjEnumFuncGenUsuario = pObjFuncGenUsuario.elements();
		while (lObjEnumFuncGenUsuario.hasMoreElements()) {
			String lStrFuncGenUsuario = (String) lObjEnumFuncGenUsuario.nextElement();
			if (lStrFuncGenUsuario.equals("ADMINISTRADOR")) {
				return true;
			}
		}
		return false;
	}

	/**
	 * Buscar string.
	 *
	 * @param pStrABuscar
	 *            el string ABuscar
	 * @param pObjArr
	 *            el objeto Arr
	 *
	 * @return true, si satisfactorio
	 */
	public boolean buscarString(String pStrABuscar, String[] pObjArr) {

		boolean esta = false;

		for (int i = 0; i < pObjArr.length; i++) {
			if (pObjArr[i].equalsIgnoreCase(pStrABuscar)) {
				esta = true;
			}
		}
		return esta;
	}

	/**
	 * Comparar fechas.
	 *
	 * @param lObjFecha1
	 *            el l obj fecha1
	 * @param lObjFecha2
	 *            el l obj fecha2
	 *
	 * @return true, si satisfactorio
	 */
	public boolean compararFechas(java.util.Date lObjFecha1, java.util.Date lObjFecha2) {

		return lObjFecha1.after(lObjFecha2);

	}

	/**
	 * Procesar numero decimal.
	 *
	 * @param pObjDecimal
	 *            el objeto Decimal
	 *
	 * @return un objeto String
	 */
	public String procesarNumeroDecimal(BigDecimal pObjDecimal) {

		String lStrRetorno = "";
		if (pObjDecimal != null) {
			lStrRetorno = pObjDecimal.toString();
		}
		// Si vale 0.00 se manda la cadena vacia
		if (lStrRetorno.equalsIgnoreCase("0.00")) {
			lStrRetorno = "";
		}

		if (lStrRetorno.equalsIgnoreCase("0.0")) {
			lStrRetorno = "";
		}

		if (lStrRetorno.equalsIgnoreCase("0.000")) {
			lStrRetorno = "";
		}

		if (lStrRetorno.equalsIgnoreCase("0.0000")) {
			lStrRetorno = "";
		}

		return lStrRetorno;
	}

	/**
	 * Validar sesion.
	 *
	 * @param pObjSesion
	 *            el objeto Sesion
	 *
	 * @return true, si satisfactorio
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public boolean validarSesion(HttpSession pObjSesion) throws ApplicationCoreException {

		try {
			String lStrIdSesion = (String) pObjSesion.getAttribute("IDSESION");
			if (lStrIdSesion.equalsIgnoreCase(pObjSesion.getId())) {
				return true;
			} else {
				throw new ApplicationCoreException(ApplicationCoreException.SINSESION,
						ApplicationCoreException.CAUSA_SINSESION, AuxiliarMVC.class.getClass().getSimpleName(),
						"validarPermisoAccion");
			}

		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.SINSESION, e.toString(), AuxiliarMVC.class
					.getClass().getSimpleName(), "validarSesion");
		}

	}

	/**
	 * Validar permiso accion.
	 *
	 * @param pObjSesion
	 *            el objeto Sesion
	 * @param pStrAccion
	 *            el string Accion
	 *
	 * @return true, si satisfactorio
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public boolean validarPermisoAccion(HttpSession pObjSesion, String pStrAccion) throws ApplicationCoreException {

		try {
			if (pObjSesion == null) {
				throw new ApplicationCoreException(ApplicationCoreException.SINSESION,
						ApplicationCoreException.CAUSA_SINSESION, AuxiliarMVC.class.getClass().getSimpleName(),
						"validarPermisoAccion");
			}
			if (pStrAccion == null) {
				return true;
			} else {
				// String lStrIdSesion = (String)
				// pObjSesion.getAttribute("IDSESION");
				// if (lStrIdSesion.equalsIgnoreCase(pObjSesion.getId())) {
				// Se valida el permiso de la acci�n
				Vector lObjVectorFuncionalidades = (Vector) pObjSesion.getAttribute("FUNCIONES");
				if (lObjVectorFuncionalidades.contains(pStrAccion)) {
					return true;
				} else {
					throw new ApplicationCoreException(ApplicationCoreException.SINPERMISO,
							ApplicationCoreException.CAUSA_SINPERMISO, this.getClass().getSimpleName(),
							"validarPermisoAccion");
				}

			}

		} catch (ApplicationCoreException e) {
			throw e;
		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.SINSESION,
					ApplicationCoreException.CAUSA_SINSESION, AuxiliarMVC.class.getClass().getSimpleName(),
					"validarPermisoAccion");
		}
	}

	/**
	 * Quitar punto.
	 *
	 * @param pStrVariable
	 *            el string Variable
	 *
	 * @return un objeto String
	 */
	public String quitarPunto(String pStrVariable) {

		return pStrVariable.substring(0, pStrVariable.indexOf("."))
				+ pStrVariable.substring(pStrVariable.indexOf(".") + 1);
	}

	/**
	 * Poner ceros.
	 *
	 * @param pStrVariable
	 *            el string Variable
	 * @param pIntLongitud
	 *            el integer Longitud
	 *
	 * @return un objeto String
	 */
	public String ponerCeros(String pStrVariable, int pIntLongitud) {

		int lIntLon = pStrVariable.length();
		for (int i = 0; i < pIntLongitud - lIntLon; i++) {
			pStrVariable = "0" + pStrVariable;
		}
		return pStrVariable;
	}

	/**
	 * Num2str.
	 *
	 * @param obj
	 *            el obj
	 *
	 * @return un objeto String
	 */
	public static String num2str(Object obj) {

		if (obj == null)
			return "";
		return String.valueOf(obj);
	}

	/**
	 * Num2str.
	 *
	 * @param obj
	 *            el obj
	 *
	 * @return un objeto String
	 */
	public static String num2str(int obj) {

		return String.valueOf(obj);
	}

	/**
	 * Num2str.
	 *
	 * @param obj
	 *            el obj
	 *
	 * @return un objeto String
	 */
	public static String num2str(float obj) {

		return String.valueOf(obj);
	}

	/**
	 * Num2str.
	 *
	 * @param obj
	 *            el obj
	 *
	 * @return un objeto String
	 */
	public static String num2str(double obj) {

		return String.valueOf(obj);
	}

	/**
	 * Str2int.
	 *
	 * @param obj
	 *            el obj
	 *
	 * @return un objeto int
	 */
	public static int str2int(Object obj) {

		if (obj == null)
			return 0;
		return Integer.parseInt("0" + (String) obj);
	}

	/**
	 * Str2dbl.
	 *
	 * @param obj
	 *            el obj
	 *
	 * @return un objeto double
	 */
	public static double str2dbl(Object obj) {

		if (obj == null)
			return 0;
		return Double.parseDouble("0" + (String) obj);
	}

	/**
	 * Str2float.
	 *
	 * @param obj
	 *            el obj
	 *
	 * @return un objeto double
	 */
	public static double str2float(Object obj) {

		if (obj == null)
			return 0;
		return Float.parseFloat("0" + (String) obj);
	}

	/**
	 * Obj2str.
	 *
	 * @param obj
	 *            el obj
	 *
	 * @return un objeto String
	 */
	public static String obj2str(Object obj) {

		if (obj == null)
			return "";
		return obj.toString();
	}

	/**
	 * Replace first.
	 *
	 * @param texto
	 *            el texto
	 * @param remplazable
	 *            el remplazable
	 * @param remplazador
	 *            el remplazador
	 *
	 * @return un objeto String
	 */
	public static String replaceFirst(String texto, String remplazable, String remplazador) {

		int i = texto.indexOf(remplazable);
		if (i < 0)
			return texto;
		int j = i + remplazable.length();
		String res = texto.substring(0, i - 1);
		res += remplazador;
		res += texto.substring(j, texto.length());
		return res;
	}

	/**
	 * Replace all.
	 *
	 * @param s
	 *            el s
	 * @param oldText
	 *            el old text
	 * @param newText
	 *            el new text
	 *
	 * @return un objeto String
	 */
	public static String replaceAll(String s, String oldText, String newText) {

		final int sLength = s.length();
		final int oldLength = oldText.length();
		final int newLength = newText.length();

		if (oldText.equals(newText))
			return s;

		StringBuffer sb = null;

		if (newLength <= oldLength) {
			sb = new StringBuffer(sLength);
		} else {
			int c = 0; // count the number of replacements to optimize memory
			// usage

			int i = 0;

			while ((i = s.indexOf(oldText, i)) > -1) {
				i += oldLength;
				c++;
			}

			if (c == 0)
				return s;

			sb = new StringBuffer(sLength + c * (newLength - oldLength));
		}

		int i = 0, x = 0;

		while ((x = s.indexOf(oldText, i)) > -1) {
			sb.append(s.substring(i, x));
			sb.append(newText);
			i = x + oldLength;
		}

		sb.append(s.substring(i));

		return sb.toString();
	}

	/**
	 * Convierte string.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto String
	 */
	public String convierteString(String pStrCadena) {

		String lStrTexto = null;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			lStrTexto = pStrCadena;
		}
		return lStrTexto;
	}

	/**
	 * Convierte int.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto int
	 */
	public int convierteInt(String pStrCadena) {

		int lIntEntero = -1;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			lIntEntero = Integer.parseInt(pStrCadena);
		}
		return lIntEntero;
	}

	/**
	 * Convierte long.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto long
	 */
	public long convierteLong(String pStrCadena) {

		long lLngEntero = -1;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			lLngEntero = Long.parseLong(pStrCadena);
		}
		return lLngEntero;
	}

	/**
	 * Convierte big decimal.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto BigDecimal
	 */
	public BigDecimal convierteBigDecimal(String pStrCadena) {

		BigDecimal lObjBigDecimal = null;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			lObjBigDecimal = new BigDecimal(pStrCadena);
		}
		return lObjBigDecimal;
	}

	/**
	 * Convierte date.
	 *
	 * @param pStrDiaMesAnyo
	 *            el string DiaMesAnyo
	 *
	 * @return un objeto Date
	 */
	public Date convierteDate(String pStrDiaMesAnyo) {

		Date lObjFecha = null;
		if ((pStrDiaMesAnyo != null) && (!pStrDiaMesAnyo.equalsIgnoreCase(""))) {
			lObjFecha = Fecha.generarFecha(pStrDiaMesAnyo);
		}
		return lObjFecha;
	}

	/**
	 * Convierte date.
	 *
	 * @param pStrDiaMesAnyo
	 *            el string DiaMesAnyo
	 * @param pStrHoraMinuto
	 *            el string HoraMinuto
	 *
	 * @return un objeto Date
	 */
	public Date convierteDate(String pStrDiaMesAnyo, String pStrHoraMinuto) {

		Date lObjFecha = null;
		if ((pStrDiaMesAnyo != null) && (!pStrDiaMesAnyo.equalsIgnoreCase("")) && (pStrHoraMinuto != null)
				&& (!pStrHoraMinuto.equalsIgnoreCase(""))) {
			lObjFecha = Fecha.generarFechaHoraMinutos(pStrDiaMesAnyo, pStrHoraMinuto);
		}
		return lObjFecha;
	}

	/**
	 * Convierte check.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto String
	 */
	public String convierteCheck(String pStrCadena) {

		String lStrCheck = "1";
		if (pStrCadena == null) {
			lStrCheck = "0";
		}
		return lStrCheck;
	}

	/**
	 * Espacios html.
	 *
	 * @param num
	 *            el num
	 *
	 * @return un objeto String
	 */
	public static String espaciosHTML(int num) {

		String res = "";
		for (int i = 0; i < num; i++) {
			res += " ";
		}
		return res;
	}

	/*
	 * public void doLogInfo(HttpServletRequest pObjReq, String
	 * pStrTipoOperacion, Logger pObjLogger, String pStrDto) throws Exception {
	 *
	 * String lStrUsuario = this.getUsuario(pObjReq); String lStrTipoOperacion =
	 * ""; if (pStrTipoOperacion.equalsIgnoreCase("C")) { lStrTipoOperacion =
	 * "Consulta"; } else if (pStrTipoOperacion.equalsIgnoreCase("M")) {
	 * lStrTipoOperacion = "Modificaci�n"; } else if
	 * (pStrTipoOperacion.equalsIgnoreCase("I")) { lStrTipoOperacion =
	 * "Inserci�n"; } else if (pStrTipoOperacion.equalsIgnoreCase("B")) {
	 * lStrTipoOperacion = "Borrado"; } else if
	 * (pStrTipoOperacion.equalsIgnoreCase("L")) { lStrTipoOperacion =
	 * "Liquidaci�n"; }
	 *
	 * String lStrMetodo = this.getOperacionLog(pObjReq); String lStrLog =
	 * "Metodo:" + lStrMetodo + " Usuario:" + lStrUsuario + " Tipo Operaci�n:"
	 * + lStrTipoOperacion; if (pStrDto != null ||
	 * !pStrDto.equalsIgnoreCase("")) { lStrLog = lStrLog + " Registro: " +
	 * pStrDto; } }
	 */

	/*
	 * private String getOperacionLog(HttpServletRequest pObjReq) throws
	 * Exception {
	 *
	 * String lStrQueryString = pObjReq.getQueryString(); if (lStrQueryString !=
	 * null) { String[] lStrAux = lStrQueryString.split("="); String[] lStrAux1
	 * = lStrAux[1].split("&"); String lStrRetorno = lStrAux1[0]; return
	 * lStrRetorno; } else return ""; }
	 */

	/*
	 * private String getUsuario(HttpServletRequest pObjReq) throws Exception {
	 *
	 * HttpSession lObjSesion = pObjReq.getSession(); if (lObjSesion != null)
	 * return (String) lObjSesion.getAttribute("CODUSUARIO"); else return ""; }
	 */

	/**
	 * Existe permiso.
	 *
	 * @param pObjSesion
	 *            el objeto Sesion
	 * @param pStrAccion
	 *            el string Accion
	 *
	 * @return true, si satisfactorio
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public boolean existePermiso(HttpSession pObjSesion, String pStrAccion) throws ApplicationCoreException {

		try {
			if (pObjSesion == null) {
				throw new ApplicationCoreException(ApplicationCoreException.SINSESION,
						ApplicationCoreException.CAUSA_SINSESION, AuxiliarMVC.class.getClass().getSimpleName(),
						"validarPermisoAccion");
			}
			if (pStrAccion == null) {
				return true;
			} else {
				String lStrIdSesion = (String) pObjSesion.getAttribute("IDSESION");
				if (lStrIdSesion.equalsIgnoreCase(pObjSesion.getId())) {
					// Se valida el permiso de la acci�n
					Vector lObjVectorFuncionalidades = (Vector) pObjSesion.getAttribute("FUNCIONALIDADES");
					if (lObjVectorFuncionalidades.contains(pStrAccion)) {
						return true;
					} else {
						return false;
					}
				} else {
					throw new ApplicationCoreException(ApplicationCoreException.SINSESION,
							ApplicationCoreException.CAUSA_SINSESION, AuxiliarMVC.class.getClass().getSimpleName(),
							"validarPermisoAccion");
				}
			}

		} catch (ApplicationCoreException e) {
			throw e;
		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.SINSESION,
					ApplicationCoreException.CAUSA_SINSESION, AuxiliarMVC.class.getClass().getSimpleName(),
					"validarPermisoAccion");
		}
	}

	/**
	 * Existe sesion.
	 *
	 * @param pObjReq
	 *            el objeto Req
	 *
	 * @return un objeto HttpSession
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public HttpSession existeSesion(HttpServletRequest pObjReq) throws ApplicationCoreException {

		HttpSession lObjSesion = pObjReq.getSession();
		if ((lObjSesion == null) || (lObjSesion.getAttribute("USR") == null)) {
			throw new ApplicationCoreException(ApplicationCoreException.SINSESION,
					ApplicationCoreException.CAUSA_SINSESION, AuxiliarMVC.class.getClass().getSimpleName(),
					"validarPermisoAccion");
		} else {
			return lObjSesion;
		}
	}

	/**
	 * Comprobar guid.
	 *
	 * @param guid1
	 *            el guid1
	 * @param guid2
	 *            el guid2
	 *
	 * @throws ApplicationCoreException
	 *             the application exception
	 */
	public static void comprobarGuid(String guid1, String guid2) throws ApplicationCoreException {

		if ((guid1 == null || guid1.equals("")) && (guid2 == null || guid2.equals("")))
			return;
		if (guid1 == null || guid2 == null || !guid1.equals(guid2)) {
			throw new ApplicationCoreException(ApplicationCoreException.ACCESOSIMULTANEO,
					ApplicationCoreException.CAUSA_ACCESOSIMULTANEO, AuxiliarMVC.class.getClass().getSimpleName(),
					"validarPermisoAccion");
		}
	}

	/**
	 * Es numerico.
	 *
	 * @param lStrEntrada
	 *            el l str entrada
	 *
	 * @return true, si satisfactorio
	 */
	public boolean esNumerico(String lStrEntrada) {

		try {
			Double.parseDouble(lStrEntrada);
			return true;
		} catch (Exception e) {
			return false;
		}
	}

	/**
	 * Convierte ascii.
	 *
	 * @param lLngEntrada
	 *            el l lng entrada
	 *
	 * @return un objeto String
	 */
	public String convierteAscii(long lLngEntrada) {

		String lStrRetorno = "";
		char c;
		c = (char) lLngEntrada;
		lStrRetorno = String.valueOf(c);
		return lStrRetorno;
	}

	/**
	 * Encode rtf.
	 *
	 * @param pStrOrigen
	 *            el string Origen
	 *
	 * @return un objeto String
	 */
	public String encodeRTF(String pStrOrigen) {

		char lcaracter;
		String lStrSalida = "";
		for (int i = 0; i < pStrOrigen.length(); i++) {
			lcaracter = pStrOrigen.charAt(i);
			int lascii = (int) lcaracter;
			if (lascii < 128) {
				lStrSalida += lcaracter;
			} else
				lStrSalida += (char) 92 + "'" + Long.toHexString(lascii);
		}
		return lStrSalida;
	}

	/**
	 * Coeficiente aporcentaje.
	 *
	 * @param lBigCoeficiente
	 *            el l big coeficiente
	 *
	 * @return un objeto BigDecimal
	 */
	public BigDecimal coeficienteAporcentaje(BigDecimal lBigCoeficiente) {

		if (lBigCoeficiente == null)
			return null;
		else
			return lBigCoeficiente.multiply(new BigDecimal(100));
	}

	/**
	 * Porcentaje acoeficiente.
	 *
	 * @param lBigPorcentaje
	 *            el l big porcentaje
	 * @param scale
	 *            el scale
	 *
	 * @return un objeto BigDecimal
	 */
	public BigDecimal porcentajeAcoeficiente(BigDecimal lBigPorcentaje, int scale) {

		if (lBigPorcentaje == null)
			return null;
		else
			return lBigPorcentaje.divide(new BigDecimal(100), scale, BigDecimal.ROUND_DOWN);
	}

	/**
	 * Compress.
	 *
	 * @param trg
	 *            el trg
	 *
	 * @return un objeto String
	 */
	public String compress(String trg) {

		try {
			byte[] buf;
			int l;
			Deflater comp = new Deflater();
			comp.setInput(trg.getBytes());
			comp.finish();

			buf = new byte[1024];
			l = comp.deflate(buf);

			return new String(buf, 0, l);
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		}
	}

	/**
	 * Decompress.
	 *
	 * @param trg
	 *            el trg
	 *
	 * @return un objeto String
	 */
	public String decompress(String trg) {

		try {
			byte[] buf;
			int l;
			Inflater decomp = new Inflater();
			decomp.setInput(trg.getBytes());

			buf = new byte[1024];
			l = decomp.inflate(buf);
			return new String(buf, 0, l);
		} catch (Exception e) {
			e.printStackTrace();
			return "";
		}
	}

	/**
	 * Borra cabecera popup.
	 *
	 * @param request
	 *            el request
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrNombreSesion
	 *            el string NombreSesion
	 */
	public void borraCabeceraPopup(HttpServletRequest request, String pStrTabla, String pStrNombreSesion) {

		// Lectura y escritura del objeto de Sesi�n (completo)
		HashMap lObjSesionSQL = (HashMap) request.getSession().getAttribute(pStrNombreSesion);

		lObjSesionSQL = null;
		lObjSesionSQL = new HashMap();
		lObjSesionSQL.put("TABLAACTUAL", pStrTabla);

		this.setCabeceraPopup(request, lObjSesionSQL, pStrNombreSesion);
	}

	/**
	 * Obtiene el cabecera popup.
	 *
	 * @param request
	 *            el request
	 * @param pStrTabla
	 *            el string Tabla
	 * @param pStrNombreSesion
	 *            el string NombreSesion
	 *
	 * @return el cabecera popup
	 */
	public HashMap getCabeceraPopup(HttpServletRequest request, String pStrTabla, String pStrNombreSesion) {

		// Lectura y escritura del objeto de Sesi�n (completo)
		HashMap lObjSesionSQL = (HashMap) request.getSession().getAttribute(pStrNombreSesion);
		if (lObjSesionSQL == null) {
			request.getSession().setAttribute(pStrNombreSesion, new HashMap());
			lObjSesionSQL = (HashMap) request.getSession().getAttribute(pStrNombreSesion);
		}

		// Borrado del objeto de Sesi�n si cambiamos de tabla
		if (lObjSesionSQL.get("TABLAACTUAL") == null) {
			lObjSesionSQL.put("TABLAACTUAL", pStrTabla);
		} else {
			String lStrIdNuevo = pStrTabla;
			String lStrIdViejo = (String) lObjSesionSQL.get("TABLAACTUAL");
			if (!(lStrIdNuevo.equals(lStrIdViejo))) {
				lObjSesionSQL = null;
				lObjSesionSQL = new HashMap();
				lObjSesionSQL.put("TABLAACTUAL", pStrTabla);
			}
		}
		return lObjSesionSQL;
	}

	/**
	 * Asigna el cabecera popup.
	 *
	 * @param request
	 *            el request
	 * @param pObjHashMap
	 *            el objeto HashMap
	 * @param pStrNombreSesion
	 *            el string NombreSesion
	 */
	public void setCabeceraPopup(HttpServletRequest request, HashMap pObjHashMap, String pStrNombreSesion) {

		request.getSession().setAttribute(pStrNombreSesion, pObjHashMap);
	}

	/**
	 * Cv string.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto String
	 */
	public String cvString(String pStrCadena) {

		String lStrTexto = null;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			lStrTexto = pStrCadena;
		}
		return lStrTexto;
	}

	/**
	 * Cv integer.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto Integer
	 */
	public Integer cvInteger(String pStrCadena) {

		Integer lIntEntero = null;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			try {
				lIntEntero = new Integer(pStrCadena);
			} catch (Throwable e) {
			}
		}
		return lIntEntero;
	}

	/**
	 * Cv long.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto Long
	 */
	public Long cvLong(String pStrCadena) {

		Long lLngEntero = null;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			try {
				lLngEntero = new Long(pStrCadena);
			} catch (Throwable e) {
			}
		}
		return lLngEntero;
	}

	/**
	 * Cv big decimal.
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto BigDecimal
	 */
	public BigDecimal cvBigDecimal(String pStrCadena) {

		BigDecimal lObjBigDecimal = null;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			try {
				lObjBigDecimal = new BigDecimal(pStrCadena);
			} catch (Throwable e) {
			}
		}
		return lObjBigDecimal;
	}

	public Float cvFloat(String pStrCadena) {

		Float lObjFloat = null;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			try {
				lObjFloat = new Float(pStrCadena);
			} catch (Throwable e) {
			}
		}
		return lObjFloat;
	}

	/**
	 * Cv date.
	 * Si se agrega un prefijo TS_ a la fecha en formato texto se devolvera un objeto en formato DD/MM/AAAA HH:MM:SS,
	 * de lo contrario con formato DD/MM/AAAA
	 * ej:
	 * 		TS_12/05/2011 23:14:22           --> objeto fecha 12/05/2011 23:14:22
	 * 		12/05/2011 23:14:22 o 12/05/2011 --> objeto fecha 12/05/2011
	 *
	 * @param pStrCadena
	 *            el string Cadena
	 *
	 * @return un objeto Date
	 */
	public Date cvDate(String pStrCadena) {

		Date lObjFecha = null;
		if ((pStrCadena != null) && (!pStrCadena.equalsIgnoreCase(""))) {
			if(pStrCadena.startsWith("TS_")) lObjFecha = Fecha.generarFechaHoraMinutosSegundos(pStrCadena.substring(3));
			else lObjFecha = Fecha.generarFecha(pStrCadena);
		}
		return lObjFecha;
	}

	/**
	 * Formatear con arrobas.
	 *
	 * @param pArrayValores
	 *            el array valores
	 *
	 * @return un objeto String
	 *
	 * @throws Exception
	 *             the exception
	 */
	public String formatearConArrobas(ArrayList pArrayValores) throws Exception {

		if (pArrayValores == null || pArrayValores.size() == 0)
			return null;
		String lStrValores = pArrayValores.toString();
		lStrValores = lStrValores.replaceAll("\\[", "");
		lStrValores = lStrValores.replaceAll("\\]", "");
		lStrValores = lStrValores.replaceAll(",", "@");
		lStrValores = lStrValores.replaceAll(" ", "");
		return lStrValores;
	}

	/**
	 * Tratar error.
	 *
	 * @param pObjExcepcion
	 *            el objeto Excepcion
	 * @param pObjRequest
	 *            el objeto Request
	 */
	public static void tratarError(ApplicationCoreException pObjExcepcion, HttpServletRequest pObjRequest) {

		int lIntCodigo = pObjExcepcion.getCodigo();

		switch (lIntCodigo) {

		case ApplicationCoreException.ERROR_ACCESO_DATOS:
			pObjRequest.setAttribute("pStrDescError", "error.BD");
			break;

		case ApplicationCoreException.SINSESION:
			pObjRequest.setAttribute("pStrDescError", "error.sinsesion");
			break;
		case ApplicationCoreException.SINPERMISO:
			pObjRequest.setAttribute("pStrDescError", "error.sinpermiso");
			break;
		case ApplicationCoreException.EXISTEUSUARIO_BD:
			pObjRequest.setAttribute("pStrDescError", "error.existeUsuario");
			break;

		default:
			pObjRequest.setAttribute("pStrDescError", "error.desconocido");
			break;
		}
	}

	/**
	 * Rellena dto.
	 *
	 * @param pObjForm
	 *            el objeto Form
	 * @param pObjDTO
	 *            el objeto DTO
	 *
	 * @return un objeto Object
	 *
	 * @throws IllegalAccessException
	 *             the illegal access exception
	 * @throws InvocationTargetException
	 *             the invocation target exception
	 * @throws NoSuchMethodException
	 *             the no such method exception
	 */
	public Object rellenaDTO(FormularioMAP pObjForm, Object pObjDTO) throws IllegalAccessException,
			InvocationTargetException, NoSuchMethodException {

		Map lObjCamposformulario = pObjForm.getValues();
		Set lObjNombrecamposform = lObjCamposformulario.keySet();

		Iterator lObjItNombrecamposform = lObjNombrecamposform.iterator();

		while (lObjItNombrecamposform.hasNext()) {
			String lStrNombreatributo = (String) lObjItNombrecamposform.next();
			String lStrValoratributo = (String) pObjForm.getValue(lStrNombreatributo);
			lStrNombreatributo = lStrNombreatributo.toLowerCase();

			Class lObjTipo = null;
			try {
				lObjTipo = PropertyUtils.getPropertyType(pObjDTO, lStrNombreatributo);
				Object lObjValoratributo = null;
				if (lObjTipo != null) {
					if (lObjTipo.getName().equalsIgnoreCase("java.util.Date")) {
						lObjValoratributo = this.cvDate(lStrValoratributo);
					}

					if (lObjTipo.getName().equalsIgnoreCase("java.lang.String")) {
						lObjValoratributo = this.cvString(lStrValoratributo);
					}

					if (lObjTipo.getName().equalsIgnoreCase("java.lang.Integer")) {
						lObjValoratributo = this.cvInteger(lStrValoratributo);
					}
					if (lObjTipo.getName().equalsIgnoreCase("java.lang.Long")) {
						lObjValoratributo = this.cvLong(lStrValoratributo);
					}

					if (lObjTipo.getName().equalsIgnoreCase("java.math.BigDecimal")) {
						lObjValoratributo = this.cvBigDecimal(lStrValoratributo);
					}
					if (lObjTipo.getName().equalsIgnoreCase("java.lang.Float")) {
						lObjValoratributo = this.cvFloat(lStrValoratributo);
					}

					PropertyUtils.setProperty(pObjDTO, lStrNombreatributo, lObjValoratributo);
				}
			} catch (Throwable e) {
				// Fallo no controlado. Se devuelve el DTO
				LogFactory.getLog(this.getClass()).error(e);
			}
		}

		return pObjDTO;
	}
	
	public Object rellenaDTO(ElementoXML pObjElem, Object pObjDTO) throws IllegalAccessException,InvocationTargetException, NoSuchMethodException {
		
		ArrayList<ElementoXML> lColElemXML = pObjElem.getElementos();
		
		//Todo, hacer un while simple y hacerlo para los elements
		for (ElementoXML lObjElemXML: lColElemXML) {
			String lStrNombreatributo = lObjElemXML.getNombre();
			String lStrValoratributo = (String) lObjElemXML.getValor();
			lStrNombreatributo = lStrNombreatributo.toLowerCase();
		
			Class lObjTipo = null;
			try {
				lObjTipo = PropertyUtils.getPropertyType(pObjDTO, lStrNombreatributo);
				Object lObjValoratributo = null;
				if (lObjTipo != null) {
					if (lObjTipo.getName().equalsIgnoreCase("java.util.Date")) {
						lObjValoratributo = Fecha.generarFechaMascara(lStrValoratributo,"yyyy-MM-dd");
					}
		
					if (lObjTipo.getName().equalsIgnoreCase("java.lang.String")) {
						String lStrAux = this.cvString(lStrValoratributo);
						if(lStrAux.equalsIgnoreCase("false")){
							lStrAux = "0";
						}
						else if(lStrAux.equalsIgnoreCase("true")){
							lStrAux = "1";
						}
						lObjValoratributo = this.cvString(lStrAux);
					}
		
					if (lObjTipo.getName().equalsIgnoreCase("java.lang.Integer")) {
						lObjValoratributo = this.cvInteger(lStrValoratributo);
					}
					if (lObjTipo.getName().equalsIgnoreCase("java.lang.Long")) {
						lObjValoratributo = this.cvLong(lStrValoratributo);
					}
		
					if (lObjTipo.getName().equalsIgnoreCase("java.math.BigDecimal")) {
						lObjValoratributo = this.cvBigDecimal(lStrValoratributo);
					}
					if (lObjTipo.getName().equalsIgnoreCase("java.lang.Float")) {
						lObjValoratributo = this.cvFloat(lStrValoratributo);
					}
		
					PropertyUtils.setProperty(pObjDTO, lStrNombreatributo, lObjValoratributo);
				}
			} 
			catch (Throwable e) {
				// Fallo no controlado. Se devuelve el DTO
				LogFactory.getLog(this.getClass()).error(e);
			}
		}
	
		return pObjDTO;
	}	

	/**
	 * Obtiene el acciones tc.
	 *
	 * @param pObjFuncGenUsuario
	 *            el objeto FuncGenUsuario
	 * @param pObjFuncPantalla
	 *            el objeto FuncPantalla
	 *
	 * @return el acciones tc
	 *
	 * @throws Exception
	 *             the exception
	 */
	public ArrayList getAccionesTC(Vector pObjFuncGenUsuario, ArrayList pObjFuncPantalla) throws Exception {
		int lIntContador = 0;
		ArrayList lObjAcciones = new ArrayList();

		Enumeration lObjEnumFuncGenUsuario = pObjFuncGenUsuario.elements();
		while (lObjEnumFuncGenUsuario.hasMoreElements()) {
			String lStrFuncGenUsuario = (String) lObjEnumFuncGenUsuario.nextElement();
			Iterator lObjEnumFuncPantalla = pObjFuncPantalla.iterator();
			while (lObjEnumFuncPantalla.hasNext()) {
				String lStrFuncPantalla = (String) lObjEnumFuncPantalla.next();
				String[] lObjFuncPantalla = this.splitCadena(lStrFuncPantalla, "@");
				if (lStrFuncGenUsuario.equals(lObjFuncPantalla[0])) {
					lObjAcciones.add(lStrFuncPantalla);
					lIntContador++;
				}
			}
		}
		return lObjAcciones;
	}

	/**
	 * Hace un split del string que se pasa como par�metro<br>
	 *
	 * @param pStrCadena
	 *            Cadena de la que se hace el split<BR>
	 * @param pStrCadena
	 *            Separador tomado para hacer el split<BR>
	 * @return String[] Array de strings resultado del split<br>
	 * @exception Exception
	 *                si hay alguna excepci�n <BR>
	 *
	 */
	static public String[] splitCadena(String pStrCadena, String pStrSeparador) throws Exception {

		StringTokenizer lObjToken = new StringTokenizer(pStrCadena, pStrSeparador);
		String[] lObjRetorno = new String[lObjToken.countTokens()];

		int i = 0;
		while (lObjToken.hasMoreTokens()) {
			lObjRetorno[i] = new String(lObjToken.nextToken());
			i++;
		}
		return lObjRetorno;
	}

	/**
	 * Busca permiso con derecho
	 *
	 * @param pObjRequest
	 * @param pStrIdFuncio
	 * @param pStrDret
	 * @return
	 * @throws Exception
	 */
	public static boolean compruebaPermiso(HttpSession pObjSesion, String pStrIdFuncio)
			throws Exception {
		Vector lObjLista = (Vector) pObjSesion.getAttribute("FUNCIONES");
		boolean lObjPermiso = lObjLista.contains(pStrIdFuncio);
		return lObjPermiso;
	}

	/**
	 * Comprueba permiso padre.
	 *
	 * @param pObjSesion
	 *            el objeto Sesion
	 * @param pStrIdFuncio
	 *            el string IdFuncio
	 *
	 * @return true, si satisfactorio
	 *
	 * @throws Exception
	 *             the exception
	 */
	public static boolean compruebaPermisoPadre(HttpSession pObjSesion, String pStrIdFuncio) throws Exception {
		ArrayList<String> lObjLista = (ArrayList<String>) pObjSesion.getAttribute("FUNCIONESPADRE");
		boolean lObjPermiso = lObjLista.contains(pStrIdFuncio);
		return lObjPermiso;
	}

	/**
	 * Rellena dto con prefijo. Carga el DTO quitando el prefijo a los campos.
	 *
	 * @param pObjForm
	 *            el objeto Form
	 * @param pObjDTO
	 *            el objeto DTO
	 *
	 * @return un objeto Object
	 *
	 * @throws IllegalAccessException
	 *             the illegal access exception
	 * @throws InvocationTargetException
	 *             the invocation target exception
	 * @throws NoSuchMethodException
	 *             the no such method exception
	 */
	public Object rellenaDTOConPrefijo(FormularioMAP pObjForm, Object pObjDTO, String pStrPrefijo)
			throws IllegalAccessException, InvocationTargetException, NoSuchMethodException {

		Map lObjCamposformulario = pObjForm.getValues();
		Set lObjNombrecamposform = lObjCamposformulario.keySet();

		Iterator lObjItNombrecamposform = lObjNombrecamposform.iterator();

		while (lObjItNombrecamposform.hasNext()) {
			String lStrNombreatributo = (String) lObjItNombrecamposform.next();
			if (lStrNombreatributo.startsWith(pStrPrefijo)) {
				String lStrValoratributo = (String) pObjForm.getValue(lStrNombreatributo);
				lStrNombreatributo = lStrNombreatributo.replaceFirst(pStrPrefijo, "");
				lStrNombreatributo = lStrNombreatributo.toLowerCase();

				Class lObjTipo = null;
				try {
					lObjTipo = PropertyUtils.getPropertyType(pObjDTO, lStrNombreatributo);

					Object lObjValoratributo = null;
					if (lObjTipo != null) {
						if (lObjTipo.getName().equalsIgnoreCase("java.util.Date")) {
							lObjValoratributo = this.cvDate(lStrValoratributo);
						}
						if (lObjTipo.getName().equalsIgnoreCase("java.lang.String")) {
							lObjValoratributo = this.cvString(lStrValoratributo);
						}
						if (lObjTipo.getName().equalsIgnoreCase("java.lang.Integer")) {
							lObjValoratributo = this.cvInteger(lStrValoratributo);
						}
						if (lObjTipo.getName().equalsIgnoreCase("java.lang.Long")) {
							lObjValoratributo = this.cvLong(lStrValoratributo);
						}
						if (lObjTipo.getName().equalsIgnoreCase("java.math.BigDecimal")) {
							lObjValoratributo = this.cvBigDecimal(lStrValoratributo);
						}
						if (lObjTipo.getName().equalsIgnoreCase("java.lang.Float")) {
							lObjValoratributo = this.cvFloat(lStrValoratributo);
						}

						PropertyUtils.setProperty(pObjDTO, lStrNombreatributo, lObjValoratributo);
					}
				} catch (Throwable e) {
					// No existe la propiedad del form en el bean (puede
					// haber muchas m�s propiedades en el form)
				}
			}
		}

		return pObjDTO;
	}
	
	/**
	 * Obtiene la Base de Datos que se est utilizando
	 *
	 * 
	 * @return un objeto String
	 */
	
	public static String obtenerTipoBBDD(){
		String lStrBBDD = null;		
		try {
			
			Properties lObjProps = Auxiliar.cargarFicheroPropiedades("aplicacion.properties");
			lStrBBDD = lObjProps.getProperty("APLICACION.BBDD");
		
		} catch (Throwable e) {
			e.printStackTrace();
		}
		return lStrBBDD;
	}
	
	public String limpiaAcentos(String pStrCadena){
		
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","a");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","a");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","A");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","A");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","e");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","e");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","E");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","E");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","i");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","I");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","o");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","o");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","O");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","O");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","U");
		pStrCadena = AuxiliarMVC.replaceAll(pStrCadena, "","U");
		
		return pStrCadena;
	
	}
	
}
