/**
 * 
 */
package es.postigo.dao;

import java.util.List;

import es.postigo.dto.Movimientos;
import es.postigo.dto.MovimientosPk;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.MovimientosDaoException;

/**
 * @author informatica4
 *
 */
public interface MovimientosDao {

	/**
	 * Method 'insert'
	 * 
	 * @param dto
	 * @return MovimientosPk
	 * @throws MovimientosDaoException 
	 */
	public MovimientosPk insert(Movimientos dto) throws MovimientosDaoException;
	
	/** 
	 * Updates a single row in the Movimientos table.
	 */
	public void update(MovimientosPk pk, Movimientos dto) throws MovimientosDaoException, ApplicationException;

	
	/** 
	 * Deletes a single row in the Movimientos table.
	 */
	public void delete(String codUbicacion, String codProducto) throws MovimientosDaoException;

	/** 
	 * Returns all rows from the Movimientos table that match the criteria 'CODIGO = :codigo'.
	 */
	public Movimientos findByPrimaryKey(String ubiOrigen, String ubiDestino, String codProducto, String fecha) throws MovimientosDaoException;

	/** 
	 * Returns all rows from the Movimientos table that match the criteria ''.
	 */
	public List<Movimientos> findAll() throws MovimientosDaoException;

	/** 
	 * Returns all rows from the Movimientos table that match the criteria 'CODIGO = :codigo'.
	 */
	public List<Movimientos> findWhereUbiOrigenEquals(String codigo) throws MovimientosDaoException;
	
	/** 
	 * Returns all rows from the Movimientos table that match the criteria 'CODIGO = :codigo'.
	 */
	public List<Movimientos> findWhereUbiDestinoEquals(String codigo) throws MovimientosDaoException;

	/** 
	 * Returns all rows from the Movimientos table that match the criteria 'Descripcion = :descripcion'.
	 */
	public List<Movimientos> findWhereCodProductoEquals(String codigo) throws MovimientosDaoException;
	
	/** 
	 * Returns all rows from the Movimientos table that match the criteria '"+ pstrSQL +"'.
	 */
	public List<Movimientos> findByDynamicWhere(String pstrSQL) throws MovimientosDaoException;

	/** 
	 * Returns the rows from the Movimientos table that matches the specified primary-key value.
	 */
	public Movimientos findByPrimaryKey(MovimientosPk pk) throws MovimientosDaoException;
	
	/** 
	 * Returns all rows from the Movimientos table that match the criteria '"+ pstrSQL +"'.
	 */
	public List<Movimientos> findByDynamicSelect(String pstrSQL) throws MovimientosDaoException;
}
