/**
 * 
 */
package es.postigo.dao;

import java.util.List;

import es.postigo.dto.ProductoUbicacion;
import es.postigo.dto.ProductoUbicacionPk;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.ProductoUbicacionDaoException;

/**
 * @author informatica4
 *
 */
public interface ProductoUbicacionDao {

	/**
	 * Method 'insert'
	 * 
	 * @param dto
	 * @return ProductoUbicacionPk
	 * @throws ProductoUbicacionDaoException 
	 */
	public ProductoUbicacionPk insert(ProductoUbicacion dto) throws ProductoUbicacionDaoException;
	
	public ProductoUbicacionPk insert(ProductoUbicacion dto, String pStrUbicacion) throws ProductoUbicacionDaoException;
	
	public ProductoUbicacionPk insertUbicacion(ProductoUbicacion dto) throws ProductoUbicacionDaoException;

	/** 
	 * Updates a single row in the ProductoUbicacion table.
	 */
	public void update(ProductoUbicacionPk pk, ProductoUbicacion dto) throws ProductoUbicacionDaoException, ApplicationException;

	/** 
	 * Deletes a single row in the ProductoUbicacion table.
	 */
	public void delete(String codigo) throws ProductoUbicacionDaoException;

	/** 
	 * Returns all rows from the ProductoUbicacion table that match the criteria 'CODIGO = :codigo'.
	 */
	public ProductoUbicacion findByPrimaryKey(String codigo) throws ProductoUbicacionDaoException;
	
	/** 
	 * Returns all rows from the ProductoUbicacion table that match the criteria 'CODIGOEAN = :codigoEAN'.
	 */
	public ProductoUbicacion findByCodigoEAN(String codigoEAN) throws ProductoUbicacionDaoException;

	/** 
	 * Returns all rows from the ProductoUbicacion table that match the criteria ''.
	 */
	public List<ProductoUbicacion> findAll() throws ProductoUbicacionDaoException;

	/** 
	 * Returns all rows from the ProductoUbicacion table that match the criteria 'CODIGO = :codigo'.
	 */
	public List<ProductoUbicacion> findWhereCodigoEquals(String codigo) throws ProductoUbicacionDaoException;

	/** 
	 * Returns all rows from the ProductoUbicacion table that match the criteria 'Descripcion = :descripcion'.
	 */
	public List<ProductoUbicacion> findWhereDescripcionEquals(String descripcion) throws ProductoUbicacionDaoException;
	
	/** 
	 * Returns all rows from the ProductoUbicacion table that match the criteria '"+ pstrSQL +"'.
	 */
	public List<ProductoUbicacion> findByDynamicWhere(String pstrSQL) throws ProductoUbicacionDaoException;

	/** 
	 * Returns the rows from the ProductoUbicacion table that matches the specified primary-key value.
	 */
	public ProductoUbicacion findByPrimaryKey(ProductoUbicacionPk pk) throws ProductoUbicacionDaoException;
	
	/** 
	 * Returns all rows from the ProductoUbicacion table that match the criteria '"+ pstrSQL +"'.
	 */
	public List<ProductoUbicacion> findByDynamicSelect(String pstrSQL) throws ProductoUbicacionDaoException;
}
