/**
 * 
 */
package es.postigo.dao;

import java.util.List;

import es.postigo.dto.Ubicacion;
import es.postigo.dto.UbicacionPk;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.ProductoDaoException;
import es.postigo.exceptions.UbicacionDaoException;

/**
 * @author informatica4
 *
 */
public interface UbicacionDao {

	/**
	 * Method 'insert'
	 * 
	 * @param dto
	 * @return UbicacionPk
	 * @throws UbicacionDaoException 
	 */
	public UbicacionPk insert(Ubicacion dto) throws UbicacionDaoException;

	/** 
	 * Updates a single row in the Ubicacion table.
	 */
	public void update(UbicacionPk pk, Ubicacion dto) throws UbicacionDaoException, ApplicationException;

	/** 
	 * Deletes a single row in the Ubicacion table.
	 */
	public void delete(String codigo) throws UbicacionDaoException;

	/** 
	 * Returns all rows from the Ubicacion table that match the criteria 'CODIGO = :codigo'.
	 */
	public Ubicacion findByPrimaryKey(String codigo) throws UbicacionDaoException;
	
	/** 
	 * Returns all rows from the Ubicacion table that match the criteria 'CODIGOEAN = :codigoEAN'.
	 */
	public Ubicacion findByCodigoEAN(String codigoEAN) throws UbicacionDaoException;

	/** 
	 * Returns all rows from the Ubicacion table that match the criteria ''.
	 */
	public List<Ubicacion> findAll() throws UbicacionDaoException;

	/** 
	 * Returns all rows from the Ubicacion table that match the criteria 'CODIGO = :codigo'.
	 */
	public List<Ubicacion> findWhereCodigoEquals(String codigo) throws UbicacionDaoException;

	/** 
	 * Returns all rows from the Ubicacion table that match the criteria 'Descripcion = :descripcion'.
	 */
	public List<Ubicacion> findWhereDescripcionEquals(String descripcion) throws UbicacionDaoException;
	
	/** 
	 * Returns all rows from the Ubicacion table that match the criteria '"+ pstrSQL +"'.
	 */
	public List<Ubicacion> findByDynamicWhere(String pstrSQL) throws UbicacionDaoException;

	/** 
	 * Returns the rows from the Ubicacion table that matches the specified primary-key value.
	 */
	public Ubicacion findByPrimaryKey(UbicacionPk pk) throws UbicacionDaoException;
	
	/** 
	 * Returns all rows from the Ubicacion table that match the criteria '"+ pstrSQL +"'.
	 */
	public List<Ubicacion> findByDynamicSelect(String pstrSQL) throws UbicacionDaoException;
	
	/** 
	 * Returns Last inserted element.
	 */
	public String obtenerUltimoElementoInsertado() throws UbicacionDaoException;
}
