/**
 * 
 */
package es.postigo.dao;

import java.util.List;

import es.postigo.dto.User;
import es.postigo.dto.UserPk;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.UserDaoException;

/**
 * @author informatica4
 *
 */
public interface UserDao {
	/**
	 * Method 'insert'
	 * 
	 * @param dto
	 * @return UserPk
	 * @throws UserDaoException 
	 */
	public UserPk insert(User dto) throws UserDaoException;

	/** 
	 * Updates a single row in the User table.
	 */
	public void update(UserPk pk, User dto) throws UserDaoException, ApplicationException;
	
	/** 
	 * Deletes a single row in the User table.
	 */
	public void delete(String pStrUser) throws UserDaoException;

	/** 
	 * Returns all rows from the User table that match the criteria 'CODIGO = :codigo'.
	 */
	public User findByPrimaryKey(String pStrUser) throws UserDaoException;
	
	/** 
	 * Returns all rows from the User table that match the criteria ''.
	 */
	public List<User> findAll() throws UserDaoException;

	/** 
	 * Returns all rows from the User table that match the criteria '"+ pstrSQL +"'.
	 */
	public List<User> findByDynamicWhere(String pstrSQL) throws UserDaoException;

	/** 
	 * Returns the rows from the User table that matches the specified primary-key value.
	 */
	public User findByPrimaryKey(UserPk pk) throws UserDaoException;
	
	/** 
	 * Returns all rows from the User table that match the criteria '"+ pstrSQL +"'.
	 */
	public List<User> findByDynamicSelect(String pstrSQL) throws UserDaoException;
}
