/**
 * 
 */
package es.postigo.delegate;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import es.postigo.dto.Movimientos;
import es.postigo.dtov.MovimientosDTOV;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.MovimientosDaoException;
import es.postigo.factoria.MovimientosDaoFactory;
import es.postigo.utility.ConexionBD;

/**
 * @author informatica4
 *
 */
public class MovimientosDelegate {

	public MovimientosDelegate() throws Exception {

	}

	public List<Movimientos> obtenerListado(String pStrSql) throws ApplicationException {

		List<Movimientos> listaMovimientos = new ArrayList<Movimientos>();
		Connection con;
		
		try {
			//Class.forName("com.ibm.as400.access.AS400JDBCDriver");
			//Connection con = DriverManager.getConnection("jdbc:as400://192.168.0.3","ipcs","ipcs");
			con = ConexionBD.obtieneConexion();
			System.out.println("Conectado correctamente");
			
			PreparedStatement statement = con.prepareStatement(pStrSql);
			ResultSet rs = statement.executeQuery();
			
			while (rs.next()) {
				Movimientos pu = new Movimientos();
				
				pu.setUbiOrigen(rs.getString("UBI_ORIGEN"));
				pu.setDescUbiOrigen(rs.getString("DESC_UBI_ORIGEN"));
				pu.setUbiDestino(rs.getString("UBI_DESTINO"));
				pu.setDescUbiDestino(rs.getString("DESC_UBI_DESTINO"));
				pu.setCodProducto(rs.getString("COD_PRODUCTO"));
				pu.setDescCodProducto(rs.getString("DESC_COD_PRODUCTO"));
				pu.setCantidad(rs.getString("CANTIDAD"));
				pu.setFecha(rs.getString("FECHA"));
				
				listaMovimientos.add(pu);				
			}
			
			rs.close();
			con.close();
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return listaMovimientos;

	}

	public MovimientosDTOV getRegistroV(String pStrUbiOrigen, String pStrUbiDestino, String pStrCodProducto, String pStrFecha) throws ApplicationException, MovimientosDaoException {

		return (MovimientosDTOV) MovimientosDaoFactory.create().findByPrimaryKey(pStrUbiOrigen, pStrUbiDestino, pStrCodProducto, pStrFecha);

	}

	public void insert(Movimientos pObjMovimientos) throws ApplicationException, MovimientosDaoException {

		MovimientosDaoFactory.create().insert(pObjMovimientos);

	}

	public void update(Movimientos pObjMovimientos) throws ApplicationException, MovimientosDaoException {

		MovimientosDaoFactory.create().update(pObjMovimientos.createPk(),pObjMovimientos);

	}
	
	public Movimientos getRegistro(String pStrUbiOrigen, String pStrUbiDestino, String pStrCodProducto, String pStrFecha) throws ApplicationException, MovimientosDaoException {

		return MovimientosDaoFactory.create().findByPrimaryKey(pStrUbiOrigen, pStrUbiDestino, pStrCodProducto, pStrFecha);

	}

	public void delete(String pStrCodUbicacion, String pStrCodProducto) throws ApplicationException, MovimientosDaoException {

		MovimientosDaoFactory.create().delete(pStrCodUbicacion, pStrCodProducto);

	}
}
