/**
 * 
 */
package es.postigo.delegate;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import es.postigo.dto.Producto;
import es.postigo.dtov.ProductoDTOV;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.ProductoDaoException;
import es.postigo.factoria.ProductoDaoFactory;
import es.postigo.utility.ConexionBD;

/**
 * @author informatica4
 *
 */
public class ProductoDelegate {

	public ProductoDelegate() throws Exception {

	}

	public List<Producto> obtenerListado(String pStrSql) throws ApplicationException {

		List<Producto> listaProductos = new ArrayList<Producto>();
		Connection con;
		
		try {
			//Class.forName("com.ibm.as400.access.AS400JDBCDriver");
			//Connection con = DriverManager.getConnection("jdbc:as400://192.168.0.3","ipcs","ipcs");
			//Conexion conAux = new Conexion();
			//conAux.init();
			con = ConexionBD.obtieneConexion();
			System.out.println("Conectado correctamente");
			
			PreparedStatement statement = con.prepareStatement(pStrSql);
			ResultSet rs = statement.executeQuery();
			
			while (rs.next()) {
				Producto pu = new Producto();
				
				pu.setCodigo(rs.getString("CODIGO"));
				pu.setDescripcion(rs.getString("DESCRIPCION"));
				pu.setLote(rs.getString("LOTE"));
				pu.setCantidad(Integer.valueOf(rs.getString("CANTIDAD")));
				pu.setCodigoean(rs.getString("CODIGOEAN"));
				pu.setCodigoCompras(rs.getString("CODIGO_COMPRAS"));
				pu.setUnidades(rs.getString("UNIDADES"));
				
				listaProductos.add(pu);				
			}
			
			rs.close();
			con.close();
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return listaProductos;

	}

	public ProductoDTOV getRegistroV(String pStrCodigo) throws ApplicationException, ProductoDaoException {

		return (ProductoDTOV) ProductoDaoFactory.create().findByPrimaryKey(pStrCodigo);

	}

	public void insert(Producto pObjProducto) throws ApplicationException, ProductoDaoException {

		ProductoDaoFactory.create().insert(pObjProducto);

	}
	
	public void insert(Producto pObjProducto, String pStrUbicacion) throws ApplicationException, ProductoDaoException {

		ProductoDaoFactory.create().insert(pObjProducto, pStrUbicacion);

	}
	
	public void update(Producto pObjProducto) throws ApplicationException, ProductoDaoException {

		ProductoDaoFactory.create().update(pObjProducto.createPk(),pObjProducto);

	}

	public Producto getRegistro(String pStrCodigo) throws ApplicationException, ProductoDaoException {

		return ProductoDaoFactory.create().findByPrimaryKey(pStrCodigo);

	}
	
	public Producto getRegistroPorCodigoEAN(String pStrCodigoEan) throws ApplicationException, ProductoDaoException {

		return ProductoDaoFactory.create().findByCodigoEAN(pStrCodigoEan);

	}

	public void delete(String pStrCodigo) throws ApplicationException, ProductoDaoException {

		ProductoDaoFactory.create().delete(pStrCodigo);
	}
	
	public String obtenerUltimoElementoInsertado()throws ApplicationException, ProductoDaoException {
		return ProductoDaoFactory.create().obtenerUltimoElementoInsertado();
	}
}
