/**
 * 
 */
package es.postigo.delegate;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import es.postigo.dto.Ubicacion;
import es.postigo.dtov.UbicacionDTOV;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.UbicacionDaoException;
import es.postigo.factoria.UbicacionDaoFactory;
import es.postigo.utility.ConexionBD;

/**
 * @author informatica4
 *
 */
public class UbicacionDelegate {

	public UbicacionDelegate() throws Exception {

	}

	public List<Ubicacion> obtenerListado(String pStrSql) throws ApplicationException {

		List<Ubicacion> listaUbicaciones = new ArrayList<Ubicacion>();
		Connection con;
		
		try {
			//Class.forName("com.ibm.as400.access.AS400JDBCDriver");
			//Connection con = DriverManager.getConnection("jdbc:as400://192.168.0.3","ipcs","ipcs");
			//Conexion conAux = new Conexion();
			//conAux.init();
			con = ConexionBD.obtieneConexion();
			System.out.println("Conectado correctamente");
			
			PreparedStatement statement = con.prepareStatement(pStrSql);
			ResultSet rs = statement.executeQuery();
			
			while (rs.next()) {
				Ubicacion pu = new Ubicacion();				
				pu.setCodigo(rs.getString("CODIGO"));
				pu.setDescripcion(rs.getString("DESCRIPCION"));
				pu.setCodigoean(rs.getString("CODIGOEAN"));				
				listaUbicaciones.add(pu);				
			}
			
			rs.close();
			con.close();
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return listaUbicaciones;

	}

	public UbicacionDTOV getRegistroV(String pStrCodigo) throws ApplicationException, UbicacionDaoException {

		return (UbicacionDTOV) UbicacionDaoFactory.create().findByPrimaryKey(pStrCodigo);

	}

	public void insert(Ubicacion pObjUbicacion) throws ApplicationException, UbicacionDaoException {

		UbicacionDaoFactory.create().insert(pObjUbicacion);

	}

	public void update(Ubicacion pObjUbicacion) throws ApplicationException, UbicacionDaoException {

		UbicacionDaoFactory.create().update(pObjUbicacion.createPk(),pObjUbicacion);

	}

	public Ubicacion getRegistro(String pStrCodigo) throws ApplicationException, UbicacionDaoException {

		return UbicacionDaoFactory.create().findByPrimaryKey(pStrCodigo);

	}
	
	public Ubicacion getRegistroPorCodigoEAN(String pStrCodigoEan) throws ApplicationException, UbicacionDaoException {

		return UbicacionDaoFactory.create().findByCodigoEAN(pStrCodigoEan);

	}

	public void delete(String pStrCodigo) throws ApplicationException, UbicacionDaoException {

		UbicacionDaoFactory.create().delete(pStrCodigo);

	}
	
	public String obtenerUltimoElementoInsertado()throws ApplicationException, UbicacionDaoException {
		return UbicacionDaoFactory.create().obtenerUltimoElementoInsertado();
	}
}
