/**
 * 
 */
package es.postigo.delegate;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.List;

import es.postigo.dto.User;
import es.postigo.dtov.UserDTOV;
import es.postigo.exceptions.ApplicationException;
import es.postigo.exceptions.UserDaoException;
import es.postigo.factoria.UserDaoFactory;
import es.postigo.utility.ConexionBD;

/**
 * @author informatica4
 *
 */
public class UserDelegate {

	public UserDelegate() throws Exception {

	}

	public List<User> obtenerListado(String pStrSql) throws ApplicationException {

		List<User> listaUsuarios = new ArrayList<User>();
		Connection con;
		
		try {
			//Class.forName("com.ibm.as400.access.AS400JDBCDriver");
			//Connection con = DriverManager.getConnection("jdbc:as400://192.168.0.3","ipcs","ipcs");
			//Conexion conAux = new Conexion();
			//conAux.init();
			con = ConexionBD.obtieneConexion();
			System.out.println("Conectado correctamente");
			
			PreparedStatement statement = con.prepareStatement(pStrSql);
			ResultSet rs = statement.executeQuery();
			
			while (rs.next()) {
				User pu = new User();
				
				pu.setLogin(rs.getString("USER"));
				pu.setPass(rs.getString("PASS"));
				
				listaUsuarios.add(pu);				
			}
			
			rs.close();
			con.close();
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return listaUsuarios;

	}

	public UserDTOV getRegistroV(String pStrUser) throws ApplicationException, UserDaoException {

		return (UserDTOV) UserDaoFactory.create().findByPrimaryKey(pStrUser);

	}

	public void insert(User pObjUser) throws ApplicationException, UserDaoException {

		UserDaoFactory.create().insert(pObjUser);

	}
		
	public void update(User pObjUser) throws ApplicationException, UserDaoException {

		UserDaoFactory.create().update(pObjUser.createPk(),pObjUser);

	}

	public User getRegistro(String pStrUser) throws ApplicationException, UserDaoException {

		return UserDaoFactory.create().findByPrimaryKey(pStrUser);

	}
	

	public void delete(String pStrUser) throws ApplicationException, UserDaoException {

		UserDaoFactory.create().delete(pStrUser);

	}
}
