/**
 * 
 */
package es.postigo.exceptions;

import java.util.Date;

/**
 * @author informatica4
 *
 */
public class ApplicationCoreException extends Exception {

	/** La constante serialVersionUID. */
	private static final long serialVersionUID = 1L;

	/** El codigo. */
	private int codigo;

	/** El excepcion. */
	private String excepcion;

	/** El nombre clase. */
	private String nombreClase;

	/** El nombre metodo. */
	private String nombreMetodo;

	/** El login usuario. */
	private String loginUsuario;

	/** El fecha. */
	private Date fecha;

	// Codigos de error
	/** La constante ERROR_ACCESO_DATOS. */
	public static final int ERROR_ACCESO_DATOS = 1;

	/** La constante FICHERO_NO_PRESENTE. */
	public static final int FICHERO_NO_PRESENTE = 2;

	/** La constante ERROR_ACCESO_DATOS_TAGS. */
	public static final int ERROR_ACCESO_DATOS_TAGS = 3;

	/** La constante FILTRO_COLUMNAS. */
	public static final int FILTRO_COLUMNAS = 4;

	/** La constante PAGINACION. */
	public static final int PAGINACION = 5;

	/** La constante SINSESION. */
	public static final int SINSESION = 6;

	/** La constante ERROR_DESCONOCIDO. */
	public static final int ERROR_DESCONOCIDO = 7;

	/** La constante ERROR_TRATAMIENTO_DATOS. */
	public static final int ERROR_TRATAMIENTO_DATOS = 8;

	/** La constante SINPERMISO. */
	public static final int SINPERMISO = 9;

	/** La constante ACCESOSIMULTANEO. */
	public static final int ACCESOSIMULTANEO = 10;

	/** La constante REFERENCIAYAEXISTE. */
	public static final int REFERENCIAYAEXISTE = 11;

	/** La constante NOEXISTEUSUARIOLDAP. */
	public static final int NOEXISTEUSUARIOLDAP = 12;

	/** La constante NOEXISTEUSUARIO_BD. */
	public static final int NOEXISTEUSUARIO_BD = 13;

	/** La constante EXISTEUSUARIO_BD. */
	public static final int EXISTEUSUARIO_BD = 14;

	/** La constante MAXFILESIZE. */
	public static final int MAXFILESIZE = 15;

	/** La constante ERROR_SIN_USUARIO_ASIGNADO. */
	public static final int ERROR_SIN_USUARIO_ASIGNADO = 16;

	/** La constante ERROR_USUARIO_ASIGNADO. */
	public static final int ERROR_USUARIO_ASIGNADO = 17;

	/** La constante ERROR_USUARIO_BLOQUEADO. */
	public static final int ERROR_USUARIO_BLOQUEADO = 18;

	/** La constante EXISTE_ROL_BD. */
	public static final int EXISTE_ROL_BD = 19;

	/** La constante EXISTE_USUARIO_BD. */
	public static final int EXISTE_USUARIO_BD = 20;

	/** La constante NO_EXISTE_USUARIO_LDAP. */
	public static final int NO_EXISTE_USUARIO_LDAP = 21;

	/** La constante EXISTE_DNI_BD. */
	public static final int EXISTE_DNI_BD = 22;

	/** La constante EXISTE_GRUP_EMPRESARIAL. */
	public static final int EXISTE_GRUP_EMPRESARIAL = 23;

	/** La constante EXISTE_ACTIVITAT. */
	public static final int EXISTE_ACTIVITAT = 24;

	/** La constante EXISTE_TIPUS_DE_VINCLE. */
	public static final int EXISTE_TIPUS_DE_VINCLE = 25;

	/** La constante EXISTE_ASSOCIACIO. */
	public static final int EXISTE_ASSOCIACIO = 26;

	/** La constante EXISTE_PROPOSIT_DE_CONTACTE. */
	public static final int EXISTE_PROPOSIT_DE_CONTACTE = 27;

	/** La constante EXISTE_TIPUS_DE_VIA. */
	public static final int EXISTE_TIPUS_DE_VIA = 28;

	/** La constante ERROR_RESTRICCION_INTEGRIDAD. */
	public static final int ERROR_RESTRICCION_INTEGRIDAD = 29;

	/** La constante EXISTE_USUARIO_COPIA_BD. */
	public static final int EXISTE_USUARIO_COPIA_BD = 30;

	/** La constante EXISTE_ROL_COPIA_BD. */
	public static final int EXISTE_ROL_COPIA_BD = 31;

	/** La constante ERROR_USUARIO_CONROLES. */
	public static final int ERROR_USUARIO_CONROLES = 32;

	/** La constante ERROR_WEB_SERVICE_NO_ENCONTRADO. */
	public static final int ERROR_WEB_SERVICE_NO_ENCONTRADO = 35;

	/** La constante ERROR_WEB_SERVICE_LOGIN. */
	public static final int ERROR_WEB_SERVICE_LOGIN = 36;

	/** La constante ERROR_WEB_SERVICE_CIERRE_SESION. */
	public static final int ERROR_WEB_SERVICE_CIERRE_SESION = 37;

	/** La constante ERROR_WEB_SERVICE_URL_NO_ENCONTRADA. */
	public static final int ERROR_WEB_SERVICE_URL_NO_ENCONTRADA = 38;

	/** La constante ERROR_WEB_SERVICE_SUBMISION. */
	public static final int ERROR_WEB_SERVICE_SUBMISION = 39;

	/** La constante ERROR_WEB_SERVICE_ENVIO. */
	public static final int ERROR_WEB_SERVICE_ENVIO = 40;

	/** La constante ERROR_FICHERO_NO_ENCONTRADO. */
	public static final int ERROR_FICHERO_NO_ENCONTRADO = 0;

	/** Error de conectividad EJB3. */
	public static final int ERROR_CONECTIVIDAD_EJB3 = 70;
	
	public static final int EXISTE_ID_USUARI = 71;
	
	public static final int EXISTE_USUARIO = 72;
	
	public static final int ERROR_ROL_CON_ALARMA_VINCULADA = 76;
	
	public static final int ERROR_DOCUMENTOS_ASOCIADOS = 77;
	
	public static final int ERROR_CONCURRENCIA = 84;
	
	
	
	

	/** La constante CAUSA_ERROR_DESCONOCIDO. */
	public static final String CAUSA_ERROR_DESCONOCIDO = "SE HA PRODUCIDO UN ERROR DESCONOCIDO";

	/** La constante CAUSA_SINSESION. */
	public static final String CAUSA_SINSESION = "SESION NO VALIDA.";

	/** La constante CAUSA_SINPERMISO. */
	public static final String CAUSA_SINPERMISO = "NO TIENE PERMISOS.";

	/** La constante CAUSA_ACCESOSIMULTANEO. */
	public static final String CAUSA_ACCESOSIMULTANEO = "NO SE PERMITE EL ACCESO SIMULTANEO A LA MISMA PANTALLA.";

	/** La constante CAUSA_NOEXISTEUSUARIO. */
	public static final String CAUSA_NOEXISTEUSUARIO = "NO EXISTE USUARIO.";

	/** La constante CAUSA_SIN_USUARIO. */
	public static final String CAUSA_SIN_USUARIO = "NO EXISTE USUARIO ASIGNADO PARA EL USUARIO: ";

	/** La constante CAUSA_USUARIO_BLOQUEADO. */
	public static final String CAUSA_USUARIO_BLOQUEADO = " -> USUARIO ESTA BLOQUEADO ";

	public static final String CAUSA_NOEXISTEUSUARIOLDAP = "NO EXISTE EL USUARIO EN LDAP";

	/** La constante CAUSA_EXISTE_TIPUS_DE_VINCLE. */
	public static final String CAUSA_EXISTE_TIPUS_DE_VINCLE = " YA EXISTE TIPUS DE VICLE ";


	/** La constante CAUSA_ERROR_RESTRICCION_INTEGRIDAD. */
	public static final String CAUSA_ERROR_RESTRICCION_INTEGRIDAD = " NO SE PUEDE BORRAR EL REGISTRO POR RESTRICCION INTEGRIDAD ";

	/** La constante CAUSA_ERROR_USUARIO_CONROLES. */
	public static final String CAUSA_ERROR_USUARIO_CONROLES = " NO SE PUEDE BORRAR EL USUARIO PORQUE TIENE ROLES ASIGNADOS ";

	
	/** La constante CAUSA_ERROR_WEB_SERVICE_NO_ENCONTRADO. */
	public static final String CAUSA_ERROR_WEB_SERVICE_NO_ENCONTRADO = "ERROR AL LOCALIZAR EL WEB SERVICE";

	/** La constante CAUSA_ERROR_BORRAR_USUARIO_CON_VINCULOS. */
	public static final String CAUSA_ERROR_BORRAR_USUARIO_CON_VINCULOS = "ERROR AL BORRAR UN USUARIO PORQUE TIENE DEPENDENCIAS DE VINCULOS";

	/** La constante CAUSA_EXISTE_PROCES_EDI. */
	public static final String CAUSA_ERROR_CONECTIVIDAD_EJB3 = "ERROR AL CONECTAR A EJB3";

	public static final String CAUSA_EXISTE_USUARIO = "YA EXISTE EL USUARIO EN EL SISTEMA, PROBLEMAS DE CONCURRENCIA";
	public static final String CAUSA_ERROR_ROL_CON_ALARMA_VINCULADA = "Existen alarmas vinculadas al rol";
	
	public static final String CAUSA_EXISTE_ID_USUARI = "YA EXISTE EL ID DE USUARIO EN EL SISTEMA, PROBLEMAS DE CONCURRENCIA";
	
	public static final String CAUSA_ERROR_CONCURRENCIA = "ERROR DE CONCURRENCIA";
	
	public static final String CAUSA_ERROR_MAXFILESIZE = "EL ARCHIVO HA SUPERADO EL MXIMO DE TAMAO PERMITIDO";
	
	/** La constante CAUSA_ERROR_DOCUMENTOS_ASOCIADOS. */
	public static final String CAUSA_ERROR_DOCUMENTOS_ASOCIADOS = "ERROR AL INTENTAR ASOCIAR UN DOCUMENTO";
	
	/***************************************************************************
	 * Constructor de la Clase de Excepcion de la aplicacion
	 * 
	 * @param codigo
	 *            Codigo de la Excepcion
	 * @param excepcion
	 *            PrintStrace de la Excepcion Original
	 * @param causa
	 *            Causa que provoc� la Excepcion (metodo de la clase Excepcion
	 *            -> getCause())
	 * @param nombreClase
	 *            Nombre de la clase que provoc� la excepcion
	 * @param nombreMetodo
	 *            M�todo de la clase que provoc� la excepcion
	 */
	public ApplicationCoreException(int codigo, String excepcion, String nombreClase, String nombreMetodo) {

		super();
		this.codigo = codigo;
		this.excepcion = excepcion;
		this.nombreClase = nombreClase;
		this.nombreMetodo = nombreMetodo;
		this.fecha = new Date();
	}

	/**
	 * Instancia un nuevo application exception.
	 */
	public ApplicationCoreException() {

		this.fecha = new Date();
	}

	/**
	 * @return the codigo
	 */
	public int getCodigo() {

		return codigo;
	}

	/**
	 * @param codigo
	 *            the codigo to set
	 */
	public void setCodigo(int codigo) {

		this.codigo = codigo;
	}

	/**
	 * @return the excepcion
	 */
	public String getExcepcion() {

		return excepcion;
	}

	/**
	 * @param excepcion
	 *            the excepcion to set
	 */
	public void setExcepcion(String excepcion) {

		this.excepcion = excepcion;
	}

	/**
	 * @return the nombreClase
	 */
	public String getNombreClase() {

		return nombreClase;
	}

	/**
	 * @param nombreClase
	 *            the nombreClase to set
	 */
	public void setNombreClase(String nombreClase) {

		this.nombreClase = nombreClase;
	}

	/**
	 * @return the nombreMetodo
	 */
	public String getNombreMetodo() {

		return nombreMetodo;
	}

	/**
	 * @param nombreMetodo
	 *            the nombreMetodo to set
	 */
	public void setNombreMetodo(String nombreMetodo) {

		this.nombreMetodo = nombreMetodo;
	}

	/**
	 * @return the loginUsuario
	 */
	public String getLoginUsuario() {

		return loginUsuario;
	}

	/**
	 * @param loginUsuario
	 *            the loginUsuario to set
	 */
	public void setLoginUsuario(String loginUsuario) {

		this.loginUsuario = loginUsuario;
	}

	/**
	 * @return the fecha
	 */
	public Date getFecha() {

		return fecha;
	}

	/**
	 * @param fecha
	 *            the fecha to set
	 */
	public void setFecha(Date fecha) {

		this.fecha = fecha;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see java.lang.Throwable#toString()
	 */
	@Override
	public String toString() {

		String lStrError = "";
		lStrError += "\n#####################################################";
		lStrError += "\nFecha: " + new Date();/*Fecha.obtenerDiaMesAnyoHoraMinutos(fecha);*/
		lStrError += "\nCODIGO ERROR: " + codigo;
		lStrError += "\nClase: " + nombreClase;
		lStrError += "\nMetodo: " + nombreMetodo;
		lStrError += "\nExcepcin:\n" + excepcion;
		lStrError += "\n#####################################################\n";

		return lStrError;
	}
}
