/**
 * 
 */
package es.postigo.exceptions;

/**
 * @author informatica4
 *
 * Excepcin que se lanza cuando una referencia nula es pasada a un mtodo que no la acepta como argumento vlido.
 *
 */
public class ArgumentNullException extends IllegalArgumentException {

	/** La constante serialVersionUID. */
	private static final long serialVersionUID = 594162728584113256L;

	/** El campo. */
	private String campo;

	/**
	 * Obtiene el nombre del parmetro nulo que produjo el error.
	 * @return Nombre del parmetro nulo que produjo el error.
	 */
	public String getCampo() {
		return campo;
	}

	/**
	 * Crea una excepcin que representa que un argumento nulo se pas como parmetro en un mtodo.
	 */
	public ArgumentNullException() {
		this("(no definido)");
	}
	
	/**
	 * Crea una excepcin que representa que un argumento nulo se pas como parmetro en un mtodo.
	 * @param campo Nombre del parmetro nulo que produjo el error.
	 */
	public ArgumentNullException(String campo) {
		super("Se especific un parmetro nulo o vacio en la llamada al mtodo. Nombre del parmetro: " + campo + ".");
		this.campo = campo;
	}	
}
