/**
 * 
 */
package es.postigo.service.impl;

import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;

import org.apache.commons.logging.LogFactory;

import es.postigo.action.utility.AuxiliarMVC;
import es.postigo.dto.CodigoDescripcionDTO;
import es.postigo.dto.MetadatoDTO;
import es.postigo.exceptions.ApplicationCoreException;
import es.postigo.service.TCService;
import es.postigo.service.servicelocator.ServiceLocatorCoreDao;
import es.postigo.utility.Fecha;

/**
 * @author informatica4
 *
 */
public class TCService_Impl implements TCService {

	/**
	 * Instancia un nuevo tC service impl.
	 */
	public TCService_Impl() {

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see es.prodevelop.service.TCService#obtenerHashMap(java.lang.String,
	 *      java.lang.String, java.lang.String, java.lang.String, int, int)
	 */
	public HashMap obtenerHashMap(String pStrElegidas, String pStrTabla, String pStrWhere, String pStrCondicion,
			int pIntCursor, int pIntNumRegistros) throws ApplicationCoreException {

		PreparedStatement lObjPstmt = null;
		ResultSet lObjRs = null;
		HashMap lObjHashMap = new HashMap();

		Connection lObjConexion = null;
		try {
			lObjConexion = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion();
			// Obtencin de la clase Intercambio para mostrar en la vista
			MetadatoDTO[] lObjColumnas = null;
			lObjColumnas = obtenerIntercambio(pStrTabla, pStrElegidas, null);

			// Obtener vector de datos de paginacin
			ArrayList lObjVector = obtenerVectorPaginacion(pStrTabla, pStrWhere, pIntCursor, pIntNumRegistros);

			String lStrBetween = (String) lObjVector.get(4);
			int lIntInicio = pStrCondicion.indexOf("order by");
			String lStrOrder = null;
			if (lIntInicio > -1) {
				lStrOrder = pStrCondicion.substring(lIntInicio);
			}

			String lStrBBDD = AuxiliarMVC.obtenerTipoBBDD();
			String lStrSql = "";
			if (pStrCondicion != null && pStrTabla != null && lStrBetween != null) {	
				if(lStrBBDD.equalsIgnoreCase("ORACLE")){	
					if (lStrOrder != null) {
						lStrSql = "select * from ( select a.*, row_number() over (" + lStrOrder + ") r from " + pStrTabla
								+ " a " + pStrWhere + ")" + " where r between " + lStrBetween + " " + lStrOrder;
					} else {
						lStrSql = "select * from ( select a.*, rownum r from " + pStrTabla + " a " + pStrWhere + ")"
								+ " where r between " + lStrBetween;
					}
				}else if(lStrBBDD.equalsIgnoreCase("PGSQL") || lStrBBDD.equalsIgnoreCase("MySQL")){
					if (lStrOrder != null) {
						// Vsevilla modif 10/09/2008. Modificado para postgres
	
						lStrSql = "select * from " + pStrTabla + pStrWhere
								+ " " + lStrOrder + lStrBetween;
					} else {
						// Vsevilla modif 10/09/2008. Modificado para postgres
	
						lStrSql = "select * from " + pStrTabla + pStrWhere
								+ lStrBetween;
					}
				}
			}

			HashMap lObjHashFila = new HashMap();
			int i = 0;
			int j = 0;

			//if (pStrElegidas.equalsIgnoreCase("*")) {
				lObjPstmt = lObjConexion.prepareStatement(lStrSql);
				lObjRs = lObjPstmt.executeQuery();
				HashMap lObjHashColFilaAnterior;
				ArrayList lObjLista = new ArrayList(); 
				while (lObjRs.next()) {
					HashMap lObjHashCol = new HashMap();
					for (j = 0; j < lObjColumnas.length; j++) {
						
						String lStrTipoDato = lObjColumnas[j].getTipodato();
						String lStrValor = "";
						if (lStrTipoDato.equalsIgnoreCase("NUMBER")) {
							BigDecimal lBigValor = lObjRs.getBigDecimal(lObjColumnas[j].getNomcolbd());
							if (lBigValor == null) {
								lStrValor = "0";
							} else {
								lStrValor = lBigValor.toString();
							}

							String[] lObjEnteraDecimal = lStrValor.split(".");

							if (lObjEnteraDecimal.length == 1) {
								lStrValor = lObjEnteraDecimal[0];
								if (lStrValor.equalsIgnoreCase("0")) {
									lStrValor = "";
								}
							} else {
								if (lObjEnteraDecimal.length == 2) {
									lStrValor = lObjEnteraDecimal[0] + "." + lObjEnteraDecimal[1];
									if (lStrValor.equalsIgnoreCase("0.0")) {
										lStrValor = "";
									}
									if (lStrValor.equalsIgnoreCase("0.00")) {
										lStrValor = "";
									}
									if (lStrValor.equalsIgnoreCase("0.000")) {
										lStrValor = "";
									}
								}
							}
						} else {
							if (lStrTipoDato.equalsIgnoreCase("DATE")) {
								lStrValor = Fecha.obtenerDiaMesAnyo(lObjRs.getDate(lObjColumnas[j].getNomcolbd()));
								if (lStrValor == null) {
									lStrValor = "";
								} else {
									if (!(Fecha.obtenerHoraMinutos(lObjRs.getDate(lObjColumnas[j].getNomcolbd()))
											.equalsIgnoreCase("00:00"))) {
										lStrValor = lStrValor
												+ " "
												+ Fecha.obtenerHoraMinutos(lObjRs
														.getDate(lObjColumnas[j].getNomcolbd()));
									}
								}
							} else {
								lStrValor = lObjRs.getString(lObjColumnas[j].getNomcolbd());
								if (lStrValor == null)
									lStrValor = "";
							}
						}
						
						
							lObjHashCol.put(String.valueOf(j), lStrValor);
						
					}
					
					//NUEVO ALBER PIF-464
					if (!existeFila(lObjHashCol,lObjHashFila,i,j)){
						lObjHashFila.put(String.valueOf(i), lObjHashCol);
						i++;
					}
				}

			lObjHashMap.put("pStrSql", lStrSql);
			lObjHashMap.put("pObjColumnas", lObjColumnas);
			
			// PIF-211 Actualizamos la paginacion por si se hubieran producido duplicados
			lObjVector.remove(9);
			lObjVector.add(9, String.valueOf(lObjHashFila.size()));
			
			lObjHashMap.put("pObjVector", lObjVector);
			lObjHashMap.put("pObjHashFila", lObjHashFila);
			return lObjHashMap;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, toString(), this.getClass()
					.getSimpleName(), "obtenerHashMap");
		} finally {
			try {
				lObjRs.close();
				lObjPstmt.close();
			} catch (Exception e) {
				throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this
						.getClass().getSimpleName(), "obtenerHashMap");
			}
		}
	}
	
	private boolean existeFila(HashMap pObjHashCol,HashMap pObjHashFila,int pNumFilas,int pNumColumnas){
		for (int i = 0; i < pNumFilas; i++){
			HashMap lObjHashColActual = (HashMap) pObjHashFila.get(String.valueOf(i));
			boolean lBolExisteCol = true;			
			for (int j = 0; j < pNumColumnas && lBolExisteCol; j++) {
				String lStrValor = (String) lObjHashColActual.get(String.valueOf(j));
				String lStrValorAntiguo = (String) pObjHashCol.get(String.valueOf(j));
				
				if (lStrValor!=null && lStrValorAntiguo!=null && !lStrValor.equals(lStrValorAntiguo))					
					lBolExisteCol = false;
				//else System.out.println(lStrValor + "-" + lStrValorAntiguo);
				if ((lStrValor!=null && lStrValorAntiguo==null) || (lStrValor==null && lStrValorAntiguo!=null))
					lBolExisteCol = false;
			}
			
			if(lBolExisteCol) return true;
		}
		return false;
	}

	/**
	 * Mtodo que pasndole un vector con los tamaos de las columnas a
	 * mostrar devuelve un vector con los porcentajes con los que debern
	 * mostrarse las columnas.
	 * 
	 * @param pObjTamColumnas
	 *            vector con los tamaos de campo <BR>
	 * @return String [] vector con los porcentajes<br>
	 * @exception ApplicationCoreException
	 *                Si se produce alguna excepcin<BR>
	 */
	private String[] getPorcentajes(int[] pObjTamColumnas, String[] pObjTipoDatos) throws ApplicationCoreException {

		String[] lObjPorcentajes = new String[pObjTamColumnas.length];
		int lIntTotal = 0;
		int i = 0;
		int lIntMinEntero = 6;
		int lIntMaxEntero = 10;
		int lIntMinString = 10;
		int lIntTamMedioString = 20;
		int lIntMaxString = 50;
		int lIntTamMaxString = 35;
		int lIntFecha = 20;
		int lIntFactor = 6;

		for (i = 0; i < pObjTamColumnas.length; i++) {
			if (pObjTipoDatos[i].equalsIgnoreCase("NUMBER")) {
				// Es un entero
				if (pObjTamColumnas[i] < lIntMinEntero) {
					pObjTamColumnas[i] = lIntMinEntero * lIntFactor;
				} else {
					if (pObjTamColumnas[i] > lIntMaxEntero) {
						pObjTamColumnas[i] = lIntMaxEntero * lIntFactor;
					} else {
						pObjTamColumnas[i] = pObjTamColumnas[i] * lIntFactor;
					}
				}
			} else {
				if (pObjTipoDatos[i].equalsIgnoreCase("DATE")) {
					// Es una fecha
					pObjTamColumnas[i] = lIntFecha * lIntFactor;
				} else {
					// Es un String
					if (pObjTamColumnas[i] < lIntMinString) {
						pObjTamColumnas[i] = lIntMinString * lIntFactor;
					} else {
						if (pObjTamColumnas[i] > lIntMaxString) {
							pObjTamColumnas[i] = lIntTamMaxString * lIntFactor;
						} else {
							pObjTamColumnas[i] = lIntTamMedioString * lIntFactor;
						}
					}
				}
			}
		}

		// Obtencin del total de longitud.
		for (i = 0; i < pObjTamColumnas.length; i++)
			lIntTotal = lIntTotal + pObjTamColumnas[i];

		// Creacin del vector de porcentajes.
		for (i = 0; i < pObjTamColumnas.length; i++)
			lObjPorcentajes[i] = String.valueOf(pObjTamColumnas[i]);

		return lObjPorcentajes;

	}
	
	public MetadatoDTO[] obtenerIntercambio(String pStrTabla, String pStrElegidas, String pStrPrefijo) throws ApplicationCoreException {

		int lIntTamObj;
		PreparedStatement lObjPstmt = null;
		ResultSet lObjRs = null;
		ResultSetMetaData lObjRsm = null;

		Connection lObjConexion = null;
		try {
			lObjConexion = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion();
			String lStrBBDD = AuxiliarMVC.obtenerTipoBBDD();
			if(lStrBBDD.equalsIgnoreCase("ORACLE")){
				if (pStrElegidas.equalsIgnoreCase("*")) {
					lObjPstmt = lObjConexion.prepareStatement("select " + pStrElegidas + " from " + pStrTabla
							+ " WHERE ROWNUM < 2");
					lObjRs = lObjPstmt.executeQuery();
				} else {
					lObjPstmt = lObjConexion.prepareStatement("select " + pStrElegidas + " from " + pStrTabla
							+ " WHERE ROWNUM < 2");
					lObjRs = lObjPstmt.executeQuery();
				}
			}else if(lStrBBDD.equalsIgnoreCase("PGSQL") || lStrBBDD.equalsIgnoreCase("MySQL")){
				lObjPstmt = lObjConexion.prepareStatement("select " + pStrElegidas + " from " + pStrTabla + " LIMIT 1 OFFSET 0");
				lObjRs = lObjPstmt.executeQuery();
			}
			lObjRsm = lObjRs.getMetaData();

			String lStrNombreFinal;
			int lIntTamColumnas;
			String lStrTipoDatos;
			int j = 0;
			int k = 0;
			int tam = 0;
			while (j < lObjRsm.getColumnCount()) {
				lStrNombreFinal = lObjRsm.getColumnName(j + 1);
				tam++;
				j++;
			}

			// Vector auxiliar con los tamaos de columna
			int[] lObjTamColumnas = new int[tam];

			// Vector auxiliar con los nombres de columna
			String[] lObjNomColumnas = new String[tam];

			// Vector auxiliar de porcentajes
			String[] lObjPorcentajes = new String[tam];

			j = 0;
			// Vector auxiliar con los nombres de columna
			String[] lObjTipoDatos = new String[tam];
			while (j < lObjRsm.getColumnCount()) {
				lStrNombreFinal = lObjRsm.getColumnName(j + 1);
				lIntTamColumnas = lObjRsm.getColumnDisplaySize(j + 1);
				lStrTipoDatos = lObjRsm.getColumnTypeName(j + 1);
				lObjNomColumnas[k] = lStrNombreFinal;
				lObjTamColumnas[k] = lIntTamColumnas;
				lObjTipoDatos[k] = lStrTipoDatos;
					k++;
				j++;
			}

			lObjPorcentajes = getPorcentajes(lObjTamColumnas, lObjTipoDatos);

			lIntTamObj = lObjRsm.getColumnCount();

			// Objeto Intercambio con nombres de columna en bd,
			// nombres de columna en properties y porcentajes asociados
			MetadatoDTO[] lObjColumnas = new MetadatoDTO[lIntTamObj];

			String lStrActual;
			for (int i = 0; i < lIntTamObj; i++) {
				lStrActual = lObjNomColumnas[i].toUpperCase();
				lObjColumnas[i] = new MetadatoDTO();
				lObjColumnas[i].setNomcolbd(lStrActual);
				//Modif vsevilla 26/02/2010. Modificado para poder indicar el prefijo. Si es nulo
				//el comportamiento es el de hasta ahora
				if(pStrPrefijo==null){
					lObjColumnas[i].setNomcolproperties(pStrTabla + "." + lStrActual);
					lObjColumnas[i].setNomcolpropertieslargo(pStrTabla + "." + lStrActual + ".TITLE");
				}
				else{
					lObjColumnas[i].setNomcolproperties(pStrPrefijo + "." + lStrActual);
					lObjColumnas[i].setNomcolpropertieslargo(pStrPrefijo + "." + lStrActual + ".TITLE");
				}
				lObjColumnas[i].setPorcentaje(lObjPorcentajes[i]);
				lObjColumnas[i].setTipodato(lObjTipoDatos[i]);
			}

			return lObjColumnas;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtenerIntercambio");
		} finally {
			try {
				lObjRs.close();
				lObjPstmt.close();
				lObjConexion.close();
			} catch (Exception e) {
				throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this
						.getClass().getSimpleName(), "obtenerIntercambio");
			}
		}
	}
	
	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#obtenerHashOrden(java.lang.String)
	 */
	public HashMap obtenerHashOrden(String pStrTabla) throws ApplicationCoreException {

		PreparedStatement lObjPstmt = null;
		ResultSet lObjRs = null;
		ResultSetMetaData lObjRsm = null;
		Connection lObjConexion = null;
		try {
			lObjConexion = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion();
			
			String lStrBBDD = AuxiliarMVC.obtenerTipoBBDD();
			if(lStrBBDD.equalsIgnoreCase("ORACLE")){
				lObjPstmt = lObjConexion.prepareStatement("select * from " + pStrTabla + " WHERE ROWNUM=1");
			}else if(lStrBBDD.equalsIgnoreCase("PGSQL")|| lStrBBDD.equalsIgnoreCase("MySQL")){
				lObjPstmt=lObjConexion.prepareStatement("select * from " + pStrTabla + " LIMIT 1 OFFSET 0");
			}
				
			lObjRs = lObjPstmt.executeQuery();
			lObjRsm = lObjRs.getMetaData();

			// A partir del ResultSet se genera un HashMap
			HashMap lObjHash = new HashMap();
			String lStrActual;
			for (int i = 0; i < lObjRsm.getColumnCount(); i++) {
				lStrActual = lObjRsm.getColumnName(i + 1).toUpperCase();
				if (!lStrActual.equalsIgnoreCase("IDIOMA") && !lStrActual.equalsIgnoreCase("CODIDIOMA")) {
					lObjHash.put(pStrTabla + "." + lStrActual, lStrActual);
				}
			}
			return lObjHash;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtenerHashOrden");
		} finally {
			try {
				lObjRs.close();
				lObjPstmt.close();
			} catch (Exception e) {
				throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this
						.getClass().getSimpleName(), "obtenerHashOrden");
			}
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#obtenerVisiblesNoVisibles(java.lang.String,
	 *      java.lang.String)
	 */
	public ArrayList obtenerVisiblesNoVisibles(String pStrTabla, String pStrVisibles) throws ApplicationCoreException {

		PreparedStatement lObjPstmt = null;
		ResultSet lObjRs = null;
		Collection resultListVisible = new ArrayList();
		Collection resultListNoVisible = new ArrayList();
		CodigoDescripcionDTO lVisible = new CodigoDescripcionDTO();
		CodigoDescripcionDTO lNoVisible = new CodigoDescripcionDTO();

		Connection lObjConexion = null;
		try {
			lObjConexion = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion();
			String lStrBBDD = AuxiliarMVC.obtenerTipoBBDD();
			if(lStrBBDD.equalsIgnoreCase("ORACLE")){
				lObjPstmt = lObjConexion.prepareStatement("select * from " + pStrTabla + " WHERE ROWNUM=1");
			}else if(lStrBBDD.equalsIgnoreCase("PGSQL") || lStrBBDD.equalsIgnoreCase("MySQL")){
				lObjPstmt=lObjConexion.prepareStatement("select * from " + pStrTabla + " LIMIT 1 OFFSET 0");
			}
			
			lObjRs = lObjPstmt.executeQuery();
			ResultSetMetaData lObjRsm = lObjRs.getMetaData();

			String[] lObjVecVisibles = pStrVisibles.split(",");
			int d = 0;
			String lStrActual;
			for (int i = 0; i < lObjRsm.getColumnCount(); i++) {
				boolean lBooEsta = false;
				lStrActual = lObjRsm.getColumnName(i + 1);
				for (int j = 0; j < lObjVecVisibles.length; j++) {
					lObjVecVisibles[j] = lObjVecVisibles[j].trim();
					if (lObjVecVisibles[j].equalsIgnoreCase(lStrActual)) {
						lBooEsta = true;
						break;
					}
				}
				if (!lStrActual.equalsIgnoreCase("IDIOMA") && !lStrActual.equalsIgnoreCase("CODIDIOMA")) {
					if (lBooEsta) {
						lVisible = new CodigoDescripcionDTO();
						lVisible.setAStrCodigo(pStrTabla + "." + lObjVecVisibles[d].toUpperCase());
						lVisible.setAStrCodigoLargo(pStrTabla + "." + lObjVecVisibles[d].toUpperCase() + ".TITLE");
						lVisible.setAStrDescripcion(lObjVecVisibles[d]);
						resultListVisible.add(lVisible);
						d++;
					} else {
						lNoVisible = new CodigoDescripcionDTO();
						lNoVisible.setAStrCodigo(pStrTabla + "." + lStrActual.toUpperCase());
						lNoVisible.setAStrCodigoLargo(pStrTabla + "." + lStrActual.toUpperCase()+ ".TITLE");
						lNoVisible.setAStrDescripcion(lStrActual);
						resultListNoVisible.add(lNoVisible);
					}
				}
			}
			CodigoDescripcionDTO retVisible[] = new CodigoDescripcionDTO[resultListVisible.size()];
			CodigoDescripcionDTO retNoVisible[] = new CodigoDescripcionDTO[resultListNoVisible.size()];
			resultListVisible.toArray(retVisible);
			resultListNoVisible.toArray(retNoVisible);
			ArrayList lCampos = new ArrayList();
			lCampos.add(0, retVisible);
			lCampos.add(1, retNoVisible);
			return lCampos;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtenerVisiblesNoVisibles");
		} finally {
			try {
				lObjRs.close();
				lObjPstmt.close();
			} catch (Exception e) {
				throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this
						.getClass().getSimpleName(), "obtenerVisiblesNoVisibles");
			}
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#obtenerNumeroRegistros(java.lang.String)
	 */
	public int obtenerNumeroRegistros(String pStrSQL) throws ApplicationCoreException {

		PreparedStatement lObjStmt = null;
		ResultSet lObjRes = null;
		try {

			int lLngTotal = 0;
			String lStrSQL = "SELECT count(*) AS TOTAL FROM " + pStrSQL;
			lObjStmt = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion().prepareStatement(lStrSQL);
			lObjRes = lObjStmt.executeQuery();
			lObjRes.next();
			lLngTotal = lObjRes.getInt("TOTAL");
			return lLngTotal;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtenerNumeroRegistros");
		} finally {
			try {
				lObjRes.close();
				lObjStmt.close();
			} catch (Exception e) {
				throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this
						.getClass().getSimpleName(), "obtenerNumeroRegistros");
			}
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#obtenerNumeroRegistrosActual(java.lang.String,
	 *      java.lang.String)
	 */
	public int obtenerNumeroRegistrosActual(String pStrTabla, String pStrCondicion) throws ApplicationCoreException {

		try {

			String lStrSQL = "SELECT count(*) AS TOTAL FROM " + pStrTabla + pStrCondicion;
			int lIntCount = ServiceLocatorCoreDao.getGenericJDBCDao().countSQL(lStrSQL);
			return lIntCount;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtenerNumeroRegistrosActual");
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#obtieneDatos(java.lang.String,
	 *      java.lang.String, java.lang.String,
	 *      org.apb.sostrat.dataaccess.dto.generic.MetadatosDTO[])
	 */
	public HashMap obtieneDatos(String pStrTabla, String pStrColumnas, String pStrWhere, MetadatoDTO[] pObjColumnas)
			throws ApplicationCoreException {

		PreparedStatement lObjPstmt = null;
		ResultSet lObjRs = null;
		HashMap lObjHashFila = new HashMap();
		int i = 0;
		int j = 0;
		HashMap lObjHashMap = new HashMap();
		try {
			String pStrSQL = "select " + pStrColumnas + " from " + pStrTabla + pStrWhere;
			Connection lObjConexion = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion();

			lObjPstmt = lObjConexion.prepareStatement(pStrSQL);
			lObjRs = lObjPstmt.executeQuery();

			while (lObjRs.next()) {
				HashMap lObjHashCol = new HashMap();
				for (j = 0; j < pObjColumnas.length; j++) {
					String lStrTipoDato = pObjColumnas[j].getTipodato();
					String lStrValor = "";
					if (lStrTipoDato.equalsIgnoreCase("NUMBER")) {

						// Modificacin PREY 31/08/2005
						BigDecimal lBigValor = lObjRs.getBigDecimal(pObjColumnas[j].getNomcolbd());
						if (lBigValor == null) {
							lStrValor = "0";
						} else {
							lStrValor = lBigValor.toString();
						}

						// Fin modificacin
						String[] lObjEnteraDecimal = lStrValor.split(".");

						if (lObjEnteraDecimal.length == 1) {
							lStrValor = lObjEnteraDecimal[0];
							if (lStrValor.equalsIgnoreCase("0")) {
								lStrValor = "";
							}
						} else {
							lStrValor = lObjEnteraDecimal[0] + "." + lObjEnteraDecimal[1];
							if (lStrValor.equalsIgnoreCase("0.0")) {
								lStrValor = "";
							}
							if (lStrValor.equalsIgnoreCase("0.00")) {
								lStrValor = "";
							}
							if (lStrValor.equalsIgnoreCase("0.000")) {
								lStrValor = "";
							}
						}
					} else {
						if (lStrTipoDato.equalsIgnoreCase("DATE")) {
							Fecha lObjFecha = new Fecha();
							lStrValor = Fecha.obtenerDiaMesAnyo(lObjRs.getDate(pObjColumnas[j].getNomcolbd()));
							if (lStrValor == null) {
								lStrValor = "";
							} else {
								if (!(Fecha.obtenerHoraMinutos(lObjRs.getDate(pObjColumnas[j].getNomcolbd()))
										.equalsIgnoreCase("00:00"))) {
									lStrValor = lStrValor + " "
											+ Fecha.obtenerHoraMinutos(lObjRs.getDate(pObjColumnas[j].getNomcolbd()));
								}
							}
						} else {
							lStrValor = lObjRs.getString(pObjColumnas[j].getNomcolbd());
							if (lStrValor == null)
								lStrValor = "";
						}
					}

					lObjHashCol.put(pObjColumnas[j].getNomcolbd(), lStrValor);
				}
				lObjHashFila.put(String.valueOf(i), lObjHashCol);
				i++;
			}
			return lObjHashFila;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtieneDatos");
		} finally {
			try {
				lObjRs.close();
				lObjPstmt.close();
			} catch (Exception e) {
				throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this
						.getClass().getSimpleName(), "obtieneDatos");
			}
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#calcularNumeroRegistros(java.lang.String)
	 */
	public long calcularNumeroRegistros(String pStrSQL) throws ApplicationCoreException {

		PreparedStatement lObjStmt = null;
		ResultSet lObjRes = null;
		try {

			long lLngTotal = 0;
			lObjStmt = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion().prepareStatement(pStrSQL);
			lObjRes = lObjStmt.executeQuery();
			LogFactory.getLog(this.getClass()).info("Select del count: " + pStrSQL);
			lObjRes.next();
			lLngTotal = lObjRes.getLong("TOTAL");
			return lLngTotal;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "calcularNumeroRegistros");
		} finally {
			try {
				lObjRes.close();
				lObjStmt.close();
			} catch (Exception e) {
				throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this
						.getClass().getSimpleName(), "calcularNumeroRegistros");
			}
		}
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#hacerPaginacion(long,
	 *      int, int)
	 */
	public ArrayList hacerPaginacion(long pLonTotal, int pIntNumRegistros, int pIntCursor) throws Exception {

		String lStrAvanzar = "";
		String lStrRetroceder = "";
		String lStrBetween = "";

		int lIntCursor = pIntCursor;
		int lIntLimiteInf = lIntCursor + 1;
		int lIntLimiteSup = lIntCursor + pIntNumRegistros;
		String lStrBBDD = AuxiliarMVC.obtenerTipoBBDD();
		if(lStrBBDD.equalsIgnoreCase("ORACLE")){
			lStrBetween = "" + lIntLimiteInf + " and " + lIntLimiteSup;
		}
		else if(lStrBBDD.equalsIgnoreCase("PGSQL") || lStrBBDD.equalsIgnoreCase("MySQL")){
			lStrBetween = " LIMIT " + lIntLimiteSup + " OFFSET " + (lIntLimiteInf-1);
		}	
		

		if (lIntCursor == 0) {
			// Son los primeros registros
			lStrRetroceder = "false";
		} else {
			lStrRetroceder = "true";
		}

		if (lIntLimiteSup >= pLonTotal) {
			// Ya hemos llegado al final de los registros
			lStrAvanzar = "false";
		} else {
			lStrAvanzar = "true";
		}

		int lIntCursorAvanzar = lIntCursor + pIntNumRegistros;
		int lIntCursorRetroceder = lIntCursor - pIntNumRegistros;

		int lIntCursorInicio = 0;

		int lIntActualNumPag = 0;

		if (pLonTotal > 0) {
			lIntActualNumPag = (int) lIntCursor / pIntNumRegistros + 1;
		}

		int lIntTotalNumPag = 0;
		if (pLonTotal % pIntNumRegistros == 0) {
			lIntTotalNumPag = (int) pLonTotal / pIntNumRegistros;
		} else {
			lIntTotalNumPag = (int) pLonTotal / pIntNumRegistros + 1;
		}

		int lIntCursorFinal = 0;
		lIntCursorFinal = (lIntTotalNumPag * pIntNumRegistros) - pIntNumRegistros;

		// Si nos han pasado un cursor mayor al numero de filas, devolvemos la
		// ultima pgina
		if (lIntCursor >= pLonTotal)
			return hacerPaginacion(pLonTotal, pIntNumRegistros, lIntCursorFinal);

		ArrayList lObjVector = new ArrayList();

		lObjVector.add(0, lStrAvanzar);
		lObjVector.add(1, lStrRetroceder);
		lObjVector.add(2, Integer.toString(lIntCursorAvanzar));
		lObjVector.add(3, Integer.toString(lIntCursorRetroceder));
		lObjVector.add(4, lStrBetween);
		lObjVector.add(5, Integer.toString(lIntCursorFinal));
		lObjVector.add(6, Integer.toString(lIntCursorInicio));
		lObjVector.add(7, Integer.toString(lIntActualNumPag));
		lObjVector.add(8, Integer.toString(lIntTotalNumPag));
		lObjVector.add(9, Long.toString(pLonTotal));

		return lObjVector;

	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#obtenerVectorPaginacion(java.lang.String,
	 *      java.lang.String, int, int)
	 */
	public ArrayList obtenerVectorPaginacion(String pStrTabla, String pStrWhere, int pIntCursor, int pIntNumRegistros)
			throws Exception {

		LogFactory.getLog(this.getClass()).info("Antes de hacer el count");
		long lLonTotal = calcularNumeroRegistros("select count(*) as TOTAL from " + pStrTabla + pStrWhere);
		
		LogFactory.getLog(this.getClass()).info("Despues de hacer el count");
		ArrayList lObjVector = hacerPaginacion(lLonTotal, pIntNumRegistros, pIntCursor);

		return lObjVector;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.apb.sostrat.service.impl.generic.TCService#obtenerHashMap(java.sql.ResultSetMetaData)
	 */
	public HashMap obtenerHashMap(ResultSetMetaData pObjRsm) throws ApplicationCoreException {

		try {
			// Vector auxiliar con los tamaos de columna
			int[] lObjTamColumnas = new int[pObjRsm.getColumnCount()];

			// Vector auxiliar con los nombres de columna
			String[] lObjNomColumnas = new String[pObjRsm.getColumnCount()];

			// HashMap con nombres de columna y porcentajes asociados
			HashMap lObjColumnas = new HashMap(pObjRsm.getColumnCount());

			// Vector auxiliar de porcentajes
			String[] lObjPorcentajes = new String[pObjRsm.getColumnCount()];

			for (int i = 0; i < pObjRsm.getColumnCount(); i++) {
				lObjTamColumnas[i] = pObjRsm.getColumnDisplaySize(i + 1);
				lObjNomColumnas[i] = pObjRsm.getColumnName(i + 1);
			}

			lObjPorcentajes = getPorcentajes(lObjTamColumnas, lObjNomColumnas);

			for (int i = 0; i < pObjRsm.getColumnCount(); i++) {
				lObjColumnas.put(lObjNomColumnas[i], lObjPorcentajes[i]);
			}

			return lObjColumnas;
		} catch (Exception e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtenerHashMap");
		}
	}

	/**
	 * 
	 */
	public String obtieneDescripcion(String pStrSQL, int pIntNumColumnas) throws Throwable {
		ResultSet lObjRs = null;
		Statement lObjStmt = null;

		try {
			Connection lObjConexion = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion();
			lObjStmt = lObjConexion.createStatement();

			lObjRs = lObjStmt.executeQuery(pStrSQL);
			String lStrDesc = "";
			if (lObjRs.next()) {
				for (int i = 1; i <= pIntNumColumnas; i++) {
					lStrDesc += lObjRs.getString(i);

					if (i != pIntNumColumnas) {
						lStrDesc += "$$$";
					}
				}
			}

			return lStrDesc;

		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtieneDescripcion");
		} finally {
			lObjRs.close();
			lObjStmt.close();
		}
	}

	/***************************************************************************
	 * Obtiene un xml a partir de una lista de datos dependientes de otra tabla
	 * 
	 * @param pStrSQL
	 *            SQL que se va a ejecutar
	 * @return
	 * @throws Throwable
	 */
	public String obtieneComboDependiente(String pStrSQL) throws Throwable {
		ResultSet lObjRs = null;
		Statement lObjStmt = null;

		try {
			Connection lObjConexion = ServiceLocatorCoreDao.getGenericJDBCDao().getConexion();
			lObjStmt = lObjConexion.createStatement();

			lObjRs = lObjStmt.executeQuery(pStrSQL);
			String lStrXML = "<?xml version=\"1.0\" encoding=\"UTF-8\"?><items>";

			while (lObjRs.next()) {
				lStrXML += "<item>";
				lStrXML += "<id>";
				lStrXML += lObjRs.getString(1);
				lStrXML +="</id><descripcion>";
				lStrXML += lObjRs.getString(2);
				lStrXML += "</descripcion>";
				lStrXML += "</item>";
			}

			lStrXML += "</items>";

			return lStrXML;

		} catch (Throwable e) {
			throw new ApplicationCoreException(ApplicationCoreException.ERROR_ACCESO_DATOS_TAGS, e.toString(), this.getClass()
					.getSimpleName(), "obtieneDescripcion");
		} finally {
			lObjRs.close();
			lObjStmt.close();
		}
	}
}