/**
 * 
 */
package es.postigo.utility;

/**
 * @author informatica4
 *
 */

import java.io.IOException;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;
import java.util.StringTokenizer;

import javax.servlet.http.HttpSession;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.commons.logging.LogFactory;

import es.postigo.exceptions.ApplicationCoreException;
import es.postigo.exceptions.DaoException;


/**
 * El Class Auxiliar.
 */
public class Auxiliar {

	/**
	 * Carga en un objeto Properties el fichero de propiedades que se pasa como
	 * parmetro<br>
	 * 
	 * @param pStrNombre
	 *            Nombre del fichero a cargar<BR>
	 * @return Properties Objeto Properties<br>
	 * @exception ApplicationCoreException
	 *                Si el fichero no existe <BR>
	 * 
	 */

	public static Properties cargarFicheroPropiedades(String pStrNombre) throws ApplicationCoreException {

		try {
			Properties lObjProps = new Properties();
			// lObjProps.load(Auxiliar.class.getClassLoader().getResourceAsStream(pStrNombre));
			lObjProps.load(Thread.currentThread().getContextClassLoader().getResourceAsStream(pStrNombre));
			return lObjProps;
		} catch (IOException e) {
			throw new ApplicationCoreException(ApplicationCoreException.FICHERO_NO_PRESENTE, e.toString(), Auxiliar.class
					.getClass().getSimpleName(), "cargarFicheroPropiedades");
		}

	}

	/**
	 * Hace un split del string que se pasa como parmetro<br>
	 * 
	 * @param pStrCadena
	 *            Cadena de la que se hace el split<BR>
	 * @param pStrCadena
	 *            Separador tomado para hacer el split<BR>
	 * @return String[] Array de strings resultado del split<br>
	 * @exception Exception
	 *                si hay alguna excepcin <BR>
	 * 
	 */
	public static String[] splitCadena(String pStrCadena, String pStrSeparador) throws Exception {

		StringTokenizer lObjToken = new StringTokenizer(pStrCadena, pStrSeparador);
		String[] lObjRetorno = new String[lObjToken.countTokens()];

		int i = 0;
		while (lObjToken.hasMoreTokens()) {
			lObjRetorno[i] = new String(lObjToken.nextToken());
			i++;
		}
		return lObjRetorno;
	}

	/**
	 * Quitar punto.
	 * 
	 * @param pStrVariable
	 *            el string Variable
	 * 
	 * @return un objeto String
	 */
	public static String quitarPunto(String pStrVariable) {

		return pStrVariable.substring(0, pStrVariable.indexOf("."))
				+ pStrVariable.substring(pStrVariable.indexOf(".") + 1);
	}

	/**
	 * Poner espacios.
	 * 
	 * @param pStrCuerpo
	 *            el string Cuerpo
	 * @param pIntNumLineas
	 *            el integer NumLineas
	 * @param pIntLongLinea
	 *            el integer LongLinea
	 * 
	 * @return un objeto String
	 */
	public static String ponerEspacios(String pStrCuerpo, int pIntNumLineas, int pIntLongLinea) {

		String[] pColLinea = pStrCuerpo.split("\n");
		String lStrCuerpo = "";
		String lStrAux = "";
		int lLon = 0;
		for (int i = 0; i < pIntNumLineas; i++) {
			if (i < pColLinea.length) {
				lStrAux = pColLinea[i];
				lStrCuerpo += pColLinea[i];
				lLon = lStrAux.length();
			} else {
				lLon = 0;
				lStrAux = "";
			}

			for (int z = lLon; z < pIntLongLinea - 1; z++) {
				lStrCuerpo += " ";
			}
			// lStrCuerpo+="\n";
		}
		return lStrCuerpo;
	}

	/**
	 * Poner espacios.
	 * 
	 * @param pStrTexto
	 *            el string Texto
	 * @param pIntLong
	 *            el integer Long
	 * 
	 * @return un objeto String
	 */
	public static String ponerEspacios(String pStrTexto, int pIntLong) {

		int lIntLong = pStrTexto.length();
		for (int i = 1; i <= pIntLong - lIntLong; i++) {
			pStrTexto += " ";
		}
		return pStrTexto;
	}

	/**
	 * Poner ceros.
	 * 
	 * @param pStrCodLiq
	 *            el string Codigo Liq
	 * @param pIntLongitud
	 *            el integer Longitud
	 * 
	 * @return un objeto String
	 */
	public static String ponerCeros(String pStrCodLiq, int pIntLongitud) {

		int lIntLon = pStrCodLiq.length();
		for (int i = 0; i < pIntLongitud - lIntLon; i++) {
			pStrCodLiq = "0" + pStrCodLiq;
		}
		return pStrCodLiq;
	}

	/**
	 * Poner puntos.
	 * 
	 * @param pStrTexto
	 *            el string Texto
	 * @param pStrTexto2
	 *            el string Texto2
	 * @param pIntLong
	 *            el integer Long
	 * 
	 * @return un objeto String
	 */
	public static String ponerPuntos(String pStrTexto, String pStrTexto2, int pIntLong) {

		int lIntLong = pStrTexto.length();
		int lIntLong2 = pStrTexto2.length();
		for (int i = 1; i <= pIntLong - lIntLong - lIntLong2; i++) {
			pStrTexto += ".";
		}
		return pStrTexto + pStrTexto2;
	}

	/**
	 * Quitar acentos.
	 * 
	 * @param pStrPalabra
	 *            el string Palabra
	 * 
	 * @return un objeto String
	 */
	public static String quitarAcentos(String pStrPalabra) {

		String lStrPalabraSinAcentos = pStrPalabra.replace('', 'a');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'e');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'i');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'o');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'u');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'a');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'e');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'i');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'o');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'u');

		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'A');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'E');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'I');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'O');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'U');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'A');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'E');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'I');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'O');
		lStrPalabraSinAcentos = lStrPalabraSinAcentos.replace('', 'U');
		return lStrPalabraSinAcentos;
	}

	/**
	 * Cv int.
	 * 
	 * @param pObjDatos
	 *            el objeto Datos
	 * @param pStrCampo
	 *            el string Campo
	 * 
	 * @return un objeto int
	 */
	public static final int cvInt(HashMap pObjDatos, String pStrCampo) {

		String lStrValor = (String) pObjDatos.get(pStrCampo);
		if (lStrValor == null) {
			return -1;
		} else {
			if (lStrValor.equals("")) {
				return -1;
			} else {
				return Integer.parseInt(lStrValor);
			}
		}
	}

	/**
	 * Cv string.
	 * 
	 * @param pObjDatos
	 *            el objeto Datos
	 * @param pStrCampo
	 *            el string Campo
	 * 
	 * @return un objeto String
	 */
	public static final String cvString(HashMap pObjDatos, String pStrCampo) {

		String lStrValor = (String) pObjDatos.get(pStrCampo);
		if (lStrValor == null) {
			return null;
		} else {
			return lStrValor;
		}
	}

	/**
	 * Cv big decimal.
	 * 
	 * @param pObjDatos
	 *            el objeto Datos
	 * @param pStrCampo
	 *            el string Campo
	 * 
	 * @return un objeto BigDecimal
	 */
	public static final BigDecimal cvBigDecimal(HashMap pObjDatos, String pStrCampo) {

		String lStrValor = (String) pObjDatos.get(pStrCampo);
		if (lStrValor == null) {
			return null;
		} else {
			try {
				return new BigDecimal(lStrValor);
			} catch (Throwable e) {
				return null;
			}
		}
	}

	/**
	 * Cv date.
	 * 
	 * @param pObjDatos
	 *            el objeto Datos
	 * @param pStrCampo
	 *            el string Campo
	 * 
	 * @return un objeto Date
	 */
	public static final Date cvDate(HashMap pObjDatos, String pStrCampo) {

		String lStrValor = (String) pObjDatos.get(pStrCampo);
		if (lStrValor == null) {
			return null;
		} else {
			return Fecha.generarFecha(lStrValor);
		}
	}

	/**
	 * Cv date.
	 * 
	 * @param pObjDatos
	 *            el objeto Datos
	 * @param pStrFecha
	 *            el string Fecha
	 * @param pStrHora
	 *            el string Hora
	 * 
	 * @return un objeto Date
	 */
	public static final Date cvDate(HashMap pObjDatos, String pStrFecha, String pStrHora) {

		String lStrVFecha = (String) pObjDatos.get(pStrFecha);
		String lStrVHora = (String) pObjDatos.get(pStrHora);
		if (lStrVFecha == null) {
			return null;
		} else {
			if (lStrVHora == null) {
				return Fecha.generarFecha(lStrVFecha);
			} else {
				return Fecha.generarFechaHoraMinutos(lStrVFecha, lStrVHora);
			}
		}
	}

	/**
	 * Cv string.
	 * 
	 * @param lObjObjeto
	 *            el l obj objeto
	 * 
	 * @return un objeto String
	 */
	public static final String cvString(Object lObjObjeto) {

		if (lObjObjeto == null) {
			return "";
		} else {
			return String.valueOf(lObjObjeto);
		}
	}

	/**
	 * Cv check.
	 * 
	 * @param pObjDatos
	 *            el objeto Datos
	 * @param pStrCampo
	 *            el string Campo
	 * 
	 * @return un objeto String
	 */
	public static final String cvCheck(HashMap pObjDatos, String pStrCampo) {

		String lStrValor = (String) pObjDatos.get(pStrCampo);
		if (lStrValor == null) {
			return "0";
		} else {
			return "1";
		}
	}

	/**
	 * Generar clausula in.
	 * 
	 * @param pStrValores
	 *            el string Valores
	 * @param pStrSeparador
	 *            el string Separador
	 * 
	 * @return un objeto String
	 * 
	 * @throws Exception
	 *             the exception
	 */
	public static String generarClausulaIN(String pStrValores, String pStrSeparador) throws Exception {

		if (pStrValores == null || pStrValores.equals(""))
			return null;

		String[] lStrValores = splitCadena(pStrValores, pStrSeparador);
		int i = 0;
		String lStrRetorno = "(";
		while (i < lStrValores.length) {
			String lStrValor = "";
			if (i == lStrValores.length - 1) {
				lStrValor = "'" + lStrValores[i] + "'";
			} else {
				lStrValor = "'" + lStrValores[i] + "',";
			}
			lStrRetorno = lStrRetorno + lStrValor;
			i++;
		}
		lStrRetorno = lStrRetorno + ")";
		return lStrRetorno;
	}

	/**
	 * Generar clausula in.
	 * 
	 * @param pArrayValores
	 *            el array valores
	 * 
	 * @return un objeto String
	 * 
	 * @throws Exception
	 *             the exception
	 */
	public static String generarClausulaIN(ArrayList pArrayValores) throws Exception {

		if (pArrayValores == null || pArrayValores.size() == 0)
			return null;

		int i = 0;
		String lStrRetorno = "(";
		while (i < pArrayValores.size()) {
			String lStrValor = "";
			if (i == pArrayValores.size() - 1) {
				lStrValor = "'" + pArrayValores.get(i) + "'";
			} else {
				lStrValor = "'" + pArrayValores.get(i) + "',";
			}
			lStrRetorno = lStrRetorno + lStrValor;
			i++;
		}
		lStrRetorno = lStrRetorno + ")";
		return lStrRetorno;
	}
	
	
	/**
	 * Generar clausula in para pk compuesta.
	 * 
	 * @param pArrayValores
	 *            el array valores
	 * 
	 * @return un objeto String
	 * 
	 * @throws Exception
	 *             the exception
	 */
	public static String generarClausulaINPKCompuesta(ArrayList pArrayValores) throws Exception {

		if (pArrayValores == null || pArrayValores.size() == 0)
			return null;

		int i = 0;
		String lStrRetorno = "";
		while (i < pArrayValores.size()) {
			String lStrValor = "";
			if (i == pArrayValores.size() - 1) {
				lStrValor =  pArrayValores.get(i).toString();
			} else {
				lStrValor =  pArrayValores.get(i).toString() +",";
			}
			lStrRetorno = lStrRetorno + lStrValor;
			i++;
		}
		lStrRetorno = lStrRetorno + "";
		return lStrRetorno;
	}

	/**
	 * Downcasting.
	 * 
	 * @param pObjSuperclase
	 *            el objeto Superclase
	 * @param pObjSubclase
	 *            el objeto Subclase
	 * 
	 * @return un objeto Object
	 * 
	 * @throws DaoException
	 *             the dao exception
	 */
	public static Object downcasting(Object pObjSuperclase, Object pObjSubclase) throws DaoException {
		try {
			PropertyUtils.copyProperties(pObjSubclase, pObjSuperclase);
		} catch (Throwable e) {
			throw new DaoException("Error en la conversin del DTO a DTOV", e);
		}

		return pObjSubclase;
	}

	/**
	 * Metodo que devuelve una lista con los atributos que son diferentes de dos
	 * objetos
	 * 
	 * @param pObj1
	 *            Primer Objeto a comparar (el Antiguo, que ser el valor
	 *            inicial)
	 * @param pObj2
	 *            Segundo Objeto a comparar (el Antiguo que ser el valor final)
	 * @return Lista de campos diferentes entre los atributos de los objetos
	 *         comparados
	 * @throws Exception
	 */
	public static HashMap<String, String> compararAtributosObjetos(Object pObj1, Object pObj2) throws Exception {

		if (pObj1.equals(pObj2)) {
			LogFactory.getLog(Auxiliar.class).info("Los objetos son identicos");
			return new HashMap<String, String>();
		}

		Map lObjAtributos1 = BeanUtils.describe(pObj1);
		Map lObjAtributos2 = BeanUtils.describe(pObj2);
		HashMap<String, String> lObjResultado = new HashMap<String, String>();

		for (Object lObj : lObjAtributos1.keySet()) {
			String lStrKey = (String) lObj;
			Object lObjValue1 = lObjAtributos1.get(lStrKey);
			Object lObjValue2 = lObjAtributos2.get(lStrKey);

			String lStrValor = "Valor Inicial: ";
			if (lObjValue1 instanceof Date) {
				SimpleDateFormat lObjFormateador = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
				String lStrValorAux = lObjFormateador.format((Date) lObjValue1);
				lStrValor += " " + lStrValorAux;
			} else {
				lStrValor += " " + (String) lObjValue1;
			}

			lStrValor += " Valor Final:";

			if (lObjValue2 instanceof Date) {
				SimpleDateFormat lObjFormateador = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss");
				String lStrValorAux = lObjFormateador.format((Date) lObjValue2);
				lStrValor += " " + lStrValorAux;
			} else {
				lStrValor += " " + (String) lObjValue2;
			}

			// Si alguno de los dos es nulo, aadimos
			if ((lObjValue1 == null || lObjValue2 == null) && (lObjValue1 != null || lObjValue2 != null)) {
				lObjResultado.put(lStrKey, lStrValor);
			} else if (lObjValue1 != null && lObjValue2 != null && !lObjValue1.equals(lObjValue2)) {
				lObjResultado.put(lStrKey, lStrValor);
			}
		}

		return lObjResultado;
	}
//	public static void recargaSession(HttpServletRequest httpServletRequest,GuUsuarioAplicacion pObjOperador) throws Exception {
//		// Sustituir la aplicacion
//		
//		Properties lObjProperties = es.prodevelop.utility.Auxiliar
//				.cargarFicheroPropiedades("aplicacion.properties");
//		String lStrIdAplicacion = (String) lObjProperties.get("codigo.aplicacion");
//		String lStrEntorno = (String) lObjProperties.get("entorno.aplicacion");
//		
//		HttpSession lObjSession = httpServletRequest.getSession(true);
//		lObjSession.setAttribute("ENTORNO", lStrEntorno);
//
//		// Suponemos que el ID de Operador es el mismo que el
//		// usuario de LDAP
//		lObjSession.setAttribute("USR", pObjOperador.getUsr());
//
//		// Cargamos las funcionalidades
//		UsuarioAplicacionDelegate lObjDelegate = new UsuarioAplicacionDelegate();
//		Vector lObjFuncGenUsuario = lObjDelegate.getFuncionalidades(pObjOperador.getUsr());
//		httpServletRequest.setAttribute("pObjFuncUsuario",lObjFuncGenUsuario);
//		lObjSession.setAttribute("FUNCIONES", lObjFuncGenUsuario);
//
////		ArrayList<String> lObjFuncionalidadesPadre = lObjFuncDeleg.obtenerFuncionesPadre(pObjOperador
////				.getIdoperador());
////		lObjSession.setAttribute("FUNCIONESPADRE", lObjFuncionalidadesPadre);
//
//	
//		
//		// Creamos el cookie para guardar la session
//		guardarSesionComoAtributo(lObjSession, pObjOperador.getUsr());
//		
//		System.out.println("Recargando session.... resultado:" + lObjSession);
//		
//	}
	
	/**
	 * Metodo que guarda los datos de sesion en el contexto
	 * 
	 * @param request
	 * @param response
	 */
	public synchronized static void guardarSesionComoAtributo(HttpSession session, String pStrOperador) {

		// Guardamos la session
		session.getServletContext().setAttribute("session_" + pStrOperador, session);
	}

}
