/**
 * 
 */
package es.postigo.utility;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.net.URL;
import java.sql.Connection;
import java.sql.DriverManager;
import java.util.Properties;

/**
 * @author informatica4
 *
 */
public class ConexionBD {

	/**Obtener la conexion a la BD**/
    public static Connection obtieneConexion() throws Exception{
        Connection con=null;
        ConexionBD conaux = new ConexionBD();
        
        String usuario = conaux.leeConfiguracion("usuario");
        String pass = conaux.leeConfiguracion("pass");
        
        Class.forName("com.mysql.jdbc.Driver").newInstance();
        con = DriverManager.getConnection(StringConexion(),usuario,pass);
        //con.setAutoCommit(false);
        
        return con;
    }
    
    /**Obtener la conexion a la BD de manera esttica para testear la configuracin**/
    public static Connection obtieneConexion(String server, String sid, String usuario, String pass) throws Exception{
        Connection con=null;
        
        Class.forName("com.mysql.jdbc.Driver").newInstance();
        con = DriverManager.getConnection("jdbc:mysql://"+server+":3306/"+sid,usuario,pass);
        //con = DriverManager.getConnection("jdbc:mysql://192.168.0.205:3306/inventario",usuario,pass);
        //con = DriverManager.getConnection("jdbc:mysql://localhost:3306/inventario",usuario,pass);
        //con.setAutoCommit(false);
        
        return con;
    }
    
    /**cierra la conezion a la BD**/
    public static void cierraConecction(Connection con) {
        try{
            con.close();
        }catch(Exception e){;}
    }
    
    /**Generamos el string de conexion usando los valores de repositorio**/
    public static String StringConexion() {
        ConexionBD con = new ConexionBD();
    	
    	String server=con.leeConfiguracion("servidor");
        String sid=con.leeConfiguracion("sid");
        /*return "jdbc:mysql://"+server+":3306/"+sid;*/
        return "jdbc:mysql://"+server+"/"+sid;
    }
    
    /**lee una propiedad del properties**/
    public String leeConfiguracion(String propiedad) {
        Properties properties = new Properties();
        String res="";
        try{
        	//Cogemos el inputStream --> Especificando la carpeta y el nombre.  
        	InputStream inputStream = this.getClass().getClassLoader().getResourceAsStream("configuracion.properties");
        	//cargamos el inputStream usando el Properties  
        	properties.load(inputStream);  
        	//insertamos el valor de la propiedad  
        	res = properties.getProperty(propiedad);
        	  
            //File file=new File("C:\\ProySpring\\.metadata\\.plugins\\org.eclipse.wst.server.core\\tmp0\\wtpwebapps\\GestionAlmacen\\WEB-INF\\classes\\configuracion.properties");
            //FileInputStream fis=new FileInputStream(file);
            //pr.load(fis);
            //res=pr.getProperty(propiedad);
            //fis.close();
        }catch(Exception e){
	        	System.out.println("Se ha producido un error al intentar abrir configuracion.properties");
	        	e.printStackTrace();
        	}
        if(res==null)
            res="";
        return res;
    }
    
    /**escribe un propiedad en el properties**/
    public static boolean escribeConfiguracion(String propiedad, String valor) {
        Properties pr=new Properties();
        boolean res=true;
        try{
            File file=new File("configuracion.properties");
            
            if(!file.exists())
                file.createNewFile();
            
            FileOutputStream fos=new FileOutputStream(file);
            FileInputStream fis=new FileInputStream(file);
            pr.load(fis);
            
            pr.setProperty(propiedad,valor);
            
            pr.store(fos,"");
            fis.close();
            fos.close();
        }catch(Exception e){res=false;}
        
        return res;
    }
    
    /**Escribe un array de propiedas, con su array de valores**/
    public static boolean escribeConfiguracion(String [] propiedad, String [] valor) {
        Properties pr=new Properties();
        boolean res=true;
        try{
            File file=new File("configuracion.properties");
            
            if(!file.exists())
                file.createNewFile();
            
            FileOutputStream fos=new FileOutputStream(file);
            FileInputStream fis=new FileInputStream(file);
            pr.load(fis);
            
            for(int i=0; i<propiedad.length; i++) {
                pr.setProperty(propiedad[i],valor[i]);
            }
            
            pr.store(fos,"");
            fis.close();
            fos.close();
        }catch(Exception e){res=false;}
        
        return res;
    }
    
    public static void rollbackConecction(Connection con) {
        try {
            con.rollback();
        } catch (Exception e) {
            ;
        }
    }
}
