/**
 * 
 */
package es.postigo.utility;

import java.io.LineNumberReader;
import java.util.HashMap;
import java.util.StringTokenizer;

import net.sf.jasperreports.engine.JRDataSource;
import net.sf.jasperreports.engine.JREmptyDataSource;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JRField;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.engine.util.JRLoader;

import es.postigo.dto.Informe;

/**
 * @author informatica4
 *
 */
public class GenerarPDF implements JRDataSource{
	
	String row = "";
	LineNumberReader lineNumberReader;
	
	public GenerarPDF() throws Exception{
		System.out.println("new GenerarPDF");
	}

	public byte[] generarInforme(Informe informe){
		byte[] pdf = null;
		String rutaInforme = "es/postigo/reports/reportePruebas.jasper";
		
		HashMap<String, Informe> parametros = new HashMap<String, Informe>();
		parametros.put("informe", informe);
		
		try{
			JasperReport masterReport = (JasperReport) JRLoader.loadObject(this.getClass().getResource(rutaInforme));
			pdf = JasperRunManager.runReportToPdf(masterReport, parametros, new JREmptyDataSource());
			
		}catch(Exception e){
			e.printStackTrace();
		}
		return pdf;
	}

	public Object getFieldValue(JRField jRField) throws JRException {
		String field = jRField.getName();
		int fieldPosition = Integer.parseInt(field.substring(7)); // Strip COLUMN_ 
		StringTokenizer st = new StringTokenizer(row,";");
		while (st.hasMoreTokens())
		{
			fieldPosition--; // The column is not 0 indexed.
			String token = st.nextToken();
			if (fieldPosition == 0) return token;
		}
		return null; // Column not found...		
	}

	public boolean next() throws JRException {
		try {
			row = lineNumberReader.readLine();
			if (row.length()>0) return true;
		}catch (Exception e) {
			e.printStackTrace();
		}			
		return false;
	}
}
