/**
 * 
 */
package es.postigo.utility;

/**
 * @author informatica4
 *
 */
public class StringUtils {
	
	/**
	 * Codifica una cadena para poder ser utilizada dentro de HTML.
	 * @param s cadena a codificar.
	 * @return Cadena codificada en HTML.
	 */
	public static String HTMLEntityEncode(String s) {
		if (s == null || s.length() == 0)
			return s;
		
		StringBuffer buf = new StringBuffer();
		int len = (s == null ? -1 : s.length());

		for (int i = 0; i < len; i++) {
			char c = s.charAt(i);
			if (c >= 'a' && c <= 'z' || c >= 'A' && c <= 'Z' || c >= '0' && c <= '9' || c == ' ') {
				buf.append(c);
			} else {
				if (c == '<') 
					buf.append("&lt;");
				else if (c == '>') 
					buf.append("&gt;");
				else if (c == '\'')
					buf.append(c);
				else
					buf.append("&#" + (int) c + ";");
			}
		}
		return buf.toString();
	}
	
	
	/* remove leading whitespace */
    public static String ltrim(String source) {
        return source.replaceAll("^\\s+", "");
    }

    /* remove trailing whitespace */
    public static String rtrim(String source) {
        return source.replaceAll("\\s+$", "");
    }

    /* replace multiple whitespaces between words with single blank */
    public static String itrim(String source) {
        return source.replaceAll("\\b\\s{2,}\\b", " ");
    }

    /* remove all superfluous whitespaces in source string */
    public static String trim(String source) {
        return itrim(ltrim(rtrim(source)));
    }

    public static String lrtrim(String source){
        return ltrim(rtrim(source));
    }

}
