/**
 * 
 */
package es.postigo.xml;

/**
 * @author informatica4
 *
 */
import java.io.Serializable;

import es.postigo.utility.StringUtils;

/**
 * El Class AtributoXML.
 */
public class AtributoXML implements Serializable {

	/** La constante serialVersionUID. */
	private static final long serialVersionUID = 1L;
	
	/** El nombre. */
	private String nombre;
	
	/** El valor. */
	private String valor;

	/**
	 * Instancia un nuevo atributo xml.
	 * 
	 * @param pStrNombre
	 *            el string Nombre
	 * @param pStrValor
	 *            el string Valor
	 */
	public AtributoXML(String pStrNombre, String pStrValor) {
		ContractualVerifier.EnsureExistence(pStrNombre);
		this.nombre = pStrNombre;
		this.valor = pStrValor;
	}

	/**
	 * @return the nombre
	 */
	public String getNombre() {

		return nombre;
	}

	/**
	 * @param nombre
	 *            the nombre to set
	 */
	public void setNombre(String nombre) {
		ContractualVerifier.EnsureExistence(nombre);
		this.nombre = nombre;
	}

	/**
	 * @return the valor
	 */
	public String getValor() {

		return valor;
	}

	/**
	 * @param valor
	 *            the valor to set
	 */
	public void setValor(String valor) {

		this.valor = valor;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return nombre + "=\"" + StringUtils.HTMLEntityEncode(valor) + "\"";		
	}
}
